﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;

        int n = s.size();
        for (int i = 0; i < n; ++i) {
            if (k <= 0) break;
            char min_char = s[i];
            int min_pos = i;
            for (int j = i + 1; j < n && j <= i + k; ++j) {
                if (s[j] < min_char) {
                    min_char = s[j];
                    min_pos = j;
                }
            }
            if (min_pos != i) {
                long long moves = min_pos - i;
                if (moves <= k) {
                    for (int j = min_pos; j > i; --j) {
                        swap(s[j], s[j - 1]);
                    }
                    k -= moves;
                }
            }
        }

        cout << s << endl; 
    }

    return 0;
}
