#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

int main() {
    int numberOfPoints;
    std::cin >> numberOfPoints;

    std::vector<std::vector<int>> points(numberOfPoints, std::vector<int>(2));
    for (int i = 0; i < numberOfPoints; ++i) {
        for (int j = 0; j < 2; ++j) {
            std::cin >> points[i][j];
        }
    }

    int secondPointX = points[1][0];
    int firstPointX = points[0][0];
    int thirdPointY = points[2][1];
    int firstPointY = points[0][1];
    int thirdPointX = points[2][0];
    int secondPointY = points[1][1];

    double sideA = std::sqrt(std::pow(secondPointX - firstPointX, 2) + std::pow(secondPointY - firstPointY, 2));
    double sideB = std::sqrt(std::pow(thirdPointX - secondPointX, 2) + std::pow(thirdPointY - secondPointY, 2));
    double sideC = std::sqrt(std::pow(firstPointX - thirdPointX, 2) + std::pow(firstPointY - thirdPointY, 2));

    std::vector<int> secondColumn;
    for (const auto& point : points) {
        secondColumn.push_back(point[1]);
    }

    if (sideA + sideB > sideC && sideA + sideC > sideB && sideB + sideC > sideA && std::count(secondColumn.begin(), secondColumn.end(), 0) >= 2) {
        std::cout << std::abs(0.5 * ((secondPointX - firstPointX) * (thirdPointY - firstPointY) - ((thirdPointX - firstPointX) * (secondPointY - firstPointY)))) << std::endl;
    } else {
        std::cout << 0 << std::endl;
    }

    return 0;
}
