def max_triangle_area(points): 
    max_area = 0 
    points_on_x_axis = [p for p in points if p[1] == 0] 
    points_above_x_axis = [p for p in points if p[1] > 0] 
    points_below_x_axis = [p for p in points if p[1] < 0] 
 
    if len(points_on_x_axis) < 2 or (not points_above_x_axis and not points_below_x_axis): 
        return 0.0 
 
    min_x = min(p[0] for p in points_on_x_axis) 
    max_x = max(p[0] for p in points_on_x_axis) 
 
    if points_above_x_axis: 
        max_y_above = max(p[1] for p in points_above_x_axis) 
        max_area = max(max_area, 0.5 * (max_x - min_x) * max_y_above) 
 
    if points_below_x_axis: 
        min_y_below = min(p[1] for p in points_below_x_axis) 
        max_area = max(max_area, 0.5 * (max_x - min_x) * abs(min_y_below)) 
 
    return max_area 
 
n = int(input().strip())   
points = [tuple(map(int, input().strip().split())) for _ in range(n)]   
 
print(f"{max_triangle_area(points):.9f}")
 
return max_area 
 
n = int(input().strip()) 
points = [tuple(map(int, input().strip().split())) for _ in range(n)] 
 
print(f"{max_triangle_area(points):.9f}")