Mod = 998244353 
 
def can_arrange(r, g, b, n): 
    return max(r, g, b) <= (n + 1) // 2 
 
def count_ways(r, g, b): 
    dp = {} 
     
    def dp_count(r, g, b, last_color): 
        if r == 0 and g == 0 and b == 0: 
            return 1 
         
        if (r, g, b, last_color) in dp: 
            return dp[(r, g, b, last_color)] 
         
        ways = 0 
        if last_color != 'R' and r > 0: 
            ways += dp_count(r - 1, g, b, 'R') 
        if last_color != 'G' and g > 0: 
            ways += dp_count(r, g - 1, b, 'G') 
        if last_color != 'B' and b > 0: 
            ways += dp_count(r, g, b - 1, 'B') 
         
        dp[(r, g, b, last_color)] = ways % Mod 
        return dp[(r, g, b, last_color)] 
     
    return (dp_count(r - 1, g, b, 'R') + dp_count(r, g - 1, b, 'G') + dp_count(r, g, b - 1, 'B')) % Mod 
 
r, g, b = map(int, input().split()) 
n = r + g + b 
 
if not can_arrange(r, g, b, n): 
    print(0) 
else: 
    result = count_ways(r, g, b) 
    print(result)