from math import factorial

def solve():
    
    MOD = 998244353
    
    r, g, b = map(int, input().split())
    
    counts = sorted([r, g, b], reverse=True)
    r, g, b = counts[0], counts[1], counts[2]
    
    if r > g + b + 1:
        print(0)
        return
    
    ans = r + g + b
    ways = factorial(ans) % MOD
    ways = (ways * pow(factorial(r), MOD - 2, MOD)) % MOD
    ways = (ways * pow(factorial(g), MOD - 2, MOD)) % MOD
    ways = (ways * pow(factorial(b), MOD - 2, MOD)) % MOD
    
    print(ways)

solve()
