def main():
    n = int(input())
    piles = list(map(int, input().split()))
    
    piles.sort()
    
    max_sequence = 1
    current_sequence = 1
    
    for i in range(1, n):
        if piles[i] == piles[i-1]:
            current_sequence += 1
            max_sequence = max(max_sequence, current_sequence)
        else:
            current_sequence = 1
            
    print("Dmitry" if max_sequence > n//2 else "Alice")



if __name__ == "__main__":
    main()