def minimize_number(s, k):
    num = int(s)
    length = len(s)

    for i in range(length):
        if k <= 0:
            break

        current_digit = (num // (10 ** (length - 1 - i))) % 10

        min_digit = current_digit
        min_index = i

        for j in range(i + 1, min(length, i + k + 1)):
            next_digit = (num // (10 ** (length - 1 - j))) % 10
            if next_digit < min_digit and not (i == 0 and next_digit == 0):
                min_digit = next_digit
                min_index = j

        if min_index != i:
            steps_needed = min_index - i
            if steps_needed <= k:
                for pos in range(min_index, i, -1):
                    digit_to_move = (num // (10 ** (length - 1 - pos))) % 10
                    digit_before = (num // (10 ** (length - 1 - (pos - 1)))) % 10

                    num -= digit_to_move * (10 ** (length - 1 - pos))
                    num += digit_to_move * (10 ** (length - 1 - (pos - 1)))
                    num -= digit_before * (10 ** (length - 1 - (pos - 1)))
                    num += digit_before * (10 ** (length - 1 - pos))

                k -= steps_needed

    return num

t = int(input())
answers = []

for _ in range(t):
    s, k = input().split()
    answers.append(minimize_number(s, int(k)))

print("\n".join(map(str, answers)))