﻿#include <iostream>
#include <vector>
using namespace std;

string is_wooden_matrix(const vector<vector<int>>& matrix, int n) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                if (matrix[i][j] > matrix[i][k] + matrix[k][j]) {
                    return "No";
                }
            }
        }
    }
    return "Yes";
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> matrix(n, vector<int>(n));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matrix[i][j];
        }
    }

    cout << is_wooden_matrix(matrix, n) << endl;
    return 0;
}
