def create_program_map(n, programs):
    # Создаем список из 26 точек
    alphabet_map = ['.'] * 26

    # Заполняем список буквами, если есть программы, начинающиеся с этой буквы
    for program in programs:
        first_letter = program[0]
        index = ord(first_letter) - ord('a')
        alphabet_map[index] = first_letter

    # Формируем выходную таблицу
    result = []
    for i in range(0, 26, 6):
        result.append(''.join(alphabet_map[i:i + 6]))

    return result


# Считываем входные данные
n = int(input())
programs = [input().strip() for _ in range(n)]

# Получаем карту программ
program_map = create_program_map(n, programs)

# Выводим результат
for line in program_map:
    print(line)