import itertools

def is_valid(arrangement):
    for i in range(1, len(arrangement)):
        if arrangement[i] == arrangement[i - 1]:
            return False
    return True
def count_valid_arrangements(colors):
    all_permutations = set(itertools.permutations(colors))
    valid_arrangements = ["".join(p) for p in all_permutations if is_valid(p)]

    return valid_arrangements

r,g,b=map(int, input().split())
colors = ["R"]*r + ["B"]*b + ["G"]*g
valid_arrangements = count_valid_arrangements(colors)
print(len(valid_arrangements))

