#include <iostream>
#include <sstream>
#include <string>

int main() {
  int n, m;
  std::cin >> n >> m;
  bool isValid = true;

  std::cin.ignore();
  for (int i = 0; i < n; i++) {
    std::string line;
    std::getline(std::cin, line);

    std::istringstream stream(line);
    std::string cell;
    int count = 0;

    while (stream >> cell) {
      for (auto &c : cell)
        c = toupper(c);
      if (cell == "A") {
        count++;
      }
    }
    if (count != 1) {
      isValid = false;
      break;
    }
  }

  std::cout << (isValid ? "Yes" : "No") << std::endl;
  return 0;
}
