#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <utility>
#include <vector>

int main() {
  int n;
  std::cin >> n;
  std::vector<std::pair<int, int>> points;
  std::vector<std::pair<int, int>> oX;
  for (int i = 0; i < n; i++) {
    int x, y;
    std::cin >> x >> y;
    if (y == 0)
      oX.push_back({x, y});
    else
      points.push_back({x, y});
  }
  if (oX.size() < 2) {
    std::cout << 0;
    return 0;
  }
  std::sort(oX.begin(), oX.end(),
            [](std::pair<int, int> a, std::pair<int, int> b) {
            return a.first < b.first;
            });
  std::sort(points.begin(), points.end(),
            [](std::pair<int, int> a, std::pair<int, int> b) {
            return abs(a.second) < (b.second);
            });
  auto left_point = oX.front(), right_point = oX.back();
  auto max_ox = points.back();

  long long int base = abs(left_point.first - right_point.first);
  double area = base * abs(max_ox.second) / 2.0;
  std::cout << area << std::endl;
  return 0;
}
