﻿#include <iostream>
#include <vector>
#include <string>

using namespace std;

bool isRACIValid(int n, int m, vector<vector<char>>& matrix) {
	for (int i = 0; i < n; ++i) {
		bool hasA = false;
		bool hasR = false;

		for (int j = 0; j < m; ++j) {
			if (matrix[i][j] == 'A') {
				if (hasA) return false;
				hasA = true;
			}
			else if (matrix[i][j] == 'R') {
				hasR = true;
			}
		}

		if (!hasA) return false;
		if (!hasR && !hasA) return false;
	}

	return true;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector<vector<char>> matrix(n, vector<char>(m));

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> matrix[i][j];
		}
	}

	if (isRACIValid(n, m, matrix)) {
		cout << "Yes" << endl;
	}
	else {
		cout << "No" << endl;
	}

	return 0;
}
