﻿#include <iostream>
#include <string>
#include <algorithm>

using namespace std;


inline int min_index(const string& s, int start, int end) {
    int minPos = start;
    for (int j = start + 1; j <= end; ++j) {
        if (s[j] < s[minPos]) {
            minPos = j;
        }
    }
    return minPos;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        int n = s.size();

        for (int i = 0; i < n && k > 0; ++i) {

            int limit = min(i + static_cast<int>(k), n - 1);
            int minPos = min_index(s, i, limit);

            if (minPos != i) {

                long long swapsNeeded = minPos - i;

                if (swapsNeeded <= k) {

                    for (int j = minPos; j > i; --j) {
                        swap(s[j], s[j - 1]);
                    }

                    k -= swapsNeeded;
                }
                else {

                    break;
                }
            }
        }
        cout << s << '\n'; 
    }

    return 0;
}
