﻿#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<vector<long long>> dist(n, vector<long long>(n));

    // Считываем матрицу расстояний
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> dist[i][j];
        }
    }

    // Проверка на выполнение свойств дерева
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            if (i == k) continue;  // пропускаем диагональные элементы
            for (int j = 0; j < n; ++j) {
                if (j == k || i == j) continue;  // пропускаем диагональные и повторные элементы
                // Если выполняется неравенство, значит матрица не является деревянной
                if (dist[i][j] > dist[i][k] + dist[k][j]) {
                    cout << "No" << endl;
                    return 0;
                }
            }
        }
    }

    cout << "Yes" << endl;
    return 0;
}
