﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

int main() {
    vector<long long> ox;
    vector<long long> oy;
    long long n;
    cin >> n;
    for (long long i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if (y == 0) {
            ox.push_back(x);
        }
        else {
            oy.push_back(abs(y));
        }
    }
    if (ox.size() < 2 || oy.size() < 1) {
        cout << 0;
        return 0;
    }
    long long x_min = *min_element(ox.begin(), ox.end());
    long long x_max = *max_element(ox.begin(), ox.end());
    long long base_length = abs(x_max - x_min);
    long long max_height = *max_element(oy.begin(), oy.end());
    double area = 0.5 * base_length * max_height;
    cout << area << endl;

    return 0;
}