#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <string>

int main() {
	int d1, d2;
	std::map<int, int> ptoi = {
		{0b1110111, 0},
		{0b0010010, 1},
		{0b1011101, 2},
		{0b1011011, 3},
		{0b0111010, 4},
		{0b1101011, 5},
		{0b1101111, 6},
		{0b1010010, 7},
		{0b1111111, 8},
		{0b1111011, 9}
	};
	std::map<int, int> itop = {
		{0, 0b1110111},
		{1, 0b0010010},
		{2, 0b1011101},
		{3, 0b1011011},
		{4, 0b0111010},
		{5, 0b1101011},
		{6, 0b1101111},
		{7, 0b1010010},
		{8, 0b1111111},
		{9, 0b1111011}
	};
	std::string t;
	std::cin >> t;
	d1 = strtol(t.c_str(), NULL, 2);
	std::cin >> t;
	d2 = strtol(t.c_str(), NULL, 2);

	int prev = -10;
	int k = 0;
	int maxk = 0;
	for (int i = 9; i >= 0; i--) {
		for (int j = 9; j >= 0; j--) {
			int a1, a2;
			if (i != 0) {
				a1 = itop[i] & d1;
				a2 = itop[j] & d2;
				if (ptoi.count(a1) > 0 and ptoi.count(a2) > 0) {
					a1 = ptoi[a1];
					a2 = ptoi[a2];
				}
				else {
					prev = -10;
					if (k > maxk) {
						maxk = k;
					}
					k = 0;
					continue;
				}
			}
			else {
				a1 = 0;
				a2 = itop[j] & d2;
				if (ptoi.count(a2) > 0) {
					a2 = ptoi[a2];
				}
				else {
					prev = -10;
					if (k > maxk) {
						maxk = k;
					}
					k = 0;
					continue;
				}
			}

			int a = a1 * 10 + a2;
			if (a - prev == 1) {
				k += 1;
				prev = a;
			} 
			else {
				if (k > maxk) {
					maxk = k;
				}
				prev = a;
				k = 0;

			}

		}
	}
	std::cout << maxk << std::endl;

}