import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int[][] points = new int[n][2];
        int index = n;
        while(index > 0){
            points[index - 1][0] = scanner.nextInt();
            points[index - 1][1] = scanner.nextInt();
            index--;
        }
        System.out.println(maxTriangleArea(n, points));
    }

    private static double maxTriangleArea(int n, int[][] points){
        double maxArea = 0;
        for(int i = 0; i < n; i++){
            for(int j = i+1; j < n; j++){
                for(int k = j+1; k < n; k++){
                    int x = points[i][0];
                    int y = points[i][1];
                    int x1 = points[j][0];
                    int y1 = points[j][1];
                    int x2 = points[k][0];
                    int y2 = points[k][1];
                    double current = (double) (x * (y1 - y2) + x1 * (y2 - y) + x2 * (y - y1)) / 2f;
                    maxArea = Math.max(maxArea, current);
                }
            }
        }
        return maxArea;
    }
}