#include "bits/stdc++.h"

using namespace std;
using ll = long long;


struct D_o
{
    int n;
    vector<ll> vec;

    vector<ll> t;

    D_o(vector<ll> v)
    {
        vec = v;
        n = vec.size();

        t.resize(4 * n);

        build(0, 0, n);
    }

    void build(int v, int tl, int tr)
    {
        if(tl + 1 == tr)
        {
            t[v] = vec[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm);
        build(2 * v + 2, tm, tr);
        t[v] = __gcd(t[2 * v + 1], t[2 * v + 2]);
    }


    ll get(int v, int tl, int tr, int l, int r)
    {
        if(r <= tl || tr <= l)
        {
            return 0;
        }
        if(l <= tl && tr <= r)
        {
            return t[v];
        }
        int tm = (tl + tr) / 2;
        return  __gcd(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm, tr, l, r));
    }

};

int main() {
    int n; cin >> n;

    vector<ll> v(n);
    for(int i = 0; i < n; ++i)
    {
        cin >> v[i];
    }

    int l, r;
    cin >> l >> r;
    --l;
    --r;
    bool fl = false;
    if(l > r)
    {
        swap(l, r);
        fl = true;
    }

    vector<ll> raz;
    for(int i = l; i < r; ++i)
    {
        raz.push_back(abs(v[i] - v[i + 1]));
    }



    D_o gg(raz);
    vector<pair<ll, ll>> nxt(n);

    for(int i = l; i < r; ++i)
    {
        int L = 0;
        int R = gg.n  - (i - l) + 1;

        while(R - L > 1)
        {
            int m = (L + R) / 2;
            if(gg.get(0, 0, gg.n, i - l, i - l + m) != 1)
            {
                L = m;
            } else {
                R = m;
            }
        }

        nxt[i] = {i + L, gg.get(0, 0, gg.n, i - l, i - l + L)};
    }

    int pos = l;
    vector<vector<ll>> ans;
    while(pos != r)
    {
        int n_pos = nxt[pos].first;
        if(n_pos > r)
        {
            n_pos = r;
        }
        ans.push_back({nxt[pos].second, pos, n_pos});
        if(n_pos == pos)
        {
            cout << "impossible\n";
            return 0;
        }
        pos = n_pos;
    }

    if(fl)
    {
        reverse(ans.begin(), ans.end());
    }
    for(auto i : ans)
    {
        if(i[0] == 0)
        {
            i[0] = 239;
        }

        if(fl)
        {
            cout << "kaban-" << i[0] << ' ' << i[2] + 1 << ' ' << i[1] + 1 << '\n';
        } else {
            cout << "kaban-" << i[0] << ' ' << i[1] + 1 << ' ' << i[2] + 1 << '\n';
        }
    }


}