// icpc-2024.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//


#include <iostream>
#include <vector>
#include <array>

using namespace std;

using ll = long long;

using digit = array<bool, 7>;

digit op(digit a, digit b) {
    digit ans = a;

    for (int i = 0; i < 7; ++i)
        ans[i] = ans[i] && b[i];

    return ans;
}

vector<digit> dgts {
        { 1, 1, 1, 0, 1, 1, 1 },
        { 0, 0, 1, 0, 0, 1, 0 },
        { 1, 0, 1, 1, 1, 0, 1 },
        { 1, 0, 1, 1, 0, 1, 1 },
        { 0, 1, 1, 1, 0, 1, 1 },
        { 1, 1, 0, 1, 0, 1, 1 },
        { 1, 1, 0, 1, 1, 1, 1 },
        { 1, 0, 1, 0, 0, 1, 0 },
        { 1, 1, 1, 1, 1, 1, 1 },
        { 1, 1, 1, 1, 0, 1, 1 },
        { 0, 0, 0, 0, 0, 0, 0 }
};

ll dgt(digit d) {
    auto it = find(dgts.begin(), dgts.end(), d);

    if (it == dgts.end())
        return -2;
    if (it == dgts.end() - 1)
        return -1;
    return it - dgts.begin();
}

int main()
{
    digit msk1{ 0, 0, 0, 0, 0, 0, 0 }, msk2{ 0, 0, 0, 0, 0, 0, 0 };
    for (int i = 0; i < 7; ++i) {
        char c;
        cin >> c;
        msk1[i] = (c == '1');
    }
    for (int i = 0; i < 7; ++i) {
        char c;
        cin >> c;
        msk2[i] = (c == '1');
    }

    ll last = -2;
    ll strk = 0;
    ll mxstrk = 0;

    for (int i = 99; i >= 10; --i) {
        digit first = op(dgts[i / 10], msk1);
        digit second = op(dgts[1 % 10], msk2);

        ll cur = 0;

        if (dgt(first) == -2 || dgt(second) < 0) {
            mxstrk = max(mxstrk, strk);
            last = -2;
            strk = 0;
            continue;
        }

        if (dgt(first) == -1) {
            cur = dgt(second);
        }
        else {
            if (dgt(first) == 0) {
                mxstrk = max(mxstrk, strk);
                last = -2;
                strk = 0;
                continue;
            }

            cur = dgt(first) * 10 + dgt(second);
        }

        if (cur == last + 1)
            strk + 1;
        else {
            mxstrk = max(mxstrk, strk);
            strk = 1;
        }

        last = cur;
    }

    mxstrk = max(mxstrk, strk);

    for (int i = 9; i >= 1; --i) {
        digit second = op(dgts[i], msk2);

        if (dgt(second) < 0) {
            mxstrk = max(mxstrk, strk);
            last = -2;
            strk = 0;
            continue;
        }

        ll cur = dgt(second);

        if (cur == last + 1) {
            strk += 1;
        }
        else {
            strk = 1;
        }

        last = cur;
    }

    mxstrk = max(mxstrk, strk);

    cout << max(mxstrk - 1, 0ll) << "\n";
}
