#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define len(a) (int)a.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll rng(ll l, ll r) { return uniform_int_distribution<ll>(l, r)(rnd); }

const int INF = 1e9 + 7;

void sol() {
    int n;
    cin >> n;
    vector<pair<ll, ll>> p(n);
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        p[i] = {x, y};
    }
    ll minx = 1e18;
    for (int i = 0; i < n; ++i) {
        if (p[i].second == 0) {
            minx = min(minx, p[i].first);
        }
    }
    ll maxx = -1e18;
    for (int i = 0; i < n; ++i) {
        if (p[i].second == 0) {
            maxx = max(maxx, p[i].first);
        }
    }
    ll maxy = 0;
    for (int i = 0; i < n; ++i) {
            maxy = max(maxy, abs(p[i].second));
    }
    if (minx == 1e18) {
        cout << 0 << endl;
    } else {

        cout << (maxx - minx) * maxy * 0.5 << endl;
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    sol();
    return (0 - 0); // <3
}
