#include <bits/stdc++.h>
#include <cstdio>

#define print_lst_1x(lst) for (auto el: lst){cout << el << ' ';} cout << endl;
#define print_lst_2x(lst) for (auto el: lst){for (auto zn: el) {cout << zn << ' ';} cout << '\n';} cout << endl;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef std::vector<int> vi;
typedef std::vector<ll> vll;
typedef std::vector<std::vector<int>> vvi;
typedef std::pair<int, int> pii;


using namespace std;

template <typename Ty>
istream& operator>>(istream& is, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        is >> arr[i];
    }
    return is;
}

template <typename Ty>
istream& operator>>(istream& is, std::pair<Ty, Ty>& arr){
    is >> arr.first>>arr.second;
    return is;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<Ty>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i] << " ";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os, std::vector<std::vector<Ty>>& arr){
    for(int i = 0; i < arr.size();  i++ ){
        os << arr[i]<< "\n";
    }
    return os;
}

template <typename Ty>
ostream& operator<<(ostream& os,std::pair<Ty,Ty>& arr){
        os << arr.first<<" "<<arr.second;
    return os;
}

//   
/*
int solve_q(){
    int n;
    scanf("%d", &n);
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        printf("%d\n", m);
        fflush(stdout);
        int ans;
        scanf("%d", &ans);
        if (ans == 0) {
            return 0;
        }
        if (ans == 1)
            l = m;
        else r = m;
    }
    return 0;
}
 */

//#include "solve_func.hpp"

void solve_cc() {
    ll n; cin>>n;
    vector<vector<ll>> cor(n, vll(2));
    cin>>cor;
    ll max_l=1e9, max_r = -1e9;
    double h = 0;
    for(int i = 0; i < n; i ++){
        if (cor[i][1] == 0){
            max_l = std::min(max_l, cor[i][0]);
            max_r = std::max(max_r, cor[i][0]);
        }
        h = max(h, (double)abs(cor[i][1]));
    }
    double s = 1/2.0*(max_r - max_l)*h;
    if (max_l == 1e9 || max_r == -1e9) s = 0;
    cout<<s;
}
int main(){
    solve_cc();
    return 0;
}