#pragma GCC optimize("Ofast")
#include <iostream>
#include <cmath>
#include <cstdint>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <functional>
#include <queue>
#include <fstream>
#include <random>
//#include <numbers>
#include <optional>
#include <deque>
#include <sstream>
#include <list>
#include <chrono>
#include <thread>

using namespace std;
using i64 = int64_t;
using ui64 = uint64_t;

#define YN(b) if (b) cout << "Yes\n"; else cout << "No\n";

template<typename T>
istream& operator>>(istream& is, vector<T>& v) { for (auto &e: v) { is >> e; } return is; }

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) { for (auto &e: v) { os << e << " "; } return os; }

template<typename T, typename V>
istream& operator>>(istream& is, pair<T, V>& v) { return is >> v.first >> v.second; }

template<typename T, typename V>
ostream& operator<<(ostream& os, pair<T, V>& v) { return os << v.first << " " << v.second; }

const int64_t md = 1e9+7;

int64_t binpow(int64_t a, int64_t b, int64_t mod = md) {
    int64_t r = 1;
    while (b) {
        if (b & 1) r = ((__int128_t)r * a) % mod;
        a = ((__int128_t)a * a) % mod;
        b >>= 1;
    }
    return r;
}

int dx[4] = {-1, 0, 1, 0};

inline int64_t sqr(int64_t x) {
    return x * x;
}

inline int popcount(int64_t x) {
    int c = 0;
    while (x) c += x & 1, x >>= 1;
    return c;
}

optional<int> dp[64][64][64][64][2];
char was[64][64][64][64][2];

vector<pair<char, char>> kor = {{-1, -1}, {-1, 0}, {-1, 1}, {0, 1}, {0, -1}, {1, 1}, {1, 0}, {1, -1}};
vector<pair<char, char>> wiz = {{0, -1}, {-1, 0}, {1, 0}, {0, 1}};
vector<pair<char, char>> cam = {{-1, -3}, {1, -3}, {-3, -1}, {3, -1}, {-3, 1}, {3, 1}, {-1, 3}, {1, 3}};
pair<char, char> get(char x) {
    return {x >> 3, x & 7};
}

int to(char x, char y) {
    return (x << 3) + y;
}

vector<vector<pair<char, char>>> hod = {kor, wiz, cam};
char avail[8][8];

void fill(char pos, int type) {
    auto p = get(pos);
    avail[p.first][p.second] = 1;
    for (auto &e: hod[type]) {
        int ni = p.first + e.first;
        int nj = p.second + e.second;
        if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
        avail[ni][nj] = 1;
    }
}

optional<int> rec(char b_kor, char w_kor, char w_cam, char w_wiz, char turn) {
    if (was[b_kor][w_kor][w_cam][w_wiz][turn]) {
        return std::nullopt;
    }
    if (dp[b_kor][w_kor][w_cam][w_wiz][turn]) {
        return *dp[b_kor][w_kor][w_cam][w_wiz][turn];
    }
    was[b_kor][w_kor][w_cam][w_wiz][turn] = 1;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            avail[i][j] = 0;
        }
    }
    if (turn == 0) {
        fill(w_kor, 0);
        fill(w_wiz, 1);dassadas
        fill(w_cam, 2);
        auto kor_p = get(b_kor);
        bool shah = avail[kor_p.first][kor_p.second];
        vector<char> available;
        for (auto &e: hod[0]) {
            char ni = kor_p.first + e.first;
            char nj = kor_p.second + e.second;
            if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
            if (avail[ni][nj]) {
                continue;
            }
            available.emplace_back(to(ni, nj));
        }
        if (shah && available.empty()) {
            was[b_kor][w_kor][w_cam][w_wiz][turn] = 0;
            return *(dp[b_kor][w_kor][w_cam][w_wiz][turn] = 0);
        }
        if (available.empty()) {
            was[b_kor][w_kor][w_cam][w_wiz][turn] = 0;
            return *(dp[b_kor][w_kor][w_cam][w_wiz][turn] = 1e9);
        }
        optional<int> ans;
        for (auto &e: available) {
            auto r = rec(e, w_kor, w_cam, w_wiz, 1);
            if (r && (!ans || *r < *ans)) {
                ans = r;
            }
        }
        was[b_kor][w_kor][w_cam][w_wiz][turn] = 0;
        return *(dp[b_kor][w_kor][w_cam][w_wiz][turn] = ans);
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

}
