///bs:-input,console
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;

const int MOD = 998244353;

int add(int x, int y) {
	return x + y >= MOD ? x + y - MOD : x + y;
}

int mul(int x, int y) {
	return int(1ll * x * y % MOD);
}

int deg(int x, int y) {
	int res = 1;
	for (int z = x; y; y >>= 1, z = mul(z, z)) {
		if (y & 1) {
			res = mul(res, z);
		}
	}
	return res;
}

int inv(int x) {
	return deg(x, MOD - 2);
}

const int MAX_N = 5e5 + 5;

int fact[MAX_N];
int rfact[MAX_N];
int deg2[MAX_N];

int getC(int n, int k) {
	if (n < k) return 0;
	return mul(fact[n], mul(rfact[k], rfact[n - k]));
}

void solve() {
    fact[0] = 1;
    for (int i = 1; i < MAX_N; ++i) {
    	fact[i] = mul(fact[i - 1], i);
    }
    rfact[MAX_N - 1] = inv(fact[MAX_N - 1]);
    for (int i = MAX_N - 2; i >= 0; --i) {
    	rfact[i] = mul(rfact[i + 1], i + 1);
    }
    deg2[0] = 1;
    for (int i = 1; i < MAX_N; ++i) {
    	deg2[i] = mul(deg2[i - 1], 2);
    }

    int r, g, b;
    cin >> r >> g >> b;

    if (g < r) swap(g, r);

    int ans = 0;
    for (int k = max(1, b - 1); k <= b + 1; ++k) {
    	for (int a = max(0, k - g); a <= min(r, k) && g - r + 2 * a <= k; ++a) {
    		int curr = 0;
    		int A = getC(k, a);
    		int B = getC(k - a, g - r + a);
    		int C = getC(a + g - 1, k - 1);
    		int D = deg2[k - g + r - 2 * a];
    		curr = add(curr, mul(mul(A, B), mul(C, D)));
    		if (k == b) curr = mul(curr, 2);
    		ans = add(ans, curr);
    		//cerr << k << " " << a << " " << curr << endl;
    	}
    	
    }
    cout << ans << "\n";
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
        