#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include "math.h"

using namespace std;

#define int __int128

void solve() {
    long long n, k;
    cin >> n >> k;
    int left = 0;
    int right = n+2;
    if (k * 2ll >= (long long)log2(n)) {
        cout << ceil(log2(n)) << "\n";
        return;
    }
    while (left < right) {
        int med = (left + right) / 2;
        int c = 1;
        int sum = 1;
        for (int i = 1; i <= 2*k; i++) {
            c = c * (med - (i-1)) / (i);
            sum += c;
            if (sum >= n) {
                break;
            }
        }
        if (sum >= n) {
            right = med;
        } else {
            left = med + 1;
        }
    }
    long long ans = left;
    cout << ans << "\n";
}

signed main() {
    int32_t t;
    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}
//
