#include <bits/stdc++.h>

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
  in >> v.first >> v.second;
  return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
  out << v.first << ' ' << v.second;
  return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { in >> v[i]; }
  return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { out << v[i] << ' '; }
  return out;
}

void solve() {
  int n; cin >> n;
  vector<int> a(n); cin >> a;
  ll sum = 0;
  for (int i = 0; i < n; ++i) {
    sum += a[i];
  }
  if (sum % 2 == 1) {
    cout << "Alice";
  } else {
    cout << "Dmitry";
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);
  std::cout.precision(10);
  std::cout.setf(std::ios::fixed);
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
  int t = 1;
  //cin >> t;
  while (t-- > 0) {
    solve();
  }
  return 0;
}
