#include <bits/stdc++.h>

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
  in >> v.first >> v.second;
  return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
  out << v.first << ' ' << v.second;
  return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { in >> v[i]; }
  return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { out << v[i] << ' '; }
  return out;
}



void solve() {
  string s; cin >> s;
  ll k; cin >> k;
  if (k == 0) {
    cout << s << '\n';
    return;
  }
  ll n = s.size();
  set<int> m[10];
  int min_val = 10;
  vector<bool> moved(n, false);
  for (int i = 0; i < n; ++i) {
    m[s[i] - '0'].insert(i);
  }
  string res;
  for (int i = 0; i < n; ++i) {
    min_val = 1;
    bool stop = false;
    auto min_idx = m[min_val].begin();
    while (m[min_val].begin() == m[min_val].end() || *min_idx > k + i) {
      ++min_val;
      min_idx = m[min_val].begin();
      if (min_val == 10) {
        stop = true;
        break;
      }
    }
    moved[*min_idx] = true;
    res += min_val + '0';
    k -= *min_idx - i;
    m[min_val].erase(min_idx);
    if (stop || k == 0) {
      break;
    }
  }
  for (int i = 0; i < n; ++i) {
    if (!moved[i]) {
      res += s[i];
    }
  }
  cout << res << '\n';
}

int main() {
  ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);
  std::cout.precision(10);
  std::cout.setf(std::ios::fixed);
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  int t = 1;
  cin >> t;
  while (t-- > 0) {
    solve();
  }
  return 0;
}
