#include <bits/stdc++.h>

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()

using namespace std;

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
  in >> v.first >> v.second;
  return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
  out << v.first << ' ' << v.second;
  return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { in >> v[i]; }
  return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &v) {
  for (size_t i = 0; i < v.size(); ++i) { out << v[i] << ' '; }
  return out;
}



void solve() {
  int n; cin >> n;
  vector<vector<int>> g(n, vector<int>(n));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      int x; cin >> x;
      g[i][j] = x;
    }
  }
  for (int s = 0; s < n; ++s) {
    vector<int> d(n, INT_MAX);
    d[s] = 0;
    vector<bool> u(n);
    for (int i = 0; i < n; ++i) {
      int v = -1;
      for (int j = 0; j < n; ++j)
        if (!u[j] && (v == -1 || d[j] < d[v]))
          v = j;
      if (d[v] == INT_MAX)
        break;
      u[v] = true;
      for (int j = 0; j < n; ++j) {
        int to = j, len = g[v][j];
        if (d[v] + len < d[to]) {
          d[to] = d[v] + len;
        }
      }
    }
    for (int i = 0; i < n; ++i) {
      if (g[s][i] != d[i]) {
        cout << "NO";
        return;
      }
    }
  }
  cout << "YES";
}

int main() {
  ios_base::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);
  std::cout.precision(10);
  std::cout.setf(std::ios::fixed);
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
  int t = 1;
  //cin >> t;
  while (t-- > 0) {
    solve();
  }
  return 0;
}
