#include <bits/stdc++.h>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2")

using namespace std;

int main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    vector<unsigned short> d(10);
    d[0] = (1 << 6) + (1 << 5) + (1 << 4) + (0 << 3) + (1 << 2) + (1 << 1) + (1 << 0);
    d[1] = (0 << 6) + (0 << 5) + (1 << 4) + (0 << 3) + (0 << 2) + (1 << 1) + (0 << 0);
    d[2] = (1 << 6) + (0 << 5) + (1 << 4) + (1 << 3) + (1 << 2) + (0 << 1) + (1 << 0);
    d[3] = (1 << 6) + (0 << 5) + (1 << 4) + (1 << 3) + (0 << 2) + (1 << 1) + (1 << 0);
    d[4] = (0 << 6) + (1 << 5) + (1 << 4) + (1 << 3) + (0 << 2) + (1 << 1) + (0 << 0);
    d[5] = (1 << 6) + (1 << 5) + (0 << 4) + (1 << 3) + (0 << 2) + (1 << 1) + (1 << 0);
    d[6] = (1 << 6) + (1 << 5) + (0 << 4) + (1 << 3) + (1 << 2) + (1 << 1) + (1 << 0);
    d[7] = (1 << 6) + (0 << 5) + (1 << 4) + (0 << 3) + (0 << 2) + (1 << 1) + (0 << 0);
    d[8] = (1 << 6) + (1 << 5) + (1 << 4) + (1 << 3) + (1 << 2) + (1 << 1) + (1 << 0);
    d[9] = (1 << 6) + (1 << 5) + (1 << 4) + (1 << 3) + (0 << 2) + (1 << 1) + (1 << 0);

    string a, b;
    cin >> a >> b;
    unsigned short mask1 = 0, mask2 = 0;
    for (int i = 0; i < 7; ++i) {
        if (a[i] == '1') mask1 += 1 << (6 - i);
        if (b[i] == '1') mask2 += 1 << (6 - i);
    }

//    for (int i = 6; i >= 0; --i) {
//        cout << ((mask1 >> i) & 1);
//    }
//    cout << endl;
//    for (int i = 6; i >= 0; --i) {
//        cout << ((mask2 >> i) & 1);
//    }
//    cout << endl;
//
//    for (int i = 0; i < 10; ++i) {
//        for (int j = 6; j >= 0; --j) {
//            cout << ((d[i] >> j) & 1);
//        }
//        cout << endl;
//    }

    vector<int> m(100, -1);
    int x, y;
    bool f;
    for (int i = 99; i > 0; --i) {
        if (i >= 10) {
            x = d[i / 10];
            x &= mask1;
            f = false;
            for (int j = 1; j < 10; ++j) {  // ?неисправный может показывать лидирующий ноль
                if (d[j] == x) {
                    x = j;
                    f = true;
                    break;
                }
            }
            if (!f) continue;
        } else {
            x = 0;
        }

        y = d[i % 10];
        y &= mask2;
        f = false;
        for (int j = 0; j < 10; ++j) {
            if (d[j] == y) {
                y = j;
                f = true;
                break;
            }
        }
        if (!f) continue;

        m[i] = x * 10 + y;
    }


    for (int i = 99; i > 0; --i) {
        cout << i << ": " << m[i] << endl;
    }

    int ans = 0, c = 0;
    for (int i = 98; i > 0; --i) {
        if (m[i] - m[i + 1] == 1) ++c;
        else {
            ans = max(ans, c);
            c = 0;
        }
    }
    cout << ans;

    return 0;
}
