#include <bits/stdc++.h>

using namespace std;

double cArea(double x1, double y1, double x2, double y2, double x3, double y3) {
    return abs(x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2)) / 2.0;
}

bool vTriangle(double x1, double y1, double x2, double y2, double x3, double y3){
    double k12 = abs((y1 - y2) / (x1 - x2));
    double k23 = abs((y2 - y3) / (x2 - x3));
    double k13 = abs((y3 - y1) / (x3 - x1));
    //cout << k12 << " " << k23 << " " << k13 << endl;
    if (k12 == k23 && k23 == k13 || !(y1 == 0 && y2 == 0 || y2 == 0 && y3 == 0 || y1 == 0 && y3 == 0))
    //if (k12 == k23 && k23 == k13)
        return true;

    return false;
}

int main() {
    int n;
    cin >> n;

    vector<pair<double, double>> points(n);

    for (int i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;
    }

    double maxArea = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) break;
                for (int k = 0; k < n; k++) {
                    if (k == i || k == j) break;
                    double area = 0;
                    if (vTriangle(points[i].first, points[i].second,
                                  points[j].first, points[j].second,
                                  points[k].first, points[k].second))
                        break;
                    else
                        area = cArea(points[i].first, points[i].second,
                                        points[j].first, points[j].second,
                                        points[k].first, points[k].second);
                    maxArea = max(maxArea, area);
                }
        }
    }

    cout << maxArea;
    return 0;
}
