def is_winning_position(piles):
    if any(pile == 0 for pile in piles):
        return False

    for i in range(len(piles)):
        if int(piles[i]) > 0:
            new_piles = piles[:]
            new_piles[i] -= 1
            if not is_winning_position(new_piles):
                return True
    return False

def game_winner(piles):
    return "Alice" if is_winning_position(piles) else "Dmitry"


n = int(input())
piles = list(map(int, input().split()))
winner = game_winner(piles)
print(winner)