#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int inf = (int)2e9;
const ll linf = (ll)1e18;

const ll mod = (ll)1e9 + 7ll;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int gcd(int a, int b) {
	while (b != 0) {
		swap(a %= b, b);
	}
	return a;
}

void solve() {
	
	
	

	int n; cin >> n;
	vector<int> a(n);
	int s, f, curr;

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	cin >> s >> f;
	bool rev = false;
	if (s > f) {
		swap(s, f);
		rev = true;
	}

	for (int i = s - 1; i < f; ++i) {
		if (i != 0 && abs(a[i] - a[i - 1]) == 1) {
			cout << "Impossible";
			return;
		}
	}

	curr = s - 1;
	int d = 0;
	vector<int> ans = {curr + 1};

	vector<int> kaban;

	for (int i = s; i < f; ++i) {
		if (gcd(abs(a[i] - a[curr]), d) == 1) {
			ans.push_back(i);
			curr = i - 1;
			kaban.push_back(d);
			d = 0;
		}
		d = gcd(abs(a[i] - a[curr]), d);
	}

	if (d > 0) {
		ans.push_back(f);
		kaban.push_back(d);
	}
	else if (d == 0 && sz(ans) == 1) {
		ans.push_back(f);
		kaban.push_back(2);
	}
	if (!rev) {
		for (int i = 0; i < sz(ans) - 1; ++i) {
			cout << "Kaban-" << kaban[i] << ' ' << ans[i] << ' ' << ans[i + 1] << "\n";
		}
	}

	else {
		reverse(all(ans));
		reverse(all(kaban));
		for (int i = 0; i < sz(ans) - 1; ++i) {
			cout << "Kaban-" << kaban[i] << ' ' << ans[i] << ' ' << ans[i + 1] << "\n";
		}
	}
	
}


signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
	//freopen("test.in", "r", stdin);
	//freopen("test.in", "w", stdout);
	//cout << fixed << setprecision(7);

	//clock_t start = clock();
	
	int tests = 1;
	//cin >> tests;
	for (int test = 1; test <= tests; ++test) {
		solve();
	}

	//clock_t end = clock();
	//ld seconds = (ld)(end - start) / CLOCKS_PER_SEC;
	//cout << seconds << "\n";
}