#include<bits/stdc++.h>

#define all(x) x.begin(), x.end()

#define F first
#define S second

using namespace std;

typedef long long ll;
typedef long double ld;

int broken(int d1, int d2, int m1, int m2) {
    int d[10] = {119, 36, 93, 109, 46, 107, 123, 37, 127, 111 };
    if (d1 == 0) {
        d2 = d[d2];
        d2 &= m2;
        int ok2 = 0;
        for (int i = 0; i < 10; ++i) if (d[i] == d2) d2 = i, ok2 = 1;
        if (ok2) return d2;
        else return -1;
    }
    d1 = d[d1];
    d2 = d[d2];
    d1 &= m1;
    d2 &= m2;
    int ok1 = 0, ok2 = 0;
    for (int i = 0; i < 10; ++i) if (d[i] == d1) d1 = i, ok1 = 1;
    for (int i = 0; i < 10; ++i) if (d[i] == d2) d2 = i, ok2 = 1;
    if (ok1 && ok2) {
        return d1 * 10 + d2;
    } else {
        return -1;
    }
}

void solve() {
    string a, b; cin >> a >> b;
    int m1 = 0, m2 = 0;
    for (int i = 0; i < a.size(); ++i) m1 += (a[i] - '0') * (1 << i);
    for (int i = 0; i < a.size(); ++i) m2 += (b[i] - '0') * (1 << i);
    // cout << m1 << ' ' << m2 << endl;
    // cout << broken(9, 9, m1, m2) << endl; return;
    int prevbr = broken(9, 9, m1, m2);
    int ans = 0;
    int curans = 0;
    for (int i = 98; i > 0; --i) {
        int cur = broken(i / 10, i % 10, m1, m2);
        // cout << i << ' ' << cur << endl;
        if (prevbr + 1 == cur) curans++;
        else ans = max(ans, curans), curans = 0;
        prevbr = cur;
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
