#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void findMinNumber(string s, unsigned long long k) {
    int n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        char minChar = s[i];
        int minIndex = i;
        
        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < minChar) {
                minChar = s[j];
                minIndex = j;
            }
        }
        
        if (minIndex != i) {
            int swapsNeeded = minIndex - i;
            if (swapsNeeded <= k) {
                for (int j = minIndex; j > i; --j) {
                    swap(s[j], s[j - 1]);
                }
                k -= swapsNeeded;
            }
        }
    }
    cout << s << endl;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        string s;
        unsigned long long k;
        cin >> s >> k;
        findMinNumber(s, k);
    }
    return 0;
}
