// #pragma GCC optimize ("O3")
#include <bits/stdc++.h>
typedef long long ll;
// #define int ll
using namespace ::std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define fore(collection) for (auto& val : collection)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define dbg(v) cerr << "Line(" << __LINE__ << ") -> " << #v << " = " << (v) << endl;
#define cmax(u, v) u = max(u, v)
#define cmin(u, v) u = min(u, v)
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
template<typename ValueType>
istream& operator>>(istream& in, vector<ValueType>& vect) { fore(vect) in >> val; return in; }
template<typename ValueType>
ostream& operator<<(ostream& out, const vector<ValueType>& vect) { fore(vect) out << val << " "; return out; }


struct Tax {
    int m;
    // [s; e) on gcd
    int s, e;
};

void doWork()
{
    int n;
    cin >> n;
    vi vect(n);
    cin >> vect;
    int s, e;
    cin >> s >> e;
    --s; --e;
    bool isReverse = s > e;
    if (isReverse) swap(s, e);

    vi gcds(n - 1);
    forn(i, n - 1) {
        gcds[i] = abs(vect[i + 1] - vect[i]);
    }
    if (find(gcds.begin() + s, gcds.begin() + e, 1) != gcds.begin() + e) {
        cout << "Impossible\n";
        return;
    }


    int curGcd = 0;
    int prevTravel = s;
    vector<Tax> ans;
    while (s < e) {
        int m = curGcd;
        curGcd = gcd(curGcd, gcds[s]);
        if (curGcd == 1) {
            ans.push_back({m, prevTravel, s});
            curGcd = gcds[s];
            prevTravel = s;
        }
        ++s;
    }
    ans.push_back({curGcd, prevTravel, s});

    if (isReverse) {
        reverse(all(ans));
        fore(ans) {
            swap(val.s, val.e);
        }
    }
    fore(ans) {
        assert(val.m != 1);
        if (val.m == 0) {
            val.m = 2;
        }
        cout << "Kaban-" << val.m << " " << val.s + 1 << " " << val.e + 1 << "\n";
    }


}

signed main()
{
    srand(chrono::duration_cast<chrono::nanoseconds>(chrono::steady_clock::now().time_since_epoch()).count());
    ios_base::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        try
        {
            doWork();
        }
        catch(const std::exception& e)
        {
            std::cerr << e.what() << '\n';
            return 0;
        }
    }
    return 0;
}
