#include <iostream>
//#include "optimization.h"
#include <vector>
#include <utility>
#include <map>
#include <string>
#include <set>
#include <unordered_set>
#include <stack>
#include <cmath>
#include <iomanip>
#include <queue>
#include <iterator>
//#include <algorithm>
#include <unordered_map>
#include <deque>
#include <cstdlib>
#include <numeric>
#include <functional>

using namespace std;
#define int long long

//#define int __int128_t
#define INT128_MIN (-INF - 1)
#define INTMAX 2147483647
//#define MAX 10001
//#define INF 1e14
const int MAX = 1e5+1;
//const int INF = 2e17;

signed main() {
#ifdef LOCAL
    freopen("main.in", "r", stdin);
#endif
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n;
    std::cin >> n;
    std::vector<std::string> programs(n);

    for (int i = 0; i < n; ++i) {
        std::cin >> programs[i];
    }

    char table[5][6];
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 6; ++j) {
            table[i][j] = '.';
        }
    }

    for (const auto& program : programs) {
        char first_letter = program[0];
        int index = first_letter - 'a';

        if (index >= 0 && index < 26) {
            table[index / 6][index % 6] = first_letter;
        }
    }

    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 6; ++j) {
            std::cout << table[i][j];
        }
        std::cout << std::endl;
    }
    for (int j = 0; j < 2; ++j) {
        std::cout << table[4][j];
    }
    std::cout << std::endl;

    return 0;
}