def is_wooden_matrix(n, matrix):
    for i in range(n):
        for j in range(n):
            if i == j:
                continue
            for k in range(n):
                if k == i or k == j:
                    continue
                if matrix[i][j] + matrix[j][k] < matrix[i][k] or matrix[i][j] + matrix[k][i] < matrix[j][k] or matrix[j][k] + matrix[k][i] < matrix[i][j]:
                    return "No"
    return "Yes"

n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]
print(is_wooden_matrix(n, matrix))
