#include <vector>
#include <iostream>
using namespace std;

const int MOD = 998244353;

vector<vector<vector<vector<int>>>> m;

int countWays(int p, int q, int r, int last) {

    if (p<0 || q<0 || r<0)
        return 0;
 
    if (p==1 && q==0 && r==0 && last==0)
        return 1;

    if (p==0 && q==1 && r==0 && last==1)
        return 1;
    if (p==0 && q==0 && r==1 && last==2)
        return 1;

    if (m[p][q][r][last] != -1)
        return m[p][q][r][last];

    if (last == 0) {
        m[p][q][r][last] = (countWays(p - 1, q, r, 1) % MOD + countWays(p - 1, q, r, 2) % MOD) % MOD;
    } else if (last == 1) {
        m[p][q][r][last] = (countWays(p, q - 1, r, 0) % MOD + countWays(p, q - 1, r, 2) % MOD) % MOD;
    } else if (last == 2) {
        m[p][q][r][last] = (countWays(p, q, r - 1, 0) % MOD + countWays(p, q, r - 1, 1) % MOD) % MOD;
    }

    return m[p][q][r][last];
}

int countUtil(int p, int q, int r) {
    m.assign(p + 1, vector<vector<vector<int>>>(q + 1, vector<vector<int>>(r + 1, vector<int>(3, -1))));

    return (countWays(p, q, r, 0) +
            countWays(p, q, r, 1) +
            countWays(p, q, r, 2)) % MOD;
}

int main() {
    int p, q, r;
    cin >> p >> q >> r;
    cout << countUtil(p, q, r) << endl;
    return 0;
}
