



#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <sstream>

typedef long long ll;
using namespace std;
string alph = "abcdefghijklmnopqrstuvwxyz";

/*
aba
aaaaaba
*/
//struct node {
//    ll ans, left, right, sum;
//};
//
//vector<node> tree;
//vector<int> a;
//
//void build(int v, int l, int r) {
//    if (l + 1 == r) {
//        tree[v] = { max(a[l], 0), a[l], a[l], a[l] };
//        return;
//    }
//    int m = (l + r) / 2;
//    build(2 * v + 1, l, m);
//    build(2 * v + 2, m, r);
//    tree[v].ans = max(max(tree[2 * v + 1].ans, tree[2 * v + 2].ans), tree[2 * v + 1].right + tree[2 * v + 2].left);
//    tree[v].left = max(tree[2 * v + 1].left, tree[2 * v + 1].sum + tree[2 * v + 2].left);
//    tree[v].right = max(tree[2 * v + 2].right, tree[2 * v + 2].sum + tree[2 * v + 1].right);
//    tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
//}
//
//void upd(int v, int l, int r, int pos, int x) {
//    if (l + 1 == r) {
//        tree[v] = { max(x, 0), x, x, x };
//        return;
//    }
//    int m = (l + r) / 2;
//    if (pos < m)
//        upd(2 * v + 1, l, m, pos, x);
//    else
//        upd(2 * v + 2, m, r, pos, x);
//    tree[v].ans = max(max(tree[2 * v + 1].ans, tree[2 * v + 2].ans), tree[2 * v + 1].right + tree[2 * v + 2].left);
//    tree[v].left = max(tree[2 * v + 1].left, tree[2 * v + 1].sum + tree[2 * v + 2].left);
//    tree[v].right = max(tree[2 * v + 2].right, tree[2 * v + 2].sum + tree[2 * v + 1].right);
//    tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
//}
//
//node get(int v, int l, int r, int ql, int qr) {
//    if (l >= qr || r <= ql)
//        return { 0, 0, 0, 0 };
//    if (l >= ql && r <= qr) {
//        return tree[v];
//    }
//    int m = (l + r) / 2;
//    node x, x1 = get(2 * v + 1, l, m, ql, qr), x2 = get(2 * v + 2, m, r, ql, qr);
//    x.ans = max(max(x1.ans, x2.ans), x1.right + x2.left);
//    x.left = max(x1.left, x1.sum + x2.left);
//    x.right = max(x2.right, x2.sum + x1.right);
//    x.sum = x1.sum + x2.sum;
//    return x;
//}
//
//vector<int> p;
//vector<int> sz;
//
//int get(int v) {
//    if (p[v] == v)
//        return v;
//    return p[v] = get(p[v]);
//}
//
//void unite(int a, int b) {
//    a = get(a);
//    b = get(b);
//    if (a == b)
//        return;
//    if (sz[a] > sz[b]) {
//        a = a ^ b;
//        b = a ^ b;
//        a = a ^ b;
//    }
//    p[a] = b;
//    sz[b] += sz[a];
//}
int b_;

int gcd(int a, int b)
{
    while (b != 0) {
        b_ = b;
        a %= b;
        b = a;
        a = b_;
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    int* a = new int[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int s, f;
    cin >> s >> f;
    s--;
    f--;
    int p1 = min(s, f), p2 = max(s, f);
    for (int i = p1; i < p2; i++) {
        if (a[i + 1] - a[i] == 1) {
            cout << "Impossible";
            return;
        }
    }
    if (s == p1) {
        int cur = 0, last = p1, prevcur;
        for (int i = p1; i < p2; i++) {
            prevcur = cur;
            cur = gcd(cur, abs(a[i + 1] - a[i]));
            if (cur == 1) {
                cout << "Kaban-" << ((prevcur == 0) ? 1000000000 : prevcur) << " " << last + 1 << " " << i + 1 << "\n";
                last = i;
                cur = 0;
                i--;
            }
        }
        cout << "Kaban-" << ((cur == 0) ? 1000000000 : cur) << " " << last + 1 << " " << p2 + 1 << "\n";
    }
    else {
        int cur = 0, last = p2, prevcur;
        for (int i = p2; i > p1; i--) {
            prevcur = cur;
            cur = gcd(cur, abs(a[i - 1] - a[i]));
            if (cur == 1) {
                cout << "Kaban-" << ((prevcur == 0) ? 1000000000 : prevcur) << " " << last + 1 << " " << i + 1 << "\n";
                last = i;
                cur = 0;
                i++;
            }
        }
        cout << "Kaban-" << ((cur == 0) ? 1000000000 : cur) << " " << last + 1 << " " << p1 + 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();

}