#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

bool check(ll** m, vector<ll> xs)
{
    if (xs.size() <= 1) return true;
    vector<ll> a, b;
    ll x = xs[0], y = xs[1], l = m[x][y];
    for (auto v : xs)
    {
        if (v == x || v == y) continue;
        if (m[v][x] - m[v][y] == -l) a.push_back(v);
        else if (m[v][x] - m[v][y] == l) b.push_back(v);
        else return false;
    }
    if (!check(m, a)) return false;
    if (!check(m, b)) return false;
    for (auto a1 : a)
    {
        for (auto b1 : b)
        {
            if (m[a1][b1] != m[a1][x] + l + m[y][b1]) return false;
        }
    }
    return true;
}

int main(){
    ll n, **d;
    cin >> n;
    d = new ll*[n];
    vector<ll> xs(n);
    for (int i = 0; i < n; i++)
    {
        xs[i] = i;
        d[i] = new ll[n];
        for (int j = 0; j < n; j++)
            cin >> d[i][j];
    }
    if (check(d, xs)) cout << "Yes";
    else cout << "No";
    cout << endl;

    return 0;
}