#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

using namespace std;

#define ll long long
#define ld long double
#define vl vector<ll>
#define pr pair<ll, ll>
#define all(a) a.begin(), a.end()

ll gcd(ll a, ll b) { return (b ? gcd(b, a % b) : a); }

ll lcm(ll a, ll b) { return a / gcd(a, b) * b; }

const ld PI = 3.14159265;
const ll MAXN = 10000 + 13;
const ll MAXM = 1000 + 13;
const ll MOD = 1e9 + 7;

void solve() {
    ll n;
    map<ll, set<ll> > mp;

    cin >> n;

    ll min_y = 10000, max_y = -10000;

    ll x, y;
    for(ll i = 0; i < n;i++){
        cin >> x >> y;
        if(y == 0) {
            mp[y].insert(x);
        }
        min_y = min(min_y, y);
        max_y = max(max_y, y);
    }

    ld ans = 0;
    for(auto elem: mp) {
        ll min_xx = *elem.second.begin();
        ll max_xx = *elem.second.rbegin();
        ll curr_y = elem.first;

        ld res1 = 0;
        if(min_y != 10000) {
            res1 = abs(max_xx - min_xx) * abs(curr_y - min_y) / 2.0;
        }

        ld res2 = 0;
        if(max_y != -10000) {
            res2 = abs(max_xx - min_xx) * abs(max_y - curr_y) / 2.0;
        }

        if(res1 > ans) {
            ans = res1;
        }

        if(res2 > ans) {
            ans = res2;
        }
    }

    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}