#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

using namespace std;

#define ll long long
#define ld long double
#define vl vector<ll>
#define pr pair<ll, ll>
#define all(a) a.begin(), a.end()

ll gcd(ll a, ll b) { return (b ? gcd(b, a % b) : a); }

ll lcm(ll a, ll b) { return a / gcd(a, b) * b; }

const ld PI = 3.14159265;
const ll MAXN = 10000 + 13;
const ll MAXM = 1000 + 13;
const ll MOD = 1e9 + 7;

void solve() {
    string n;
    ll k;
    cin >> n >> k;
    string m = n;
    sort(all(m));
    map<char, deque<ll>> mp;
    for (int i = 0; i < n.size(); ++i) {
        mp[n[i]].push_back(i);
    }
    map<char, int> cnt;
    vector<ll> cnter(n.size());
    for (ll i = 0; i < n.size(); ++i) {
        char c = m[i];
        ll j = mp[c][cnt[c]++];
        cnter[i] = max(0ll, j - i);
    }

//    for (const auto& [ss, tt] : mp) {
//        cout << ss << "\n    ";
//        for (const auto& oo: tt) {
//            cout << oo << " ";
//        }
//        cout << '\n';
//    }
//
//    cout << '\n';
//
//    for(int i = 0; i < n.size(); ++i) {
//        cout << m[i] << ": " << cnter[i] << '\n';
//    }

    vector<bool> moved(n.size());
    int np = 0;
    cnt = {};
    for (int i = 0; i < n.size(); ++i) {
        if (auto x = k - cnter[i]; x >= 0) {
            char char_to_move = m[i];
            int num_of_this_chars_already_moved = cnt[char_to_move]++;
            moved[mp[char_to_move][num_of_this_chars_already_moved]] = 1;
            k = x;
        }
        else {
            break;
        }
    }

    for (char i = '1'; i <= '9'; ++i) {
        if (mp[i].empty()) {
            mp.erase(i);
        }
    }

    string middle;
    middle.reserve(n.size());
    for (int i = 0; i < n.size(); ++i) {
        if (moved[i]) { middle.push_back(n[i]); np++; }
    }
    if (np == n.size()) {
        cout << m << endl;
        return;
    }
    for (int i = 0; i < n.size(); ++i) {
        if (!moved[i])
            middle.push_back(n[i]);
    }

//    cout << "middle = " << middle << endl;

    n = move(middle);
    mp = {};
    for (int i = np; i < n.size(); ++i) {
        mp[n[i]].push_back(i);
    }

    while (k) {
        for (auto& tt : mp) {
            auto p = tt.first;
            auto& v = tt.second;
            if (v.empty()) continue;
            if (auto x = k - (v.front() - np); x >= 0) {
                for (int j = v.front(); j > np; --j) {
                    swap(n[j], n[j-1]);
                }
                np++;
                for (auto& ttt : mp) {
                    if (ttt.first <= p) continue;

                    for (auto& x: ttt.second) {
                        if (x < v.front()) ++x;
                        else break;
                    }
                }
                v.pop_front();
                k = x;
                break;
            }
        }
        if (np == n.size()) break;
    }

    cout << n << endl;
}

int main() {
    ios::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}