﻿#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <bitset>
#include <math.h>
//#include <pair>

#define ll long long
#define M_PI 3.14159265358979323846

using namespace std;

int NSD(int a, int b)
{
    while (a && b) if (a < b) b %= a; else a %= b;
    return a + b;
}

void source() {

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;
    s--;
    f--;
    bool flag = 0;
    if (s > f) {
        swap(s, f);
        flag = 1;
    }

    vector<int> raz(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        raz[i] = abs(a[i + 1] - a[i]);
    }

    int r = s, l = s;
    
    vector < pair<int, pair<int, int>> > ans;
    while (s < f) {
        if (raz[s] == 1) {
            cout << "Impossible";
            return;
        }

        r = s;
        int fix = raz[s];
        if (fix == 0) {
            fix = a[s];
        }
        int prev_fix = fix;
        while (fix != 1 && s < f) {
            prev_fix = fix;
            fix = NSD(fix, raz[s + 1]);
            s++;
        }
        l = s;
        ans.push_back({ prev_fix, {r + 1, l + 1} });
        //cout << "Kaban-" << prev_fix << ' ' << r + 1 << ' ' << l + 1 << endl;
        
    }

    if (flag == 1) {
        for (int i = ans.size() - 1; i >= 0; --i) {
            cout << "Kaban-" << ans[i].first << ' ' << ans[i].second.second << ' ' << ans[i].second.first << endl;
        }
    }
    else {
        for (int i = 0; i < ans.size(); ++i) {
            cout << "Kaban-" << ans[i].first << ' ' << ans[i].second.first << ' ' << ans[i].second.second << endl;
        }
    }
    

    /*for (int i = 0; i < n - 1; ++i) {
        cout << raz[i] << ' ';
    }*/




}

int main() {

    ll g;
    g = 1;
    //cin >> g;

    while (g--) {
        source();
    }

    return 0;
}