﻿#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <bitset>
#include <math.h>
//#include <pair>

#define ll long long
#define M_PI 3.14159265358979323846

using namespace std;

// 0 - red
// 1 - green
// 2 - blue
int perm(int r, int g, int b, int f) {
    if (r < 0 || g < 0 || b < 0) return 0;

    if (r == 0 && g == 0 && b == 0) return 1;

    if (f == 0) {
        return (perm(r, g - 1, b, 1) + perm(r, g, b - 1, 2)) % 998244353;
    }
    if (f == 1) {
        return (perm(r - 1, g, b, 0) + perm(r, g, b - 1, 2)) % 998244353;
    }
    if (f == 2) {
        return (perm(r - 1, g, b, 0) + perm(r, g - 1, b, 1)) % 998244353;
    }
}

void source() {

    int r, g, b;
    cin >> r >> g >> b;
    if (r > g + b || g > r + b || b > r + g) cout << 0;
    else cout << (perm(r - 1, g, b, 0) + perm(r, g - 1, b, 1) + perm(r, g, b - 1, 2)) % 998244353;

}

int main() {

    ll g;
    g = 1;
    //cin >> g;

    while (g--) {
        source();
    }

    return 0;
}