def square(x1, x2, y3):
    return 0.5 * abs((x2 - x1)*(y3))


def main():
    n = int(input())
    min_ox_point = [float('inf'), 0.0]
    max_ox_point = [float('-inf'), 0.0]
    best_outside_point = (0.0, 0.0)
    for _ in range(n):
        point = tuple(map(float, input().split()))
        if point[1] == 0.0:
            min_ox_point[0] = min(min_ox_point[0], point[0])
            max_ox_point[0] = max(max_ox_point[0], point[0])
        else:
            best_outside_point = max(best_outside_point, point, key=lambda x: abs(x[1]))
        # print(min_ox_point, max_ox_point, best_outside_point)
    if min_ox_point[0] != float('inf') and max_ox_point[0] != float('-inf'):
        print(square(x1=min_ox_point[0], x2=max_ox_point[0], y3=best_outside_point[1]))
    else: 
        print(0)


if __name__ == "__main__":
    main()