import fileinput

def game(heap_stones):
    xor_sum = 0
    for stone in heap_stones:
        xor_sum ^= stone

    if xor_sum == 0:
        return "Dmitry"
    else:
        return "Alice"

if __name__ == "__main__":
    lines = []
    for line in fileinput.input():
        lines.append(line.strip())

    n = int(lines[0])
    heap_stones = list(map(int, lines[1].split()))
    print(game(heap_stones))