MOD = 998244353
MAX_N = 300000

fact = [1] * (MAX_N + 1)
inv_fact = [1] * (MAX_N + 1)

for i in range(2, MAX_N + 1):
    fact[i] = fact[i - 1] * i % MOD

inv_fact[MAX_N] = pow(fact[MAX_N], MOD - 2, MOD)
for i in range(MAX_N - 1, 0, -1):
    inv_fact[i] = inv_fact[i + 1] * (i + 1) % MOD

r, g, b = map(int, input().split())

if abs(r - g) > 1 or abs(g - b) > 1 or abs(b - r) > 1:
    print(0)
else:
    total_ways = (fact[r + g + b] * inv_fact[r] % MOD * inv_fact[g] % MOD * inv_fact[b] % MOD *inv_fact[max([r,g,b])] % MOD * fact[min([r,g,b])]%MOD) % MOD
    print(total_ways)
