#define GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
template <class T>
T gcd(T a, T b) {
    while (b) a = a % b, swap(a, b);
    return a;
}

const ll mod = 998244353;

int64_t poww(int64_t val, int64_t d, int64_t modd = mod) {
    int64_t ans = 1, mn = val;
    while (d) {
        if (d & 1) ans = mn * ans % modd;
        mn = mn * mn % modd, d >>= 1;
    }
    return ans;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> s(n);
    for (int i=0;i<n;++i) cin >> s[i];
    ll st,f;
    cin >> st >> f;
    vector<pair<pair<ll,ll>,ll>> ans;
    st--;f--;
    for (int i=min(st,f)+1;i<=max(st,f);++i) {
        if (abs(s[i] - s[i-1]) == 1) {
            cout << "impossible";
            return;
        }
    }
    bool fl = false;
    if (st > f) {
        swap(st,f);
        fl = true;
    }
    ll gg = 0;
    ll lst=st;
    for (int i=st+1;i<=f+1;++i) {
        ll ngg = gcd(gg, abs(s[i]-s[i-1]));
        if (ngg == 1 || i == f+1) {
            if (gg == 0) gg = 2;
            ans.push_back({{gg, lst}, i-1});
            lst = i-1;
            gg = abs(s[i]-s[i-1]);
        }
        else {
            gg = ngg;
        }
    }
    if (fl) {
        reverse(ans.begin(), ans.end());
        for (auto e: ans) cout << "Kaban-" << e.first.first << ' ' << e.second+1 << ' ' << e.first.second+1 << '\n';
    }
    else {
        for (auto e: ans) cout << "Kaban-" << e.first.first << ' ' << e.first.second+1 << ' ' << e.second+1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
