#define GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
template <class T>
T gcd(T a, T b) {
    while (b) a = a % b, swap(a, b);
    return a;
}

const ll mod = 998244353;

int64_t poww(int64_t val, int64_t d, int64_t modd = mod) {
    int64_t ans = 1, mn = val;
    while (d) {
        if (d & 1) ans = mn * ans % modd;
        mn = mn * mn % modd, d >>= 1;
    }
    return ans;
}

void solve() {
    ll n,k;
    cin >> n >> k;
    ll ans = 0;
    while (n>1 && k) {
        ans++;
        k--;
        n = (n+1)/2;
    }
    cout << ans+n-1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) solve();
}
