#include <bits/stdc++.h>

#include <iomanip>
// #include <linux/limits.h>
#include <utility>
#include <vector>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define Sz(x) ((int)(x).size())

//typedef tree<
//        pair<int, pair<int, int>>,
//        null_type,
//        less<>,
//        rb_tree_tag,
//        tree_order_statistics_node_update>
//        ordered_set;

using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18 + 10 + 300 + 5251 + 14154;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vpi = vector<pii>;

#ifdef LOCAL

void debugPrint(std::integral auto integer) {cerr << integer;}
void debugPrint(std::floating_point auto kek) {cerr << kek;}

void debugPrint(const std::string& s) {cerr << "\"" << s << "\"";}
void debugPrint(const char* s) {cerr << "\"" << s << "\"";}
void debugPrint(bool b) {cerr << (b ? "true" : "false");}
void debugPrint(char  c) {cerr << "\'" << c << "\'";}
template <typename F, typename S>
void debugPrint(const pair<F, S> & p) { cerr << "{"; debugPrint(p.first); cerr << ", "; debugPrint(p.second); cerr << "}";}

template<typename T>
void debugPrint(complex<T> c) { cerr << "{"; debugPrint(c.real()); cerr << ", "; debugPrint(c.imag()); cerr << "}";}

template <template <typename> class Container, typename T>
    requires (!same_as<T, char>)
void debugPrint(Container<T> & container) {
    cerr << "{";
    for (auto it = container.begin(); it != container.end(); ++it) {
        if (it == container.begin()) {
            debugPrint(*it);
        } else {
            cerr << ", ";
            debugPrint(*it);
        }
    }
    cerr << "}";
}

void debugPrint() {}

void debugPrint(auto head, auto... tail) {
    debugPrint(head); if (sizeof...(tail) != 0) {
        cerr << ", ";
    }
    debugPrint(tail...);
}

#endif

#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << "] = ["; debugPrint(x); cerr << "]\n";
#else
#define debug(x...) 52
#endif

int bpow(int x, int y, int M = INF) {
    x %= M;
    int res = 1;
    while (y) {
        if (y & 1) res = x * res % M;
        x = x * x % M;
        y >>= 1;
    }
    return res;
}

int gcd(int a, int b, int & x, int & y) {
    if (a == 0) {
        x = 0; y = 1;
        debug(x, y);
        return b;
    }
    int x1, y1;
    int d = gcd (b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    debug(x, y);
    return d;
}

vi remDup(vi a) {
    sort(all(a));
    a.erase(unique(all(a)), a.end());
    return a;
}

void solve(int numberTest) {
    int n;
    cin >> n;
    vpi v(n);
    
    int minY = INF;
    int maxY = -INF;

    for (auto& [x, y] : v) {
        cin >> x >> y;
        minY = min(minY, y);
        maxY = max(maxY, y);
    }

    ld res = 0.0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (v[i].second != 0 || v[j].second != 0) continue;
            int dx = abs(v[i].first - v[j].first);
            int dy = max(abs(minY), abs(maxY));
            ld cur = ld(dx * dy) / 2;
            res = max(res, cur);
        }
    }
    cout << fixed << setprecision(15);
    cout << res << "\n";
}

void solveG() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a) {
        cin >> i;
    }    
    for(auto& i: a) {
        if (i % 2 == 1) {
            cout << "Alice\n";
            return;
        }
    }
    cout << "Dmitry\n";
}

void solveH() {
    string s;
    cin >> s;
    int k;
    cin >> k;
    int left = 0;
    for (int i = 1; i <= 9; ++i) {
        vector<int> p;
        for (int j = left; j < Sz(s); ++j) {
            if (s[j]  - '0' == i) p.push_back(j);
        }
        int cnt = 0;
        int new_left = left;
        for (auto& pos: p) {
            if (pos - new_left <= k) {
                k -= (pos - new_left);
                ++cnt;
                ++new_left;
            } else {
                break;
            }
        }
        string cpy = s;
        for (int j = left; j < left + cnt; ++j) {
            cpy[j] = '0' + i;
        }
        int ptr = left + cnt;
        for (int j = left; j < Sz(s); ++j) {
            if (s[j] == '0' + i && cnt > 0) {
                --cnt;
                continue;
            }
            cpy[ptr] = s[j];
            ++ptr;
        }
        left = new_left;
        s = std::move(cpy);
    }
    for (int i = 1; i <= 9; ++i) {
        vector<int> p;
        for (int j = left; j < Sz(s); ++j) {
            if (s[j]  - '0' == i) p.push_back(j);
        }
        int cnt = 0;
        int new_left = left;
        for (auto& pos: p) {
            if (pos - new_left <= k) {
                k -= (pos - new_left);
                ++cnt;
                ++new_left;
            } else {
                break;
            }
        }
        string cpy = s;
        for (int j = left; j < left + cnt; ++j) {
            cpy[j] = '0' + i;
        }
        int ptr = left + cnt;
        for (int j = left; j < Sz(s); ++j) {
            if (s[j] == '0' + i && cnt > 0) {
                --cnt;
                continue;
            }
            cpy[ptr] = s[j];
            ++ptr;
        }
        left = new_left;
        s = std::move(cpy);
    }
    

    
    cout << s << '\n';
}

vector<vector<int>> c(100, vector<int>(100, 0));

void count_c() {
    for (int i = 0; i < 100; ++i) {
        c[i][0] = c[i][i] = 1;
    }
    for (int n = 1; n < 100; ++n) {
        for (int k = 1; k < n; ++k) {
            if (c[n - 1][k - 1] >= INF || c[n - 1][k] >= INF) {
                c[n][k] = INF;
                continue;;
            }
            c[n][k] = c[n - 1][k - 1] + c[n - 1][k];
        }
    }
}

void solveJ() {
    int n, k;
    cin >> n >> k;
    int l = 0, r = 100;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int tec = 0;
        for (int i = 0; i <= k && 2 * i <= m + 1 && tec < INF; ++i) {
            tec += c[m + 1][2 * i];
        }
        if (tec < n) {
            l = m;
        } else {
            r = m;
        }
    }
    cout << r << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    count_c();

    int nt = 1;
    cin >> nt;

    for (int i = 1; i <= nt; i++) {
        // solve(i);
        // solveG();
        // solveH();
        solveJ();
    }
}