#include <bits/stdc++.h>

using namespace std;

template <typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2> p)
{
    out << p.first << " " << p.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& i : a) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T> a)
{
    for (auto i : a)
        out << i << (std::is_same_v<T, vector<int>> ? "\n" : " ");
    return out;
}

#pragma GCC optimize("Ofast,unroll-loops")

// #define int long long
#define pii pair<int, int>
#define ss second
#define ff first
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define deb(x) cerr << (#x) << " is " << (x) << endl;

vector<int> t;
int size_ = 0;

int get(int i, int x, int tl, int tr)
{
    if (tr - tl == 1)
    {
        return t[x];
    }

    int tm = (tl + tr) / 2;
    if (i < tm) return get(i, 2 * x + 1, tl, tm);
    return get(i, 2 * x + 2, tm, tr) + t[x];
}

void add(int l, int r, int val, int x, int tl, int tr)
{
    if (r <= tl || l >= tr) return;
    if (l <= tl && r >= tr)
    {
        t[x] += val;
        return;
    }

    int tm = (tl + tr) / 2;
    add(l, r, val, 2 * x + 1, tl, tm);
    add(l, r, val, 2 * x + 2, tm, tr);
}

signed main()
{
#ifndef LOCAL_STDOUT
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int n;
    cin >> n;
    if (n < 3)
    {
        cout << 0 << endl;
        return 0;
    }
    vector<int> xs;
    int max_y = -1e9;
    int min_y = 1e9;
    for (int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        max_y = max(max_y, y);
        min_y = min(min_y, y);
        if (y == 0)
        {
            xs.push_back(x);
        }
    }
    if (xs.size() < 2)
    {
        cout << 0 << endl;
        return 0;
    }
    sort(xs.begin(), xs.end());
    long double ans = 0;
    long double sz = xs.back() - xs.front();
    ans = 0.5 * sz * max(abs(min_y), abs(max_y));
    cout.precision(10);
    cout << ans << endl;
}