#include <bits/stdc++.h>

using namespace std;

template <typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2> p)
{
    out << p.first << " " << p.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& i : a) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T> a)
{
    for (auto i : a)
        out << i << (std::is_same_v<T, vector<int>> ? "\n" : " ");
    return out;
}

#pragma GCC optimize("Ofast,unroll-loops")

// #define int long long
#define pii pair<int, int>
#define ss second
#define ff first
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define deb(x) cerr << (#x) << " is " << (x) << endl;

bitset<7> m1, m2;

string digits[10] = {
    "1110111",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011",
};

int get_digit(bitset<7> x)
{
    string s = x.to_string();
    for (int i = 0; i < 10; i++)
    {
        if (s == digits[i]) return i;
    }
    return -1;
}

int view(int x)
{
    if (x < 10)
    {
        return get_digit(bitset<7>(digits[x]) & m2);
    }
    string s = to_string(x);
    int a = s[0]-'0', b = s[1]-'0';
    bitset<7> q = bitset<7>(digits[a]) & m1;
    bitset<7> w = bitset<7>(digits[b]) & m2;

    int f = q.to_ulong() == 0 ? 0 : get_digit(q);
    int f2 = get_digit(w);
    if (f < 0 || f2 < 0) return -1;
    return f * 10 + f2;
}

int max_k(int real)
{
    int res = 0;
    int fake = view(real);
    if (fake < 0) return 0;
    real--;
    fake++;
    while(real > 0 && view(real) == fake)
    {
        res++;
        real--;
        fake++;
    }
    return res;
}

signed main()
{
#ifndef LOCAL_STDOUT
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    string q, w;
    cin >> q >> w;
    m1 = bitset<7>(q);
    m2 = bitset<7>(w);


    int ans = 0;
    for (int i = 99; i > 0; i--)
    {
        ans = max(ans, max_k(i));
    }
    cout << ans;
}