#include <iostream>

using namespace std;

typedef long long ll;

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return bin_pow(a, n - 1) * a;
    ll b = bin_pow(a, n / 2);
    return b * b;
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

void solve() {
    ll n, k;cin >> n >> k;
    cout << k + 1 << ' ' << n * k + 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
