#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define repi(i,a,b) for (int i = a; i < b; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()

using ll = long long;
using pll = pair<ll, ll>;
using vi = vector<ll>;
using vvi = vector<vi>;

mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());

vector<int> symbols(8, 1);

int look_like(int x) {
	const int bad = 0;
	if (x == 0) {
		return -1;
	}
	if (x == 1) {
		if (symbols[6] && symbols[3]) return 1;
		return bad;
	}
	if (x == 2) {
		if (symbols[1] && symbols[3] && symbols[4] && symbols[5] && symbols[7]) return 2;
		return bad;
	}
	if (x == 3) {
		if (symbols[1] && symbols[3] && symbols[4] && symbols[6] && symbols[7]) return 3;
		if (!symbols[1] && symbols[3] && !symbols[4] && symbols[6] && !symbols[7]) return 1;
		return bad;
	}
	if (x == 4) {
		if (symbols[2] && symbols[3] && symbols[4] && symbols[6]) return 4;
		if (!symbols[2] && symbols[3] && !symbols[4] && symbols[6]) return 1;
		return bad;
	}
	if (x == 5) {
		if (symbols[1] && symbols[2] && symbols[4] && symbols[6] && symbols[7]) return 5;
		return bad;
	}
	if (x == 6) {
		if (symbols[1] && symbols[2] && symbols[4] && symbols[5] && symbols[6] && symbols[7]) return 6;
		if (symbols[1] && symbols[2] && symbols[4] && !symbols[5] && symbols[6] && symbols[7]) return 2;
		return bad;
	}
	if (x == 7) {
		if (symbols[1] && symbols[3] && symbols[6]) return 7;
		if (!symbols[1] && symbols[3] && symbols[6]) return 1;
		return bad;
	}
	if (x == 8) {
		if (symbols[1] && symbols[2] && symbols[3] && !symbols[4] && symbols[5] && symbols[6] && symbols[7]) return 0;
		if (!symbols[1] && !symbols[2] && symbols[3] && !symbols[4] && !symbols[5] && symbols[6] && !symbols[7]) return 1;
		if (symbols[1] && symbols[2] && !symbols[3] && symbols[4] && !symbols[5] && symbols[6] && symbols[7]) return 2;
		if (symbols[1] && !symbols[2] && symbols[3] && symbols[4] && !symbols[5] && symbols[6] && symbols[7]) return 3;
		if (!symbols[1] && symbols[2] && symbols[3] && symbols[4] && !symbols[5] && symbols[6] && !symbols[7]) return 4;
		if (symbols[1] && symbols[2] && !symbols[3] && symbols[4] && !symbols[5] && symbols[6] && symbols[7]) return 5;
		if (symbols[1] && symbols[2] && !symbols[3] && symbols[4] && symbols[5] && symbols[6] && symbols[7]) return 6;
		if (symbols[1] && !symbols[2] && symbols[3] && !symbols[4] && !symbols[5] && symbols[6] && !symbols[7]) return 7;
		if (symbols[1] && symbols[2] && symbols[3] && symbols[4] && symbols[5] && symbols[6] && symbols[7]) return 8;
		if (symbols[1] && symbols[2] && symbols[3] && symbols[4] && !symbols[5] && symbols[6] && symbols[7]) return 9;
		return bad;
	}
	if (x == 9) {
		if (symbols[1] && symbols[2] && symbols[3] && symbols[4] && symbols[6] && symbols[7]) return 9;
		if (symbols[1] && !symbols[2] && symbols[3] && symbols[4] && symbols[6] && symbols[7]) return 3;
		if (symbols[1] && symbols[2] && !symbols[3] && symbols[4] && symbols[6] && symbols[7]) return 2;
		if (!symbols[1] && !symbols[2] && symbols[3] && !symbols[4] && symbols[6] && !symbols[7]) return 1;
		return bad;
	}
	return bad;
}

int parse_value(int x) {
	if (x == 0) return look_like(0);
	int res = 0;
	while (x) {
		int lk = look_like(x % 10);
		if (lk == -1) return -1;
		res *= 10;
		res += lk;
		x /= 10;
	}
	return res;
}

void solve() {
	int n; cin >> n;
	bool nc = false;
	for (int i = 0; i < n; i++) {
		int a; cin >> a;
		if (a % 2 != 0) nc = true;
	}
	if (nc) cout << "Alice\n";
	else cout << "Dmitry\n";
}


int main() {
    // freopen("output.txt", "w", stdout);
    // ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}