#include <algorithm>
#include <bitset>
#include <cctype>
#include <cstdio>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <vector>
using namespace std;
#define int long long
#define M9 2286661337LL
#define mod 998244353
#define INF (M9 * M9)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define eps 1e-6

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
// int get_rnd(int l, int r) { return rnd() % (r - l + 1) + l; }

int mp[] = {0b1110111, 0b0010010, 0b1011101, 0b1011011, 0b0111010,
            0b1101011, 0b1101111, 0b1010010, 0b1111111, 0b1111011};
map<int, int> ctod;
int fst, lst;

int trans_form(int n) {
  int a = mp[n / 10] & fst;
  int b = mp[n % 10] & lst;
  int res;

  if (n > 10) {
    auto i1 = ctod.find(a);
    if (i1 == ctod.end()) 
      return 999999999;
    res = 10 * i1->second;
  }
  
  auto i2 = ctod.find(b);
  if (i2 == ctod.end()) 
    return 999999999;
  return res + i2->second;
}

void solve() {
  string s1, s2;
  cin >> s1 >> s2;
  fst = stoi(s1, 0, 2);
  lst = stoi(s2, 0, 2);

  for (int i = 0; i <= 9; i++) {
    ctod.insert({mp[i], i});
  }
  int ans = 0;
  for (int y = 0; y <= 99; y++) {
    for (int x = 0; x <= 99; x++) {
      for (int k = 0; y >= k + 1 && x + k == trans_form(y - k); k++) {
        ans = max(ans, k);
      }
    }
  }
  cout << ans;
}

signed main() {
#ifdef __DEFINETELY_UNDEFINED_MACROVALUE
  freopen("../../in.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int t = 1;
  //  cin >> t;
  while (t--)
    solve();
  return 0;
}
