#include <bits/stdc++.h>

#define fastIO cin.tie(nullptr); ios_base::sync_with_stdio(false);
#define rep(i, a, b) for (int i = a; i < b; i++)
#define full(vec) vec.begin(), vec.end()
#define eb emplace_back
#define pb push_back
#define fr first
#define sc second

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

typedef vector <ll> vl;
typedef vector <vector <ll>> vvl;

const ld EPS = 1e-9;
const ll P = 307;
const ld PI = acos(-1);

template<class T>
istream &operator>>(istream &input, vector<T>& v) {
    for (auto &i : v) {
        input >> i;
    }
    return input;
}

template<class T>
ostream &operator<<(ostream &output, vector<T>& v) {
    for (auto &i : v) {
        output << i << ' ';
    }
    return output;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

void cok(bool t) { cout << (t ? "YES" : "NO") << '\n'; }

#define bits_s(a) bitset<64>(a).to_string()
string bits(ll m) {
    string s = bits_s(m);
    //reverse(full(s));
    return s;
}

const ll N = 2e5 + 10;
const ll MAXN = 1e16;
const ll MOD = 1e9 + 7;

void solve() {
    string s;
    ll k;
    cin >> s >> k;
    set <pair <ll, ll>> ms;
    set <pair <ll, ll>> ms_rev;
    ll last = 0;
    for (; last < s.size(); last++) {
        if (last > k) {
            break;
        }
        ms.insert({s[last] - '0', last});
        ms_rev.insert({last, s[last] - '0'});
    }
    ll cur = 0;
    vector <ll> ans;
    //map <ll, ll> mp;
    vector <ll> used;
    while (true) {
        if (ms.size() == 0) {
            break;
        }

        auto el = *ms.begin();
        ms.erase(ms.begin());
        ms_rev.erase({el.second, el.first});
        k -= (cur - el.second);

        cur++;
        while (ms.size() > 0 && (*(--ms_rev.end())).first - cur > k) {
            ms.erase({(*(--ms_rev.end())).second, (*(--ms_rev.end())).first});
            ms_rev.erase(--ms_rev.end());
        }
        for (; last < s.size(); last++) {
            if (last - cur <= k) {
                ms.insert({s[last] - '0', last});
                ms_rev.insert({last, s[last] - '0'});
            }
            else{
                break;
            }
        }
        ans.push_back(el.first);
        used.push_back(el.second);
    }
    sort(used.begin(), used.end());
    for (auto el : ans) {
        cout << el;
    }
    cur = 0;
    used.push_back(-1);
    for (ll i = 0; i < s.size(); i++) {
        if (used[cur] != i) {
            cout << s[i];
        }
        else{
            cur++;
        }
    }
    cout << '\n';
    return;
}

signed main() {
    fastIO
    auto start_time = chrono::high_resolution_clock::now();
    ll _ = 1;
    //cout.precision(10);
    //cout << fixed;
    cin >> _;
    while (_--) {
        solve();
    }
    auto end_time = chrono::high_resolution_clock::now();
    //cerr << "Execution time: " << chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
    return 0;
}
