#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using vll = vector<ll>;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void swapChars(string &s, ll i, ll j) {
    char tmp = s[i];
    s[i] = s[j];
    s[j] = tmp;
}
void full(string s, ll k) {
    ll n = s.size();
    for (ll i = 0; i < n && k > 0; ++i) {
        ll pos = i;
        for (ll j = i + 1; j < n && j - i <= k; ++j) {
            if (s[j] < s[pos]) {
                pos = j;
            }
        }

        if (pos != i) {
            char minDigit = s[pos];
            for (ll j = pos; j > i; --j) {
                s[j] = s[j - 1];
            }
            s[i] = minDigit;

            k -= (pos - i);
        }
    }
    cout << s;
}
void solve() {
    string s;
    ll k;
    cin >> s >> k;
    ll n = s.size();
    if (n == 1) {
        cout << s << '\n';
        return;
    }
    vector<ll> active(n, 0);
    vll sortingMap(10, -1);
    vll minIndexes(10, INT64_MAX);
    for (ll i = 0; i < n; ++i) {
        int c = s[i] - '0';
        if (sortingMap[c] == -1) {
            sortingMap[c] = 1;
        } else {
            sortingMap[c] += 1;
        }
    }
    vll sorted;
    for (ll i = 1; i <= 9; ++i) {
        while (sortingMap[i] > 0) {
            sorted.pb(i);
            sortingMap[i]--;
        }
    }
    for (ll i = 0; i < n; ++i) {
        minIndexes[sorted[i]] = min(minIndexes[sorted[i]], i);
    }
    //    for (int i = 1; i < 10; ++i) {
    //        cout << minIndexes[i] << ' ';
    //    }
    vll dp(n, -1);
    for (ll i = 0; i < n; ++i) {
        int curr = s[i] - '0';
        if (minIndexes[curr] != INT64_MAX) {
            int curMinIndex = minIndexes[curr];
            if (i <= curMinIndex) {
                dp[curMinIndex] = 0;
            } else {
                dp[curMinIndex] = i - curMinIndex;
            }
            minIndexes[curr]++;
        }
    }
    //    for (int i = 0; i < n; ++i) {
    //        cout << dp[i] << ' ';
    //    }
    vll ans;
    ll lastI = 0;
    for (int i = 0; i < n; ++i) {
        if ((k - dp[i]) > 0) {
            ans.pb(sorted[i]);
            k -= dp[i];
            active[i] = 1;
            lastI = i;
        } else {
            //            active[i] = 1;
            //            ans.pb(s[i] - '0');
            break;
        }
    }

    //    const ll leftK = k;
    // find огрызок
    //    ll lastJ = lastI + 1;
    //    pll minElem = {s[lastI] - '0', lastI};
    //    while ((k > 0) && lastJ < n) {
    //        int curr = s[lastJ] - '0';
    //        if (curr < minElem.first) {
    //            minElem = {curr, lastJ};
    //            k--;
    //        }
    //        lastJ++;
    //    }
    //    if (minElem.second != lastI) {
    //        swapChars(s, minElem.second - leftK, minElem.second);
    ////        ans.pb(minElem.first);
    //    }
    //    for (int i = 0; i < n; ++i) {
    //        if (!active[i]) {
    //            ans.pb((int) (s[i] - '0'));
    //        }
    //    }
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i];
    }
    if (ans.size() != n)
        full(s.substr(lastI), k);
    cout << '\n';
    //    cout << s << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}
