#include <iostream>
#include <vector>

using namespace std;

struct Ans {
    int m, s, f;
};

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;
    --s;
    --f;
    vector<Ans> ans;
    if (s < f) {
        int g = 0;
        int s1 = s;
        for (int i = s; i < f; ++i) {
            int d = abs(a[i + 1] - a[s1]);
            if (d == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            int gg = gcd(d, g);
            if (gg == 1) {
                ans.push_back({ g, s1, i });
                g = abs(a[i + 1] - a[i]);
                s1 = i;
            } else {
                g = gg;
            }
        }
        ans.push_back({ g, s1, f });
    } else {
        int g = 0;
        int s1 = s;
        for (int i = s; i > f; --i) {
            int d = abs(a[i - 1] - a[s1]);
            if (d == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            int gg = gcd(d, g);
            if (gg == 1) {
                ans.push_back({ g, s1, i });
                g = abs(a[i - 1] - a[i]);
                s1 = i;
            } else {
                g = gg;
            }
        }
        ans.push_back({ g, s1, f });
    }
    for (const Ans& x : ans) {
        cout << "Kaban-";
        if (x.m == 0) {
            cout << 1000000000 << ' ';
        } else {
            cout << x.m << ' ';
        }
        cout << x.s + 1 << ' ' << x.f + 1 << endl;
    }
}
