#pragma GCC optimize("O3,unroll-loops")
   
#include <iostream>
#include <vector>
#include <algorithm>

int INF = __INT32_MAX__;
 
using namespace std;
  
int main() {
    #define int long long
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> matr(n, vector<int>(n));
    vector <pair <int, pair <int, int>>> g;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matr[i][j];
            g.push_back({matr[i][j], {i, j}});
        }
    }
    
    int m =  g.size();
    int cost = 0;
    vector < pair<int,int> > res;

    sort (g.begin(), g.end());
    vector<int> tree_id (n);
    for (int i=0; i<n; ++i)
    	tree_id[i] = i;
    for (int i=0; i<m; ++i)
    {
    	int a = g[i].second.first,  b = g[i].second.second,  l = g[i].first;
    	if (tree_id[a] != tree_id[b])
    	{
    		cost += l;
    		res.push_back (make_pair (a, b));
    		int old_id = tree_id[b],  new_id = tree_id[a];
    		for (int j=0; j<n; ++j)
    			if (tree_id[j] == old_id)
    				tree_id[j] = new_id;
    	}
    }

    vector<vector<int>> d(n, vector<int>(n, INF));
    for (auto [a, b] : res) {
        d[a][b] = matr[a][b];
        d[b][a] = matr[b][a];
    }

    for (int k=0; k<n; ++k) {
        for (int i=0; i<n; ++i) {
            for (int j=0; j<n; ++j) {
                if(i == j) continue;
                d[i][j] = min (d[i][j], d[i][k] + d[k][j]);
                d[j][i] = min (d[j][i], d[j][k] + d[k][i]);
            }
        }
    }
 
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (d[i][j] < matr[i][j]) {
                //cout << d[i][j] << " " << matr[i][j] << "\n";
                cout << "No";
                return 0;
            }
        }
    }
     
    cout << "Yes";
}
