#define watch(x) cout << (#x) << " is " << (x) << endl;
#define pow2(x) ((x)*(x))
#define mod(x, m) ((((x) % (m)) + (m)) % (m))
#define max3(a, b, c) max(a, max(b, c))
#define min3(a, b, c) min(a, min(b, c))
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define wv(a) {cout << (#a) << " is "; for (auto i : a) cout << (i) << ' '; cout << endl;}

#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <stack>
#include <iomanip>
#include <deque>
#include <random>
#include <ctime>

using namespace std;
typedef long long ll;
typedef pair<int, int> ii;
typedef pair<int, ii> iii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<iii> viii;
typedef vector<vii> vvii;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 2e9;
mt19937 rnd(1317);


string minimalNumber(string s, long long k) {
    ll n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        char minChar = s[i];
        int minPos = i;

        // Найдем минимальную цифру в пределах доступных замен
        for (int j = i + 1; j < min(n, i + k + 1); ++j) {
            if (s[j] < minChar) {
                minChar = s[j];
                minPos = j;
            }
        }

        // Если нашли более мелкую цифру, то заменим
        if (minPos != i) {
            // Двигаем найденный символ на место i
            for (int j = minPos; j > i; --j) {
                swap(s[j], s[j - 1]);
                --k;  // Уменьшаем количество доступных замен
            }
        }
    }
    return s;
}

void solve() {
    string s;
    cin >> s;
    ll n = s.size();
    vi digs(n);
    forn(i, n) {
        digs[i] = s[i] - '0';
    }
    vi new_digs = digs;
    ull k;
    cin >> k;
    ll start = 0;
    bool flag = true;

    for (ll dig = 1; dig <= 9 && flag; dig++) {
        ll last_dig = 0;
        for (ll i = start; i < n; i++) {
            if (digs[i] == dig) {
                if (i - start - last_dig <= k) {
                    k -= i - start - last_dig;
                    last_dig++;
                } else {
                    flag = false;
                }
            }
        }
        for (ll i = start; i < start + last_dig; i++) {
            new_digs[i] = dig;
        }
        ll j = start + last_dig;
        for (ll i = start; last_dig > 0; i++) {
            if (digs[i] == dig) {
                last_dig--;
                start++;
            } else {
                new_digs[j++] = digs[i];
            }
        }
        digs = new_digs;
    }
    ll i = start;
    ll j = i;
    set<pair<ll, ll>> st;
    while (k > 0 && i < n) {
        if (k > n) {
            cout << (1 / 0) << endl;
            throw "error";
        }
        while (j < n && j - i <= k) {
            st.insert({digs[j], j});
            j++;
        }
        ll pos = -1;
        while (pos == -1) {
            auto p = *(st.begin());
            st.erase(st.begin());
            ll val_pos = p.second;
            if (val_pos - i <= k) {
                pos = val_pos;
            }
        }
        for (ll t = pos; t > i; --t) {
            st.erase({digs[t - 1], t - 1});
            st.insert({digs[t - 1], t});
            swap(digs[t], digs[t - 1]);
            --k;
        }
        i++;
    }


    for (auto el: digs) {
        cout << el;
    }
    cout << endl;
}

signed main() {
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}