#include <bits/stdc++.h>

using namespace std;

template<class T>
ostream& operator<<(ostream& out, const vector<T>& a) {
  for (auto& i : a) {
    out << i << " ";
  }
  return out;
}

template<class T>
T read() {
  T t;
  cin >> t;
  return t;
}

template<class T>
void operator>>(istream& in, vector<T>& a) {
  for (auto& i : a) {
    in >> i;
  }
}

template<class T>
void operator>>(istream& in, vector<vector<T>>& a) {
  for (auto& i : a) {
    in >> i;
  }
}

#define ll long long
#define ull unsigned ll
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define X first
#define Y second
constexpr ll MOD = 998244353;
constexpr ll inf = 1e10;

ll calc_log(ll n) {
  ll ans = 0;
  while (n != 1) {
    n = ceil(n / 2);
    ++ans;
  }

  return ans;
}

void solution() {
  ll n = read<ll>();
  ll k = read<ll>();
  ll nlog = calc_log(n);
  if (n == 2) {
    cout << 1 << '\n';
    return;
  }

  if (n == 4) {
    cout << 2 << '\n';
    return;
  }
  if (k >= nlog) {
    cout << nlog + 1 << '\n';
  } else {
    cout << (k - 1) + (n / nlog) - 1 << '\n';
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  auto ttt = read<int>();
  while (ttt--) {
    solution();
  }
}
