#include <iostream>

bool check_dist(long long a, long long b, long long c) {
    return (a + b >= c) && (b + c >= a) && (c + a >= b);
}

int main() {
    std::ios_base::sync_with_stdio(false);
    int n;
    std::cin >> n;
    long long woodeen[n][n];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            std::cin >> woodeen[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                if (!check_dist(woodeen[i][j], woodeen[i][k], woodeen[j][k])) {
                    std::cout << "No" << std::endl;
                    return 0;
                }
            }   
        }
    }
    std::cout << "Yes" << std::endl;
    return 0;
}