#include <iostream>

int main() {
    std::ios_base::sync_with_stdio(false);
    int n;
    std::cin >> n;
    long long woodeen[n][n];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            std::cin >> woodeen[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            for (int k = 0; k < n; k++) {
                if (i == k || j == k) continue;
                int mx = std::max(woodeen[i][j], std::max(woodeen[i][k], woodeen[j][k]));
                int mn = std::min(woodeen[i][j], std::min(woodeen[i][k], woodeen[j][k]));
                int md = woodeen[i][j] + woodeen[i][k] + woodeen[j][k] - mx - mn;
                if (md + mn < mx) {
                    std::cout << "No" << std::endl;
                    return 0;
                }
            }   
        }
    }
    std::cout << "Yes" << std::endl;
    return 0;
}