def get_area(x1, y1, x2, y2, x3, y3) -> float:
    return 0.5 * abs(x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2))


n = int(input())
if n < 3:
    print(0)
    exit(0)
y_null = []
y_not_null = []
for i in range(n):
    x,y = map(int, input().split())
    if y == 0:
        y_null.append([x,y])
    else:
        y_not_null.append([x,y])

if len(y_not_null) < 1:
    print(0)
    exit(0)
if len(y_null) < 2:
    print(0)
    exit(0)
x_min = min(map(lambda x: x[0], y_null))
x_max = max(map(lambda x: x[0], y_null))

max_area = 0
for i in range(len(y_not_null)):
    x3, y3 = y_not_null[i][0], y_not_null[i][1]
    a = get_area(x_min, 0, x_max, 0, x3, y3)
    if a > max_area:
        max_area = a
print(max_area)
