def max_triangle_area(points):
    max_area = 0
    on_x_axis = [p for p in points if p[1] == 0]
    off_x_axis = [p for p in points if p[1] != 0]
    

    if len(on_x_axis) < 2 or not off_x_axis:
        return 0 
    

    for i in range(len(on_x_axis)):
        for j in range(i + 1, len(on_x_axis)):
            x1, y1 = on_x_axis[i]
            x2, y2 = on_x_axis[j]
            
            for x3, y3 in off_x_axis:
                area = abs(x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2)) / 2.0
                if area > max_area:
                    max_area = area
    return max_area


n = int(input())

if n < 1 or n > 1000:
    exit(0)
else:
    points = [tuple(map(int, input().split())) for _ in range(n)]
    if any(abs(x) > 1000 or abs(y) > 1000 for x, y in points):
        exit(0)
    else:
        print(f"{max_triangle_area(points)}")