def max_triangle_area(points): 
    max_area = 0 
    on_x_axis = [p for p in points if p[1] == 0] 
    off_x_axis = [p for p in points if p[1] != 0] 
 
    if len(on_x_axis) < 2 or not off_x_axis: 
        return 0 
 
    on_x_axis.sort() 
     
    x1, _ = on_x_axis[0] 
    x2, _ = on_x_axis[-1] 
    max_base = abs(x2 - x1) 
 
    for x3, y3 in off_x_axis: 
        area = abs(max_base * y3) / 2.0 
        if area > max_area: 
            max_area = area 
 
    return max_area 
 
 
n = int(input()) 
 
if n < 1 or n > 1000: 
    exit(0) 
else: 
    points = [tuple(map(int, input().split())) for _ in range(n)] 
    if any(abs(x) > 1000 or abs(y) > 1000 for x, y in points): 
        exit(0) 
    else: 
        print(f"{max_triangle_area(points)}")