#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <utility>
#include <math.h>
#include <queue>
#include <fstream>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")

using namespace std;
using ll = long long;
using ld = long double;
const ll mod = 998244353;
const ld pog = 1e-12;
vector <string> dg = { "123567", "36", "13457", "13467", "2346", "12467", "124567", "136", "1234567", "123467" };
vector <ll> ndg1(10);
vector <ll> ndg2(10);

ll getnum(string s) {
    if (s.size() == 0) return -2;
    for (int i = 0; i <= 9; i++) {
        if (s == dg[i]) return i;
    }
    return -1;
}

ll nx(ll p) {
    ll p1, p2, p3 = 0;
    p1 = p / 10;
    p2 = p % 10;

    if (p1 == 0) {
        if (ndg2[p2] >= 0) return ndg2[p2];
        else return -1;
    }
    else {
        if (ndg1[p1] == -1) {
            return -1;
        }
        else if (ndg1[p1] != -2) {
            p3 += 10 * ndg1[p1];
        }
        if (ndg2[p2] >= 0) p3 += ndg2[p2];
        else return -1;
    }

    return p3;
}

void solve() {
    ll i, j, p;
    string s1, s2, s3;
    cin >> s1 >> s2;
    vector <ll> num1(8);   //    1
    vector <ll> num2(8);   //    2
    for (i = 1; i <= 7; i++) if (s1[i - 1] == '1') num1[i] = 1;
    for (i = 1; i <= 7; i++) if (s2[i - 1] == '1') num2[i] = 1;

    
    for (i = 0; i <= 9; i++) {
        s3 = "";
        for (j = 0; j < dg[i].size(); j++) {
            p = dg[i][j] - '0';
            if (num1[p] == 1) s3 += dg[i][j];
        }
        ndg1[i] = getnum(s3);
    }
    
    for (i = 0; i <= 9; i++) {
        s3 = "";
        for (j = 0; j < dg[i].size(); j++) {
            p = dg[i][j] - '0';
            if (num2[p] == 1) s3 += dg[i][j];
        }
        ndg2[i] = getnum(s3);
    }
    
    vector <ll> a(100);

    for (i = 1; i <= 99; i++) {
        a[i] = nx(i);
    }

    ll ans = 0, k = 0;
    for (i = 98; i >= 1; i--) {
        if (a[i] != -1 && a[i + 1] != -1 && a[i] == a[i + 1] + 1) k++;
        else {
            ans = max(ans, k);
            k = 0;
        }
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    ll t = 1;
    //cin >> t;
    while (t--) solve();
}