#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <stack>
#include <map>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<vector<int>> g(n, vector<int>(n, 0));
    set<pair<int, pair<int, int>>> st; // weight, left, right
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            cin >> g[i][j];
        }
    }
    vector<int> isin(n, 0);
    isin[0] = 1;
    for (int i = 0; i < n; i++)
    {
        if (i == 0) continue;
        st.insert({ g[0][i], {0, i} });
    }
    while (!st.empty())
    {
        pair<int, pair<int, int>> cur = *st.begin();
        int w = cur.first, left = cur.second.first, right = cur.second.second;
        st.erase(st.begin());
        for (int i = 0; i < n; i++)
        {
            if (!isin[i] || i == left)
                continue;
            if (g[i][left] + g[left][right] != g[i][right])
            {
                cout << "No" << endl;
                return 0;
            }
            st.erase({ g[i][right], {i, right} });
        }
        isin[cur.second.second] = 1;
        for (int i = 0; i < n; i++)
        {
            if (isin[i]) continue;
            st.insert({ g[i][right], {right, i} });
        }
    }
    cout << "Yes" << endl;
}