#include <iostream>
#include <algorithm>
#include <vector>
#define ll long long

using namespace std;

constexpr ll MOD = 998'244'353;

void solve() {
  ll n;  
  cin >> n;
  vector<int> a(n, 0);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  a.push_back(0);
  sort(a.begin(), a.end());
  ll ans = 0;
  for (int i = 1; i < a.size(); i++) {
    ans ^= i * ((a[i] - a[i - 1]) & 1);
  }
  cout << (ans ? "Alice" : "Dmitry") << endl;
}

int main() {
  ll t = 1;
  while (t--) {
    solve();
  }
}

/*
6 1 3
1 5 8
5 3 2
6 5 9
2 1 4
2 4 6
1 2
12 3
15 6
4 3
10 2
*/