#include <bits/stdc++.h>
using namespace std;

const int N = 4e5 + 10;
vector<int> sm;

int get(int l, int r, int l1, int r1, int v) {
    if (l > r1 || r < l1) return 0;
    if (l1 <= l && r <= r1) return sm[v];
    int md = (l + r) / 2;
    return get(l, md, l1, r1, v * 2) + get(md + 1, r, l1, r1, v * 2 + 1);
}

void add(int l, int r, int index, int v) {
    if (l > index || r < index) return;
    if (l == r) {
        sm[v] = 1;
        return;
    }
    int md = (l + r) / 2;
    add(l, md, index, v * 2);
    add(md + 1, r, index, v * 2 + 1);
    sm[v] = sm[v * 2] + sm[v * 2 + 1];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        string s;
        int k;
        cin >> s >> k;
        int n = s.size();
        sm.assign(4 * n + 1, 0);
        vector<deque<int>> v(10);
        vector<string> val(n + 1, "");
        vector<char> f(s.begin(), s.end());
        vector<int> vis(n + 1, 0);

        for (int i = 0; i < n; i++) {
            int x = s[i] - '0';
            v[x].push_back(i);
        }

        int i = 0, pos = 0;
        vector<int> qq;
        while (i < n) {
            if (vis[i] == 1) {
                i++;
                continue;
            }
            int x = s[i] - '0';
            int ii = i + 1;
            bool ok = true;

            for (int j = 1; j < x; j++) {
                if (v[j].empty()) continue;
                int i_org = get(1, n, ii, v[j].front() + 1, 1);
                if (v[j].front() - i - i_org > k) continue;
                
                k -= v[j].front() - i - i_org;
                qq.push_back(v[j].front());
                add(1, n, v[j].front() + 1, 1);
                vis[v[j].front()] = 1;
                val[i] += to_string(j);
                f[v[j].front()] = '\0';
                v[j].pop_front();
                ok = false;
                break;
            }
            i += ok;
            if (ok) {
                v[x].pop_front();
            }
        }

        string ans;
        for (int i = 0; i < n; i++) {
            ans += val[i] + (f[i] ? f[i] : '\0');
        }
        cout << ans << '\n';
    }
    return 0;
}
