def max_triangle_area(points):
    points_on_x = [x for x, y in points if y == 0]
    points_not_on_x = [(x, y) for x, y in points if y != 0]

    if len(points_on_x) < 2 or not points_not_on_x:
        return 0.0

    points_on_x.sort()

    max_area = 0.0
    for i in range(len(points_on_x)):
        for j in range(i + 1, len(points_on_x)):
            base_length = abs(points_on_x[j] - points_on_x[i])
            for x, y in points_not_on_x:
                area = 0.5 * base_length * abs(y)
                max_area = max(max_area, area)

    return max_area

n = int(input().strip())
points = [tuple(map(int, input().strip().split())) for _ in range(n)]

result = max_triangle_area(points)
print(f"{result:.9g}")