def max_triangle_area(points):

    min_x = float('inf')
    max_x = float('-inf')

    max_height = 0

    for x, y in points:
        if y == 0:

            min_x = min(min_x, x)
            max_x = max(max_x, x)
        else:
            max_height = max(max_height, abs(y))

    if min_x == float('inf') or max_x == float('-inf') or max_height == 0:
        return 0.0

    base_length = abs(max_x - min_x)
    max_area = 0.5 * base_length * max_height
    return max_area

n = int(input().strip())
points = [tuple(map(int, input().strip().split())) for _ in range(n)]

result = max_triangle_area(points)
print(f"{result:.9g}")