﻿#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;

        int n = s.length();
        for (int i = 0; i < n && k > 0; ++i) {
            char min_char = s[i];
            int min_index = i;

            for (int j = i + 1; j < n && j <= i + k; ++j) {
                if (s[j] < min_char) {
                    min_char = s[j];
                    min_index = j;
                }
            }

            if (min_index != i) {
                int moves_needed = min_index - i;

                if (moves_needed <= k) {
                    for (int j = min_index; j > i; --j) {
                        swap(s[j], s[j - 1]);
                    }
                    k -= moves_needed;
                }
            }
        }

        cout << s << "\n";
    }

    return 0;
}