#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <map>
#include <math.h>

#define ll long long
#define ld long double

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;

        if (n == 1) {
            cout << "0\n";
            continue;
        }

        ll pow = 64 - __builtin_clzll(n);
        if ((n & (n - 1)) == 0) {
            pow--;
        }

        if (k >= pow - 2) {
            cout << pow << '\n';
            continue;
        }

        ll preq = (1 << (k + 1));
        ll fi = (n - 1) / preq;
        cout << fi + k + 1 << '\n';
    }

    return 0;
}
