﻿#include <bits/stdc++.h>

#define int long long
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define fornr(i, n) for (int i = (int)n-1; i >=0; i--)
using namespace std;
vector<int> all = {
        0b1110111, // 0
        0b0100100, // 1 0b0010010
        0b1011101, // 2 0b1011101
        0b1101101, // 3 0b1011011
        0b0101110, // 4 0b0111010
        0b1101011, // 5 0b1101011
        0b1111011, // 6 0b1101111
        0b0100101, // 7 0b1010010
        0b1111111,// 8 0b1111111
        0b1101111 // 9 0b1111011
};



pair<int, int> right_state(int num){
    int fir = num/10;
    int sec = num % 10;
    if (fir != 0){
        fir = all[fir];
    }
    sec = all[sec];
    return {fir, sec};
}
int mask1 = 0, mask2 = 0;

void apply_masks(pair<int, int>& p){
    p.first = p.first & mask1;
    p.second = p.second & mask2;
}

int get_num_by_state(pair<int, int>& p){
    int fir = -1, sec = -1;
    forn(i, all.size()){
        if (p.first == all[i]){
            fir = i;
        }
        if (p.second == all[i]){
            sec = i;
        }
    }
    if (p.first == 0){
        fir = 0;
    }
    if (fir == -1 || sec == -1){
        return -1;
    }
    return fir * 10 + sec;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    forn(i, 7) {
        char ch;
        cin >> ch;
        int bit = (ch - '0') << i;
        mask1 += bit;
    }
    forn(i, 7) {
        char ch;
        cin >> ch;
        int bit = (ch - '0') << i;
        mask2 += bit;
    }
    vector<int> seen(100);
    forn(i, 100){
        if (i == 0) {
            continue;
        }
        pair<int, int> state = right_state(i);
        apply_masks(state);
        seen[i] = get_num_by_state(state);
    }
    int max_cnt =0;
    for (int i = 1; i < 100; i++){
        if (seen[i] != -1) {
            int cnt = 0;
            while (seen[i + 1] != -1 && seen[i + 1] == seen[i] -1) {
                i++;
                cnt++;
                if (i == 99){
                    break;
                }
            }
            if (cnt > max_cnt){
                max_cnt = cnt;
            }
        }
    }
    cout << max_cnt << '\n';
}
