// clang-format off
#include <bits/stdc++.h>
using namespace std; using ll = long long; using ull = unsigned long long; using ld = long double;
struct hash_pair {template<typename T1, typename T2>size_t operator()(const pair<T1, T2> &p) const noexcept {size_t h1 = (*this)(p.first), h2 = (*this)(p.second); return h1 == h2 ? h1 : h1 ^ h2;} template<typename T> size_t operator()(const T &v) const noexcept {return hash<T>()(v);}};
template<typename T1, typename T2> ostream &operator<<(ostream &o, const pair<T1, T2> &p) {o << '(' << p.first << ';' << p.second << ')'; return o;}
template<typename C, typename Sep> ostream &print_iterable(const C &container, Sep sep, ostream &o = cout);
template<typename C> auto operator<<(ostream &o, const C &container) -> decltype(container.begin(), o) {return print_iterable(container, ' ', o);}
template<typename C, typename Sep> ostream &print_iterable(const C &container, Sep sep, ostream &o) {for (auto &element : container) {o << element << sep;} return o;}
template<typename C> auto operator>>(istream &i, C &container) -> decltype(container.begin(), i) {for (auto &elem : container) {i >> elem;} return i;}
template<typename H, typename... T> void dbg_out(const H &head, const T&... tail) {cerr << head; if constexpr (sizeof...(tail)) {cerr << ' '; dbg_out(tail...);} else cerr << endl;}
#pragma GCC optimize("O3,Ofast")
#ifdef DEBUG
#define dbg(...) do {std::cerr << "(" << #__VA_ARGS__ << ") "; dbg_out(__VA_ARGS__);}while(false);
#else
#define dbg(...) void (0);
#endif
#define forn(i, n) for (ll i = 0; i < ll(n); ++i)
#define all(v) v.begin(), v.end()
constexpr ll MOD = 1e9 + 7;
// clang-format on
vector<ll> num_to_look = {
    0b1110111, 0b0010010, 0b1011101, 0b1011011, 0b0111010,
    0b1101011, 0b1101111, 0b1010010, 0b1111111, 0b1111011,
};
map<ll, ll> look_to_num;
ll maskl = 0;
ll maskr = 0;

ll get_real_num(ll num) {
    ll l = num / 10;
    ll r = num % 10;
    ll lnew = num_to_look[l] & maskl;
    ll rnew = num_to_look[r] & maskr;
    if (l == 0) {
        if (look_to_num.count(rnew) == 1) {
            return look_to_num[rnew];
        }
        return 100;
    } else {
        if (lnew == 0 && look_to_num.count(rnew) == 1) {
            return look_to_num[rnew];
        } else if (look_to_num.count(lnew) == 1 &&
                   look_to_num.count(rnew) == 1) {
            if (look_to_num[lnew] == 0) {
                return 100;
            }
            return 10 * look_to_num[lnew] + look_to_num[rnew];
        }
        return 100;
    }
    assert(false);
}

void solve() {
    forn(i, 10) {
        look_to_num[num_to_look[i]] = i;
    }
    assert(num_to_look[8] == 127);
    assert(num_to_look[0 == 119]);
    forn(i, 7) {
        char ok;
        cin >> ok;
        maskl |= (ok == '1') << (6 - i);
    }
    forn(i, 7) {
        char ok;
        cin >> ok;
        maskr |= (ok == '1') << (6 - i);
    }

    ll k = 0;
    ll cur = 0;
    ll last = get_real_num(99);
    for (ll i = 98; i > 0; --i) {
        ll next = get_real_num(i);
        if (next == last + 1) {
            ++cur;
            if (k < cur) {
                k = cur;
            }
        } else {
            cur = 0;
        }
        last = next;
    }

    dbg(maskl, maskr);
    cout << k << '\n';
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll all_tests = 1;
    // cin >> all_tests;
    forn(test_case, all_tests) {
        dbg("SOLVING #", test_case);
        solve();
    }
}
