#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <compare>
#include <complex>
#include <cstddef>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <limits>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <regex>
#include <sstream>
#include <stack>
#include <string>
#include <string_view>
#include <thread>
#include <unistd.h>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>
#include <set>
// #include "json.hpp" // lib for json, dont forget to coment on contests
// #include <curl/curl.h> // lib for curl, dont forget to coment on contests
// #include <bit>
// #include "optimization.h"

// using json = nlohmann::json; // namespace for json, dont forget to coment on
// contests
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define ld long double

typedef tree<int, null_type, less<>, rb_tree_tag,
             tree_order_statistics_node_update>
    ordered_set;

const int INF = 1e18 + 7;
const int inf = 1e9 + 7;
const int MOD1 = 1e9 + 9;
const int P = 31;
const int P1 = 43;
const int MOD = 1e9 + 7;
const ld PI = acosl(-1);
const ld EPS = 1e-9;

const int MAX_BITSET = 123;
set<int> p[20];

void solve() {
    string s;
    int k;
    cin >> s >> k;
    int n = s.size();
    ordered_set used;
    for (int i = 0; i < n; i++) {
        p[s[i] - '0'].insert(i);
    }
    set<int> u;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 10; j++) {
            if (p[j].size() && (*p[j].begin() + (used.size() - used.order_of_key(*p[j].begin())) - i) <= k) {
                cout << j;
                //cout << (*p[j].begin() + (used.size() - used.order_of_key(*p[j].begin())) - i) << '\n';
                k -= (*p[j].begin() + (used.size() - (int)used.order_of_key(*p[j].begin())) - i);
                used.insert(*p[j].begin());
                u.insert(*p[j].begin());
                p[j].erase(p[j].begin());
                break;
            }
        }
    }
    cout << '\n';
    for (int i = 0; i < 10; i++) {
       p[i].clear();
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    int t = 1;
    cin >> t;
    //      t = readInt();
    while (t--) {
        solve();
        // solve1();
    }

    // while (!isEof()) {
    //     solve();
    // }

    return 0;
}