    #include <algorithm>
    #include <bitset>
    #include <chrono>
    #include <climits>
    #include <cmath>
    #include <compare>
    #include <complex>
    #include <cstddef>
    #include <cstdlib>
    #include <cstring>
    #include <deque>
    #include <ext/pb_ds/assoc_container.hpp>
    #include <ext/pb_ds/tree_policy.hpp>
    #include <ext/rope>
    #include <fstream>
    #include <functional>
    #include <iomanip>
    #include <iostream>
    #include <iterator>
    #include <limits>
    #include <map>
    #include <math.h>
    #include <numeric>
    #include <queue>
    #include <random>
    #include <regex>
    #include <sstream>
    #include <stack>
    #include <string>
    #include <string_view>
    #include <thread>
    #include <unistd.h>
    #include <unordered_map>
    #include <unordered_set>
    #include <utility>
    #include <vector>
    #include <set>
    // #include "json.hpp" // lib for json, dont forget to coment on contests
    // #include <curl/curl.h> // lib for curl, dont forget to coment on contests
    // #include <bit>
    // #include "optimization.h"

    // using json = nlohmann::json; // namespace for json, dont forget to coment on
    // contests
    using namespace std;
    using namespace __gnu_pbds;
    #define int long long
    #define ld long double

    typedef tree<int, null_type, less<>, rb_tree_tag,
                tree_order_statistics_node_update>
        ordered_set;

    const int INF = 1e18 + 7;
    const int inf = 1e9 + 7;
    const int MOD1 = 1e9 + 9;
    const int P = 31;
    const int P1 = 43;
    const int MOD = 1e9 + 7;
    const ld PI = acosl(-1);
    const ld EPS = 1e-9;

    const int MAX_BITSET = 123;

    void solve() {
        int n;
        cin >> n;
        vector<int> v(n);
        for (auto &it : v) {
            cin >> it;
        }
        int s, f;
        cin >> s >> f;
        s--;
        f--;
        bool rev = false;
        if (s > f) {
            swap(s, f);
            rev = true;
        } 
        bool bad = false;
        int curNode = -1;
        int beg = -1;
        vector<pair<int, pair<int, int> > > ans;
        for (int i = s; i < f && !bad; i++) {
            int cur = abs(v[i] - v[i + 1]);
            if (cur == 0) {
                continue;
            }
            if (cur == 1) {
                bad = true;
            }
            if (curNode == -1) {
                curNode = cur;
                beg = i;
            } else {
                int g = __gcd(curNode, cur);
                if (g == 1) {
                    ans.push_back({curNode, {beg, i}});
                    curNode = cur;
                    beg = i;
                } else {
                    curNode = g;
                }
            }
        }
        if (bad) {
            cout << "Impossible";
            return;
        }
        if (curNode == -1) {
            curNode = v[s];
            beg = s;
        }
        ans.push_back({curNode, {beg, f}});
        if (rev) {
            reverse(ans.begin(), ans.end());
            for (int i = 0; i < ans.size(); i++) {
                cout << "Kaban-" << ans[i].first << ' ' << ans[i].second.second + 1 << ' ' << ans[i].second.first + 1  << '\n';
            }
        } else {
            for (int i = 0; i < ans.size(); i++) {
                cout << "Kaban-" << ans[i].first << ' ' << ans[i].second.first + 1  << ' ' << ans[i].second.second + 1  << '\n';
            }
        }
    }

    signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

        std::ios_base::sync_with_stdio(0);
        std::cin.tie(0);
        int t = 1;
        // cin >> t;
        //      t = readInt();
        while (t--) {
            solve();
            // solve1();
        }

        // while (!isEof()) {
        //     solve();
        // }

        return 0;
    }