#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <compare>
#include <complex>
#include <cstddef>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <limits>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <regex>
#include <sstream>
#include <stack>
#include <string>
#include <string_view>
#include <thread>
#include <unistd.h>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>
// #include "json.hpp" // lib for json, dont forget to coment on contests
// #include <curl/curl.h> // lib for curl, dont forget to coment on contests
// #include <bit>
// #include "optimization.h"

// using json = nlohmann::json; // namespace for json, dont forget to coment on
// contests
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define ld long double

// #define FAST_ALLOCATOR_MEMORY 1e8
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

const int INF = 1e18 + 7;
const int inf = 1e9 + 7;
const int MOD1 = 1e9 + 9;
const int P = 31;
const int P1 = 43;
const int MOD = 1e9 + 7;
const ld PI = acosl(-1);
const ld EPS = 1e-9;

const int MAX_BITSET = 123;

int dp[1000001][31][2];

void precalc() {
    int n = 1000000;
    int k = 30;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= k; j++) {
            if (i == 1) {
                dp[i][j][0] = 0;
                dp[i][j][1] = 0;
                continue;
            }
            dp[i][j][0] = max(dp[i / 2][j][1], dp[i / 2 + i % 2][j][0]) + 1;
            if (j == 1) {
                dp[i][j][1] = i - 1;
                continue;
            }
            dp[i][j][1] = max(dp[i / 2][j - 1][0], dp[i / 2 + i % 2][j][1]) + 1;
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0, cnt = 0; i < k; i++) {
        if (n < 1000000) {
            cout << dp[n][min(k - i, 30ll)][0] + cnt << '\n';
            return;
        }
        if (n == 1) {
            cout << cnt << '\n';
            return;
        }
        cnt++;
        n = n / 2;
        if (n < 1000000) {
            cout << dp[n][min(k - i, 30ll)][1] + cnt << '\n';
            return;
        }
        if (n == 1) {
            cout << cnt << '\n';
            return;
        }
        if (i == k - 1) {
            cout << cnt + (n - 1) << '\n';
            return;
        }
        n = n / 2;
        cnt++;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    int t = 1;
    precalc();
    cin >> t;
    //      t = readInt();
    while (t--) {
        solve();
        // solve1();
    }

    // while (!isEof()) {
    //     solve();
    // }

    return 0;
}
