#include <vector>
#include <iostream>
#include <random>
#include <time.h>
#include <algorithm>
#include <iomanip>
#include <map>

using namespace std;

#define re return
#define rep(i, n) for (int i = 0; i < n; ++i)
#define rrep(i, n) for (int i = n - 1; i >= 0; --i)
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define fi first
#define se second
#define sz(n) (int)(n.size())
#define sq(n) ((n) * (n))

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void GO() {
#ifdef LOL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const ll INF = 1e9;
const ll mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int P = 57;
const ld EPS = 1e-8;
const ld PI = acos(-1.0);

mt19937 rnd(time(0));

///var

///

map<int, string> numToString= {
    {0, "1110111"},
    {1, "0010010"},
    {2, "1011101"},
    {3, "1011011"},
    {4, "0111011"},
    {5, "1101011"},
    {6, "1101111"},
    {7, "1010010"},
    {8, "1111111"},
    {9, "1111011"}
};

map<string, int> stringToNum = {
    {"1110111", 0},
    {"0010010", 1},
    {"1011101", 2},
    {"1011011", 3},
    {"0111011", 4},
    {"1101011", 5},
    {"1101111", 6},
    {"1010010", 7},
    {"1111111", 8},
    {"1111011", 9}
};

string change_num(int num,const string &t) {
    string s = numToString[num];
    for (int i = 0; i < 8; ++i) {
        int one = s[i] - '0';
        int two = t[i] - '0';
        int thr = one & two;
        s[i] = char(thr + '0');
    }
    return s;
}

void solve(){
    string h, m; cin >> h >> m;
    vector<pair<string, string>> a;
    int ans = 0, last = -10, cnt = 0;
    vi b;
    for (int num = 99; num >= 1; --num) {
        int one = num / 10, two = num % 10;
        string hour = (one == 0 ? "-" : change_num(one, h));
        string minute = change_num(two, m);

        if (stringToNum.count(minute) && (hour == "-" || stringToNum.count(hour))) {
            int fir = (hour == "-" ? 0 : stringToNum[hour]);
            int sec = stringToNum[minute];
            int cur = 10 * fir + sec;
            if (cur == last + 1) last = cur, cnt++;
            else {
                ans = max(ans, cnt);
                last = cur, cnt = 0;
            }

            continue;
        }
        ans = max(ans, cnt);
        cnt = 0, last = -10;
    }

    cout << max(ans, cnt);
}

signed main() {
    GO();
    int Q = 1; 
    while (Q--) solve();
}
