#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

vector<int> getn(int digit) {
    vector<int> ans = {2};
    if(digit == 0)
        ans =  {1,1,1,0,1,1,1};
    if(digit == 1) {
        ans = {0,0,1,0,0,1,0};
    }
    if(digit == 2) {
        ans = {1,0,1,1,1,0,1};
    }
    if(digit == 3) {
        ans = {1,0,1,1,0,1,1};
    }
    if(digit == 4) {
        ans = {0,1,1,1,0,1,1};
    }
    if(digit == 5) {
        ans = {1,1,0,1,0,1,1};
    }
    if(digit == 6) {
        ans = {1,1,0,1,1,1,1};
    }
    if(digit == 7) {
        ans = {1,0,1,0,0,1,0};
    }
    if(digit == 8) {
        ans = {1,1,1,1,1,1,1};
    }
    if(digit == 9) {
        ans = {1,1,1,1,0,1,1};
    }
    if (ans[0] == 2)
        ans = {0,0,0,0,0,0,0};
    return ans;
}

int getnum(int n, vector<int>id1, vector<int> id2) {
    vector<int>b1;
    vector<int>b2;
    if(n < 10) {
        b1 = getn(10);
        b2 = getn(n);
    } else {
        b1 = getn(n/10);
        b2 = getn(n%10);
    }
    for(int i = 0; i < 7; i++) {
        b1[i] &= id1[i];
    }
    for(int i = 0; i < 7; i++) {
        b2[i] &= id2[i];
    }
    int nb1 = -1,nb2 = -1;
    vector<int>eq;
    for(int i = 0; i < 11; i++) {
        eq = getn(i);
        int f = 0;
        for(int j = 0; j < 7; j++) {
            if(eq[j] != b1[j]){
                f = 1;
            }
        }
        if(f == 0) {
            nb1 = i;
        }
    }
    for(int i = 0; i < 11; i++) {
        eq = getn(i);
        int f = 0;
        for(int j = 0; j < 7; j++) {
            if(eq[j] != b2[j]){
                f = 1;
            }
        }
        if(f == 0) {
            nb2 = i;
        }
    }
    if(nb1 < 0 || nb2 < 0) {
        return -1;
    } else {
        return nb1 * 10 + nb2;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string id1;
    string id2;
    cin>>id1;
    cin>>id2;
    vector<int>a(7);
    vector<int>b(7);
    for(int i = 0; i < 7; i++) {
        if(id1[i] == '1') {
            a[i] = 1;
        } else {
            a[i] = 0;
        }
    }
    for(int i = 0; i < 7; i++) {
        if(id2[i] == '1') {
            b[i] = 1;
        } else {
            b[i] = 0;
        }
    }
    vector<int>dp(100);
    int ans = 0;
    for(int i = 98; i > 0; i--) {
        if(getnum(i,a,b) + 1 == getnum(i + 1,a,b)) {
            dp[i] = dp[i+1] + 1;
        }
        ans = max(ans,dp[i]);
    }
    cout<<ans;
    return 0;
}