#include<iostream>
#include<vector>
#include<algorithm>
#include<random>
#define pnn pair<node*,node*>
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
const ll nmx = 1e5 + 5;
const ll INF = 1e9;
struct node
{
    ll mn;
    ll ind;
    ll sz;
    ll prior;
    ll va;
    node* l, * r;
    node(ll val,ll le) {
        l = r = nullptr;
        mn = val;
        ind = 0;
        sz = 1;
        va = val;
        prior = (((ll)rand() << 15ll) | rand());
    }
};
node* root = nullptr;
ll size(node* a)
{
    if (a == nullptr)return 0;
    return a->sz;
}
pll minn(node* a)
{
    if (a == nullptr)return { INF,INF };
    return { a->mn,a->ind };
}
void upd(node* a)
{
    a->sz = 1 + size(a->l) + size(a->r);
    pll bu;
    if (minn(a->l).first <= a->va && minn(a->l).first <= minn(a->r).first)
    {
        a->mn = minn(a->l).first;
        a->ind = minn(a->l).second;
    }
    else if (a->va <= minn(a->r).first)
    {
        a->mn = a->va;
        a->ind = size(a->l);
    }
    else
    {
        a->mn = minn(a->r).first;
        a->ind = 1 + size(a->l) + minn(a->r).second;
    }
}
node* merge(node* a, node* b)
{
    if (a == nullptr)return b;
    if (b == nullptr)return a;
    if (a->prior > b->prior)
    {
        a->r = merge(a->r, b);
        upd(a);
        return a;
    }
    else
    {
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}
pnn split(node* a, ll k)
{
    if (a == nullptr)return { nullptr,nullptr };
    if (size(a->l) + 1 <= k)
    {
        pnn q = split(a->r, k-size(a->l)-1);
        a->r = q.first;
        upd(a);
        return { a,q.second };
    }
    else
    {
        pnn q = split(a->l, k);
        a->l = q.second;
        upd(a);
        return { q.first,a };
    }
}
pll mine(ll l, ll r)//[l;r]
{
    pnn rq = split(root, r);
    pnn lq = split(rq.first, l);
    pll res = { lq.second->mn,lq.second->ind+l };
    root = merge(lq.first, merge(lq.second, rq.second));
    return res;
}
node* ctrlx(ll l, ll r) {
    pnn q1 = split(root, r);
    pnn q2 = split(q1.first, l);
    root = merge(q2.first, q1.second);
    return q2.second;
}
void ctrlv(node* v, ll k) {
    pnn q = split(root, k);
    root = merge(q.first, merge(v, q.second));
}
void solve();
signed main()
{
    cin.tie(0)->sync_with_stdio(0);
    ll t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
void solve()
{
    ll t;
    cin >> t;
    while (t--)
    {
        string e;
        ll k;
        cin >> e >> k;
        vector<ll>A(e.size());
        ll n = A.size();
        root = nullptr;
        for (ll j = 0; j < A.size(); ++j)
        {
            A[j] = e[j] - '0';
            root = merge(root, new node(A[j], j));
        }
        vector<ll>ans = A;
        ll i = 0;
        while (i < n-1 && k>0)
        {
            pll we = mine(i + 1, min(n, i + k+1));
            ll je = mine(i, i + 1).first;
            if (we.first >= je)
            {
                ans[i] = je;
                ++i;
                continue;
            }
            k -= we.second - i;
            node* kek = ctrlx(we.second, we.second+1);
            node* k2 = ctrlx(i, 1);
            ctrlv(kek, i);
            ctrlv(k2, i+1);
            ans[i] = we.first;
            ++i;
        }
        while (i < n)
        {
            ans[i] = mine(i, i+1).first;
            ++i;
        }
        for (ll j = 0; j < ans.size(); ++j)
        {
            cout << ans[j];
        }
        cout << '\n';
    }
}