#include <iostream>
#include <fstream>
#include <utility>
#include <vector>
#include <set>
#include <bitset>
#include <cctype>
#include <cmath>
#include <climits>
#include <algorithm>
#include <sstream>
#include <unordered_map>
#include <map>
#include <queue>
#include <unordered_set>
#include <thread>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//using namespace gnu_pbds;
using namespace std;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


#define fori(n)for (int i = 0; i < (n); ++i)
#define fo(n)for (int i = 0; i < n; i++)
#define fori1(n)for (long long i = 1; i < n+1; i++)
#define revi1(n)for (int i = n; i >=0; i--)
#define forj(n)for (long long j = 0; j < (n); j++)
#define rep(i, n)for (long long i = 0; i < (n); i++)
#define repj(i, j, n)for (long long i = j; i < (n); i++)
#define forj1(n)for (long long j = 1; j < n+1; j++)
#define revj1(n)for (long long j = n; j >=0; j--)
#define revi(n)for (int i = n-1; i >= 0; i--)
#define ll long long
#define ull unsigned long long
#define MAXN (2147483647)
#define MINN (-2147483648)
#define ffast_io ios::sync_with_stdio(false);\
                 cout.tie(nullptr); cin.tie(nullptr)

vector<vector<ll>> multi(vector<vector<ll>> a, vector<vector<ll>> b) {
    vector<vector<ll>> res(a.size(), vector<ll>(b[0].size(), 0));
    fori(a.size()) {
        forj(b[0].size()) {
            ll temp = 0;
            rep(k, b.size())temp = (temp + (a[i][k] * b[k][j]));
            res[i][j] = temp;
        }
    }
    return res;
}

vector<vector<ll>> pow(const vector<vector<ll>> &mat, int powred) {
    if (powred == 1) return mat;
    if (powred % 2 == 1) return multi(pow(mat, powred - 1), mat);
    vector<vector<ll>> temp = pow(multi(mat, mat), powred / 2);
    return temp;
}

template<typename T>
void debug(T ttt[], std::ostream &out = std::cout) {
    for (auto it = ttt; it != ttt; ++it) out << *it << ' ';
    out << std::endl;
}

void debug(int *ttt[], std::ostream &out = std::cout) {
    for (auto it = ttt; it != ttt; ++it) debug(*it);
    out << std::endl;
}

template<typename T>
void debug(const std::vector<T> &ttt, std::ostream &out = std::cout) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) out << *it << ' ';
    out << std::endl;
}

template<typename T>
void debug(const std::vector<vector<T>> &ttt, std::ostream &out = std::cout) {
    for (int it = 0; it != ttt.size(); ++it) debug(ttt[it]);
}

template<typename K, typename V>
void debug(const std::map<K, V> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) std::cout << it->first << ": " << it->second << ' ';
    std::cout << std::endl;
}

template<typename K, typename V>
void debug(const std::unordered_map<K, V> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) std::cout << it->first << ": " << it->second << ' ';
    std::cout << std::endl;
}

template<typename K, typename V>
void debug(const std::unordered_map<K, vector<V>> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) {
        std::cout << it->first << ": ";
        debug(it->second);
    }
    std::cout << std::endl;
}

void debug(std::deque<int> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) {
        std::cout << *it + 1 << " ";
    }
    std::cout << std::endl;
}

template<typename T>
void debug(set<T> ttt, std::ostream &out = std::cout) {
    for (auto t: ttt) out << t << " ";
    out << endl;
}

//void debug(bool k, std::ostream &out = std::cout) { if (k) out << "yes"; else out << "no"; }

//ll power(int base, int exponent) {
//    if (exponent == 0) return 1;
//    ll half = power(base, exponent / 2);
//    ll result = half * half;
//    if (exponent % 2 != 0) result *= base;
//    return result;
//}

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,tune=native")

/*
    ___                         ______                  _____


Айзат Кашапов, [21.10.2024 23:42]
/   | _____/ /___  ______ _/ /  / ____/___  ____/ /     / ___// /_____ ______/ /______   / / / /  ________
  / /| |/ ___/ / / / /  / /  / /   / __ \/ __  / _ \    \__ \/ __/ __ / ___/ / ___/  / /_/ / _ \/ ___/ _ \
 / ___ / // /_/ /_/ / /_/ / /  / /___/ /_/ / /_/ /  /   ___/ / /_/ /_/ / /  / /_(  )  /   /  / /  /  /
/_/  |_\___/\/\__,_/\__,_/_/   \____/\____/\__,_/\___/   /____/\__/\__,_/_/   \__/____/  /_/ /_/\___/_/   \___/

*/

bool is_cicle = false;

void dfsik(long long vertex_now, std::vector<std::vector<long long>> &graph, std::vector<bool> &visited) {
    visited[vertex_now] = true;
    std::vector<long long> row = graph[vertex_now];
    for (auto i : row) {
        if (!visited[i]) {
            dfsik(i, graph, visited);
        }
    }

}

bool is_stupid = false;
void dfs(ll begin_vertex, ll vertex_now, ll pref,  std::vector<std::vector<ll>> &graph, std::vector<std::vector<ll>> & matrix, std::vector<bool> &visited) {
    if (is_stupid) return;
    if (matrix[begin_vertex][vertex_now] != matrix[pref][vertex_now] + matrix[begin_vertex][pref]) {
        is_stupid = true;
        return;
    }

    visited[vertex_now] = true;
    std::vector<long long> row = graph[vertex_now];
    for (auto i : row) {
        if (!visited[i]) {
            dfs(begin_vertex, i, vertex_now, graph, matrix, visited);
        } else {
            is_cicle = true;
            return;
        }
    }

}

//first is index
ll max_in(std::vector<ll>& row) {
    ll maxi = -2, index = -1;
    for (int i = 0; i < row.size(); ++i) {
        if (row[i] == -1 or row[i] == 0) continue;
        if (row[i] > maxi) {
            maxi = row[i];
            index = i;
        }

    }
    return index;
 }

//first is index
ll min_in(std::vector<ll>& row) {
    ll mini = 10000000000, index = -1;
    for (int i = 0; i < row.size(); ++i) {
        if (row[i] == -1 or row[i] == 0) continue;
        if (row[i] < mini) {
            mini = row[i];
            index = i;
        }

    }
    return index;
}

int main() {
    ll n, p;
    std::cin >> n;
    std::vector<std::vector<ll>> matrix;
    std::vector<std::vector<ll>> second_matrix;
    std::vector<ll> row;
    for(int i = 0; i < n; ++i) {
        matrix.push_back(row);
        second_matrix.push_back(row);
        for (int j = 0; j < n; ++j) {
            std::cin >> p;
            matrix[i].push_back(p);
            second_matrix[i].push_back(p);
        }
    }

    std::vector<std::vector<ll>> graph;
    for (int i = 0; i < n; ++i) {
        graph.push_back(row);
    }

    for (int i = 0; i < n; ++i) {
        while(true) {
//            for (int j = 0; j < n; ++j) {
//                for (auto z : second_matrix[j]) {
//                    std::cout << z << " ";
//                }
//                std::cout << "\n";
//            }
//            std::cout <<"-----------------------\n";

            ll index = max_in(second_matrix[i]) ;
            if (index == -1) break;

            //нашли максимум - значит это лист, давайте найдём в листе минимум, сложим ребро в граф
            ll index_min = min_in(second_matrix[index]);
            if (index_min == -1) break;

            graph[index_min].push_back(index);
            graph[index].push_back(index_min);
            for (int j = 0; j < n; ++j) {
                second_matrix[j][index] = -1;
                second_matrix[index][j] = -1;
            }
        }

    }

//    for (int i = 0; i < n; ++i) {
//        for (auto j : graph[i]) {
//            std::cout << j << " ";
//        }
//        std::cout << "\n";
//    }

    std::vector<bool> visited;
    std::vector<ll> stack;
    for (int i = 0; i < n; ++i) {
        visited.push_back(false);
    }



    ll counter = 0;
    for (int i = 0; i < n; ++i) {
        for (auto j : graph[i]) {
            ++counter;
        }
    }
    if (counter != 2 * n - 2) {
        std::cout << "No";
        return 0;
    }

    dfsik(0, graph, visited);
    for (auto i : visited) {
        if (!i) {
            std::cout << "No";
            return 0;
        }
    }

    for (int i = 0; i < n; ++i) {
        visited[i] = false;
    }

    for (int i = 0; i <n; ++i) {
        dfs(i, i, i, graph, matrix, visited);
        for (int j = 0; j < n; ++j) {
            visited[j] = false;
        }
    }

    if (is_stupid) {
        std::cout << "No";
        return 0;
    }

    std::cout << "Yes";
    return 0;
}

