#include <iostream>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <queue>
#include <random>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>
#include <deque>

using namespace std;

long long mod = 1e9 + 7;

// random_device rd;
// mt19937 gen(rd());

// long long binPow(long long a, long long p)
// {
//     if (p == 0 || a == 1) {return 1;}
//     a %= mod;
//     if (p % 2 == 0) {return binPow(a * a % mod, p / 2) % mod;}
//     return (a * binPow(a, p - 1)) % mod;
// }

template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p);

template<class T>
istream& operator>> (istream& in, vector<T>& vec)
{
    for (T& i: vec) {in >> i;}
    return in;
}

template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

int kkk(const string& str)
{
    int ans = 0;
    for (int i = 0; i < str.size(); ++i)
    {
        if (str[str.size() - i] == '1')
        {
            ans = ans + (1 << i);
        }
    }
    return ans;
}

void solve()
{
    map<int, int> mp =
    {
        {kkk("1110111"), 0},
        {kkk("0010010"), 1},
        {kkk("1011101"), 2},
        {kkk("1011011"), 3},
        {kkk("0111010"), 4},
        {kkk("1101011"), 5},
        {kkk("1101111"), 6},
        {kkk("1010010"), 7},
        {kkk("1111111"), 8},
        {kkk("1111011"), 9}
    };
    map<int, int> mp_rev =
    {
        {0, kkk("1110111")},
        {1, kkk("0010010")},
        {2, kkk("1011101")},
        {3, kkk("1011011")},
        {4, kkk("0111010")},
        {5, kkk("1101011")},
        {6, kkk("1101111")},
        {7, kkk("1010010")},
        {8, kkk("1111111")},
        {9, kkk("1111011")}
    };
    string a, b;
    cin >> a >> b;
    int a1 = kkk(a), b1 = kkk(b);
    int ans = 0;
    for (int i = 1; i <= 99; ++i)
    {
        int c2 = i;
        int c1 = 0;
        if (i >= 10)
        {
            int l = mp_rev[i / 10] & a1;
            int r = mp_rev[i % 10] & b1;
            if (mp.find(l) != mp.end() && mp.find(r) != mp.end())
            {
                c1 = mp[l] * 10 + mp[r];
            }
            else
            {
                continue;
            }
        }
        while(c1 > 0 && c2 < 99)
        {
            if (c2 + 1 >= 10)
            {
                int l = mp_rev[(c2 + 1) / 10] & a1;
                int r = mp_rev[(c2 + 1) % 10] & b1;
                if (mp.find(l) != mp.end() && mp.find(r) != mp.end() && mp[l] * 10 + mp[r] == c1 - 1)
                {
                    ++c2;
                    --c1;
                }
                else
                {
                    break;
                }
            }
            else
            {
                int r = mp_rev[(c2 + 1)] & b1;
                if (mp.find(r) != mp.end() && mp[r] == c1 - 1)
                {
                    ++c2;
                    --c1;
                }
                else
                {
                    break;
                }
            }
        }
        ans = max(ans, c2 - i);
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;

    for (;t > 0; --t)
    {
        solve();
    }
}