#include <iostream>
#include <cmath> //   abs
using namespace std;

struct coord {
    short x;
    short y;
};
double triangleArea(coord& A, coord& B, coord& C) {
    return fabs(A.x * (B.y - C.y) + B.x * (C.y - A.y) + C.x * (A.y - B.y)) / 2.0;
}

int main() {
    short n; //  
    cin >> n;

    coord* arr = new coord[n];

    //   
    for (short i = 0; i < n; i++) {
        cin >> arr[i].x >> arr[i].y;
    }

    short maxX = -32768; //    short
    short minX = 32767;  //    short
    coord* maxPoint=nullptr; //    x
    coord* minPoint=nullptr; //    x

    //     x     Ox
    for (short i = 0; i < n; i++) {
        if (arr[i].y == 0) { // ,     Ox
            if (arr[i].x > maxX) {
                maxX = arr[i].x; //   
                maxPoint = &arr[i]; //  
            }
            if (arr[i].x < minX) {
                minX = arr[i].x; //   
                minPoint = &arr[i]; //  
            }
        }
    }

    //         Ox
    short dist = 0;
    if (maxX == -32768 && minX == 32767) {
        cout << 0 << endl;
    }
    else {
        dist = abs(maxX - minX); //   

    }
    if (dist == 0)
    {
        cout << dist << endl;
        return 0;
    }
    double area = 0, marea = 0;

    //    
    for (short i = 0; i < n; i++) {
        if (arr[i].y != 0) { // ,      Ox
            area = triangleArea(*maxPoint, *minPoint, arr[i]);
            if (area > marea) {
                marea = area;
            }
        }
    }

    cout << marea << endl;

    delete[] arr; //  
    return 0;
}