﻿#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

int n;
vector<int> score;
vector<bool> been;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    else {
        return gcd(b, a % b);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    score.resize(n);
    been.resize(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> score[i];
    }
    int f, s;
    cin >> s >> f;
    s--; f--;
    int last = 1;

    vector<pair<int, int>> ans;
    if (s > f) {
        int v = s - 1;
        last = abs(score[s] - score[v]);
        while (last == 0 && v != f) {
            int v2 = v - 1;
            last = abs(score[v2] - score[v]);
            v = v2;
        }
        if (v == f) {
            ans.push_back({ s, 0 });
            ans.push_back({ v, 2 });
        }
        else {
            ans.push_back({ s, 0 });
            ans.push_back({ v, last });
            if (last == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            while (v != f) {
                int v2 = v - 1;
                int ab = abs(score[v2] - score[v]);
                if (ab == 1) {
                    cout << "Impossible" << endl;
                    return 0;
                }
                last = gcd(last, ab);
                if (last == 1) {
                    ans.push_back({ v2, ab });
                    last = ab;
                }
                else {
                    ans[ans.size() - 1] = { v2, last };
                }
                v = v2;
            }
        }
    }
    else {
        int v = s + 1;
        last = abs(score[s] - score[v]);
        while (last == 0 && v != f) {
            int v2 = v + 1;
            last = abs(score[v2] - score[v]);
            v = v2;
        }
        if (v == f) {
            ans.push_back({ s, 0 });
            ans.push_back({ v, 2 });
        }
        else {
            ans.push_back({ s, 0 });
            ans.push_back({ v, last });
            if (last == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            while (v != f) {
                int v2 = v + 1;
                int ab = abs(score[v2] - score[v]);
                if (ab == 1) {
                    cout << "Impossible" << endl;
                    return 0;
                }
                last = gcd(last, ab);
                if (last == 1) {
                    ans.push_back({ v2, ab });
                    last = ab;
                }
                else {
                    ans[ans.size() - 1] = { v2, last };
                }
                v = v2;
            }
        }
    }
    for (int i = 0; i + 1 < ans.size(); i++) {
        cout << "Kaban-" << ans[i + 1].second << ' ' << ans[i].first  + 1<< ' ' << ans[i + 1].first + 1 << endl;
    }
    return 0;
}