﻿#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

int n;
vector<int> par_v;
vector<vector<int>> w; 
vector<vector<pair<int, int>>> g_2;
int max_par(int v1) {
    if (par_v[v1] != -1) {
        par_v[v1] = max_par(par_v[v1]);
        return par_v[v1];
    }
    return v1;
}
vector<bool> been;
bool dfs(int v, long long len, int st_v) {
    been[v] = 1;
    if (w[st_v][v] != len) {
        return false;
    }
    for (pair<int, int> i : g_2[v]) {
        if (!been[i.first]) {
            if (!dfs(i.first, len + i.second, st_v)) {
                return false;
            }
        }
    }
    return true;
}


int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    int m = n * (n - 1) / 2;
    vector<vector<int>> g(m, vector<int>(3));
    w.resize(n, vector<int>(n, 0));
    par_v.resize(n, -1);
    int numb = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> w[i][j];
            if (i < j) {
                g[numb][0] = w[i][j];
                g[numb][1] = i;
                g[numb][2] = j;
                numb++;
            }
        }
    }
    sort(g.begin(), g.end());
    g_2.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        c = g[i][0];
        a = g[i][1];
        b = g[i][2];
        int v1 = max_par(a);
        int v2 = max_par(b);
        if (v1 != v2) {
            g_2[a].push_back({ b, c });
            g_2[b].push_back({ a, c });
            par_v[v2] = v1;
        }
    }

    been.resize(n, 0);
    for (int i = 0; i < n; i++) {
        bool b = dfs(i, 0, i);
        if (!b) {
            cout << "NO" << endl;
            return 0;
        }
        been.assign(n, 0);
    }
    cout << "YES" << endl;
    return 0;
}