#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <climits>
#include <iomanip>

using namespace std;

typedef long long int ll;
typedef long double ld;
struct Point {
    ld x;
    ld y;
};

void solve() {
    ll n; cin >> n;
    ld mmin = LONG_MAX, mmax = LONG_MIN;
    vector<Point> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        if (a[i].y == 0) {
            mmin = min(a[i].x, mmin);
            mmax = max(a[i].x, mmax);
        }
    }
    if (mmin == mmax || mmin == LONG_MAX || mmax == LONG_MIN) {
        cout << "0\n";
        return;
    }
    ld ans = 0, osn = mmax - mmin;
    for (ll i = 0; i < n; i++) {
        ans = max(ans, osn * (abs(a[i].y))/2);
    }
    cout <<fixed << setprecision(11) << ans << '\n';
}

int main() {
    solve();
}
