import itertools


def triag_sum(a, b, c):
    return 0.5 * abs((b[0] - a[0]) * (c[1] - a[1]) - (c[0] - a[0]) * (b[1] - a[1]))


n = int(input())
axis_points = []
other_points = []
for _ in range(n):
    point = tuple((int(i) for i in input().split()))
    if point[1] == 0:
        axis_points.append(point)
    else:
        other_points.append(point)

max_ = 0
for a, b in itertools.combinations(axis_points, 2):
    for c in other_points:
        sum_ = triag_sum(a, b, c)
        if sum_ > max_:
            max_ = sum_
print(max_)
