import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Triangle {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        List<int[]> points = new ArrayList<>();

        for (int i = 0; i < n; i++) {
            int x = scanner.nextInt();
            int y = scanner.nextInt();
            points.add(new int[]{x, y});
        }

        List<int[]> basePoints = new ArrayList<>();
        for (int[] point : points) {
            if (point[1] == 0) {
                basePoints.add(point);
            }
        }

        double maxArea = 0.0;
        for (int i = 0; i < basePoints.size(); i++) {
            for (int j = i + 1; j < basePoints.size(); j++) {
                int x1 = basePoints.get(i)[0];
                int x2 = basePoints.get(j)[0];

                for (int[] point : points) {
                    if (point[1] != 0) {
                        double height = Math.abs(point[1]);
                        double area = 0.5 * Math.abs(x1 - x2) * height;
                        maxArea = Math.max(maxArea, area);
                    }
                }
            }
        }

        System.out.println(maxArea);
        scanner.close();
    }
}
