#include<iostream>
#include<algorithm>
#include<set>
#include<vector>
#include<cmath>
#include<map>
#define fr first
#define sc second
#define pb push_back
#define all(x) x.begin(), x.end()
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
const ll mod = 1e10 + 9;
struct segtree {
	ll size = 1;
	vector<int> tree;
	void resize(ll n) {
		while (size < n)size *= 2;
		tree.resize(2 * size, 0);
	}
	void add(int i) {
		tree[size + i] = 1;
		int n = size + i;
		while (n)n /= 2, tree[n] = tree[n * 2] + tree[n * 2 + 1];
	}
	int sum(int l, int r, int& l0, int& r0, int i) {
		if (l0 <= l && r0 >= r) return tree[i];
		if (l >= r0 || r <= l0)return 0;
		return sum(l, (l + r) / 2, l0, r0, i * 2) + sum((l + r) / 2, r, l0, r0, i * 2 + 1);
	}
	int sum(int l, int r) {
		return sum(0, size, l, r, 1);
	}
};
void solve() {
	string s; ll k; cin >> s >> k; int n = s.size();
	segtree seg; seg.resize(n);
	vector<int> num(n); for (int i = 0; i < n; i++)num[i] = s[i] - '0';
	vector<int>posn(10);
	vector<vector<int>> pos(n, vector<int>(10, -1));
	for (int i = n - 2; i >= 0; i--)
		pos[i] = pos[i + 1], pos[i][num[i + 1]] = i + 1;
	posn = pos[0]; posn[num[0]] = 0;
	string ans = "";
	vector<char> used(n, 0);
	for (int i = 0; i < n; i++) {
		char add = s[i];
		if (used[i])continue;
		for (int j = 1; j < 9; j++) {
			int s = seg.sum(i, posn[j]);
			if (j < num[i] && posn[j] - i - s <= k && posn[j] != -1) {
				k -= posn[j] - i - s;
				used[posn[j]] = 1;
				seg.add(posn[j]);
				add = char(j + '0');
				i--;
				break;
			}
		}
		posn[add-'0'] = posn[add-'0'] == -1 ? -1 : pos[posn[add-'0']][add-'0'];
		ans += add;
	}
	cout << ans << "\n";
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed; cout.precision(7);
	int t = 1;
	cin >> t;
	while (t--)solve();
	return 0;
}