# def f(r, b, g, prev):
#     if r < 0 or b < 0 or g < 0:
#         return 0
#     if r == 0 and b == 0 and g == 0:
#         return 1
#     if prev == 'r':
#         return f(r, b - 1, g, 'b') + f(r, b, g - 1, 'g')
#     if prev == 'b':
#         return f(r - 1, b, g, 'r') + f(r, b, g - 1, 'g')
#     if prev == 'g':
#         return f(r - 1, b, g, 'r') + f(r, b - 1, g, 'b')
 
 
# def totalWays(r, b, g):
#     return f(r - 1, b, g, 'r') + f(r, b - 1, g, 'b') + f(r, b, g - 1, 'g')


# r, b, g = map(int, input().split())
# print(totalWays(r, b, g))

from collections import deque

def totalWays(r, b, g):
    # Стартовые состояния
    queue = deque([(r - 1, b, g, 'r'), (r, b - 1, g, 'b'), (r, b, g - 1, 'g')])
    count = 0

    while queue:
        curr_r, curr_b, curr_g, prev_color = queue.popleft()

        # Базовый случай: все шары расставлены
        if curr_r == 0 and curr_b == 0 and curr_g == 0:
            count += 1
            continue

        # Ограничивающие случаи: недопустимые состояния
        if curr_r < 0 or curr_b < 0 or curr_g < 0:
            continue

        # Добавление новых состояний в очередь
        if prev_color == 'r':
            queue.append((curr_r, curr_b - 1, curr_g, 'b'))
            queue.append((curr_r, curr_b, curr_g - 1, 'g'))
        elif prev_color == 'b':
            queue.append((curr_r - 1, curr_b, curr_g, 'r'))
            queue.append((curr_r, curr_b, curr_g - 1, 'g'))
        elif prev_color == 'g':
            queue.append((curr_r - 1, curr_b, curr_g, 'r'))
            queue.append((curr_r, curr_b - 1, curr_g, 'b'))

    return count

# Чтение входных данных
r, b, g = map(int, input().split())

# Вывод результата
print(totalWays(r, b, g) % 998_244_353)