import heapq
def f_min(s, k):
    n = len(s)
    s = list(s)
    for i in range(n):
        min_pos = i
        heap = []
        for j in range(i + 1, min(n, i + k + 1)):
            heapq.heappush(heap, (s[j], j))
        while heap:
            min_val, min_pos = heapq.heappop(heap)
            if min_pos - i <= k:
                break
        if min_pos != i:
            k -= (min_pos - i)
            s.insert(i, s.pop(min_pos))
    return ''.join(s)
def inp(inp):
    res = []
    for s, k in inp:
        res.append(f_min(s, k))
    return res
t = int(input().strip())
inputs = []
for _ in range(t):
    s, k = input().strip().split()
    k = int(k)
    inputs.append((s, k))
results = inp(inputs)
for result in results:
    print(result)