#include <iostream>
#include <string>
#include <algorithm>

std::string minimize_number(std::string s, int k) {
    int n = s.length();

    for (int i = 0; i < n; ++i) {
        if (k <= 0) {
            break;
        }

        int max_index = std::min(i + k, n - 1);

        // Находим минимальную цифру в диапазоне
        char min_digit = *std::min_element(s.begin() + i, s.begin() + max_index + 1);
        int min_index = std::find(s.begin() + i, s.begin() + max_index + 1, min_digit) - s.begin();

        if (min_index == i) {
            continue;
        }

        // Перемещаем минимальную цифру к позиции i, используя соседние обмены
        while (min_index > i) {
            std::swap(s[min_index], s[min_index - 1]);
            min_index--;
            k--;
            if (k <= 0) {
                break;
            }
        }
    }

    return s;
}

int main() {
    int n;
    std::cin >> n;
    for (int x = 0; x < n; ++x) {
        std::string s;
        int k;
        std::cin >> s >> k;
        std::string result = minimize_number(s, k);
        std::cout << result << std::endl;
    }
    return 0;
}