#include<bits/stdc++.h>

using namespace std;

int n;
void config_io()
{
    cin.tie(NULL);
    cout.tie(NULL);
    cout.sync_with_stdio(false);
    //freopen("output.txt", "w", stdout);
    //freopen("input.txt", "r", stdin);
}

int find_root(int v, vector<int>& a){
    if(a[v] != v){
        return find_root(a[v], a);
    }
    return v;
}

void union_roots(int a, int b, vector<int>& v){
    if(rand() % 2 == 1){
        swap(b, a);
    }
    v[a] = b;

}

void dfs(int r, int v, int p, int d, vector<vector<int>>& a, vector<vector<int>>& b){
    if(d != b[r][v]){
        cout << "No";
        exit(0);
    }
    for(int i = 0; i < n; i++){
        if(a[v][i] != -1 && i != p){
            dfs(r, i, v, d+a[v][i], a, b);
        }
    }
}




void sol(){
    cin >> n;
    vector<vector<int>> t(n);
    vector<vector<int>> m(n);
    vector<int> t1(n);
    vector<int> tmp(n);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            cin >> tmp[j];
            t1[j] = -1;
        }
        t[i] = tmp;
        m[i] = t1;
    }

   vector<int> root(n);
   for(int i = 0; i < n; i++){
    root[i] = i;
   }

   vector<pair<int, pair<int, int>>> vert;

   for(int i = 0; i < n-1; i++){
    for(int j = i+1; j < n; j++){
        vert.push_back({t[i][j], {i, j}});
    }
   }

   sort(vert.begin(), vert.end());

   for(auto x: vert){
    if(find_root(x.second.first, root) != find_root(x.second.second, root)){
        m[x.second.first][x.second.second] = m[x.second.second][x.second.first] = x.first;
        union_roots(find_root(x.second.first, root), find_root(x.second.second, root), root);

    }
   }

   for(int i = 0; i < n; i++){
    dfs(i, i, -1, 0, m, t);
   }
   cout << "Yes";

};

int main(){
    config_io();
    sol();
}