import math
def find_min_hours(t, test_cases):
    results = []
    for n, k in test_cases:
        hours = 0
        count = 1
        while count < n and hours < k + 1:
            count *= 2
            hours += 1
        if count < n:
            hours += math.ceil((n - count) / (k + 1))
        results.append(hours)
    return results

t = int(input().strip())
test_cases = [tuple(map(int, input().strip().split())) for _ in range(t)]
print("\n".join(map(str, find_min_hours(t, test_cases))))
