def minimize_number(s, k):
    s = list(s)
    n = len(s)

    for i in range(n):
        if k <= 0:
            break

        pos = i
        for j in range(i + 1, min(n, i + k + 1)):
            if s[j] < s[pos]:
                pos = j

        for j in range(pos, i, -1):
            s[j], s[j - 1] = s[j - 1], s[j]

        k -= (pos - i)

    return ''.join(s)


t = int(input())

results = []
for _ in range(t):
    s, k = input().split()
    k = int(k)

    results.append(minimize_number(s, k))

for result in results:
    print(result)
