﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

string find_minimum_number(string s, long long k) {
    int n = s.length();
    vector<int> min_num(n);
    for (int i = 0; i < n; i++) {
        min_num[i] = s[i] - '0';
    }
    if (k > 0)
    {
        for (int i = 0; i < n - 1; i++) {
            if (min_num[i] > min_num[i + 1] && k > 0) {
                swap(min_num[i], min_num[i + 1]);
                k--;
                i = 0;
            }
        }
    }
   
    string result = "";
    for (int i = 0; i < n; i++) {
        result += to_string(min_num[i]);
    }
    return result;
}

int main() {
    long long t;
    vector<string> otvet;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        otvet.push_back(find_minimum_number(s, k));
    }
    for (auto i : otvet)
    {
        cout << i << endl;
    }

    return 0;
}