import heapq 
 
def minimize_number_with_swaps(s, k): 
    digits = list(s) 
    n = len(digits) 
     
    for i in range(n): 
        if k <= 0: 
            break 
 
        min_digit = digits[i] 
        min_idx = i 
         
        for j in range(i + 1, min(i + k + 1, n)): 
            if digits[j] < min_digit: 
                min_digit = digits[j] 
                min_idx = j 
         
        if min_idx == i: 
            continue 
 
        for j in range(min_idx, i, -1): 
            digits[j] = digits[j - 1] 
        digits[i] = min_digit 
         
        k -= (min_idx - i) 
 
    return ''.join(digits) 
 
t = int(input().strip()) 
results = [] 
for _ in range(t): 
    s, k = input().strip().split() 
    k = int(k) 
    result = minimize_number_with_swaps(s, k) 
    results.append(result) 
 
print('\n'.join(results))
