import heapq

def minimize_number_with_swaps(s, k):
    digits = list(s)
    n = len(digits)
    
    heap = []
    
    for i in range(n):
        heapq.heappush(heap, (digits[i], i))
        
        if len(heap) > k + 1:
            heapq.heappop(heap)
        
        if heap:
            min_digit, min_idx = heapq.heappop(heap)
            if min_idx != i:

                digits[min_idx:i+1] = [digits[j] for j in range(min_idx, i)] + [min_digit]
                k -= (min_idx - i)
                

                if k <= 0:
                    break
                

            heapq.heappush(heap, (min_digit, i))

    return ''.join(digits)

t = int(input().strip())
results = []
for _ in range(t):
    s, k = input().strip().split()
    k = int(k)
    result = minimize_number_with_swaps(s, k)
    results.append(result)

print('\n'.join(results))
