def minimize_number_with_swaps(s, k): 
    digits = list(s) 
    n = len(digits) 
     
    i = 0 
    while i < n and k > 0: 
        min_idx = i 
        for j in range(i + 1, min(i + k + 1, n)): 
            if digits[j] < digits[min_idx]: 
                min_idx = j 
 
        if min_idx != i: 
            min_digit = digits[min_idx] 
            for j in range(min_idx, i, -1): 
                digits[j] = digits[j - 1] 
            digits[i] = min_digit 
            k -= (min_idx - i) 
         
        i += 1 
 
    return ''.join(digits) 
 
t = int(input().strip()) 
results = [] 
for _ in range(t): 
    s, k = input().strip().split() 
    k = int(k) 
    results.append(minimize_number_with_swaps(s, k)) 
 
print('\n'.join(results))