#include <iostream>
#include <vector>
#include <string>

using namespace std;

string minimize_number(string s, int k) {
    int l = s.length();
    
    for (int i = 0; i < l; ++i) {
        if (k <= 0) {
            break;
        }
        
        int min_index = i;
        for (int j = i + 1; j < min(l, i + k + 1); ++j) {
            if (s[j] < s[min_index]) {
                min_index = j;
            }
        }
        
        if (min_index != i) {
            char min_digit = s[min_index];
            for (int j = min_index; j > i; --j) {
                s[j] = s[j - 1];
            }
            s[i] = min_digit;
            k -= (min_index - i);
        }
    }
    
    return s;
}

int main() {
    int t;
    cin >> t;
    cin.ignore();
    vector<string> results;

    for (int i = 0; i < t; ++i) {
        string line;
        getline(cin, line);
        size_t last_space = line.find_last_of(' ');
        string s = line.substr(0, last_space);
        int k = stoi(line.substr(last_space + 1));
        string result = minimize_number(s, k);
        results.push_back(result);
    }

    for (const string& res : results) {
        cout << res << endl;
    }

    return 0;
}