# digit = [0]*7
digitArr = [
    [1, 1, 1, 0, 1, 1, 1],  # 0
    [0, 0, 1, 0, 0, 1, 0],  # 1
    [1, 0, 1, 1, 1, 0, 1],  # 2
    [1, 0, 1, 1, 0, 1, 1],
    [0, 1, 1, 1, 0, 1, 0],
    [1, 1, 0, 1, 0, 1, 1],
    [1, 1, 0, 1, 1, 1, 1],
    [1, 0, 1, 0, 0, 1, 0],
    [1, 1, 1, 1, 1, 1, 1],
    [1, 1, 1, 1, 0, 1, 1]  # 9
]

noDigit = [0, 0, 0, 0, 0, 0, 0]

hundredArr = []
hundredArr.append([noDigit, digitArr[1]])
hundredArr.append([noDigit, digitArr[2]])
hundredArr.append([noDigit, digitArr[3]])
hundredArr.append([noDigit, digitArr[4]])
hundredArr.append([noDigit, digitArr[5]])
hundredArr.append([noDigit, digitArr[6]])
hundredArr.append([noDigit, digitArr[7]])
hundredArr.append([noDigit, digitArr[8]])
hundredArr.append([noDigit, digitArr[9]])

for i in range(10, 100):
    spl1, spl2 = map(int, str(i))

    hundredArr.append([digitArr[spl1], digitArr[spl2]])


def convert_strings_to_array(str1, str2):
    list1 = [int(char) for char in str1]
    list2 = [int(char) for char in str2]

    return [list1, list2]

def bitwise_and_arrays(array1, array2):
    # Выполняем побитовое AND для каждого элемента массива
    return [[a & b for a, b in zip(row1, row2)] for row1, row2 in zip(array1, array2)]

def compare_arrays_with_bit_and(array1, array2, array3):
    # Выполняем побитовое AND для первого и второго массива
    and_result = bitwise_and_arrays(array1, array2)
    # Сравниваем получившийся массив с третьим массивом
    return and_result == array3

str1 = input()
str2 = input()

inputArray = convert_strings_to_array(str1, str2)

maxAns = 0

for i in range(len(hundredArr)):
    for j in range(len(hundredArr)):
        if compare_arrays_with_bit_and(hundredArr[i-1], inputArray, hundredArr[j-1]):
            tekAns = 0
            # print(i,j,"***")
            ii = i-1
            jj = j+1
            if ii<0 or jj>=len(hundredArr):
                continue

            while compare_arrays_with_bit_and(hundredArr[ii-1], inputArray, hundredArr[jj-1]):
                tekAns +=1
                maxAns = max(maxAns, tekAns)
                ii-=1
                jj+=1

                # print(hundredArr[i-1])
                # print(hundredArr[j-1])
                # print(ii,jj,"---")


            # print(hundredArr[i-1])
            # print(hundredArr[j-1])
            # print(i,j,"---")

print(maxAns)