#include <iostream>
#include <cmath>
#include <utility>
#include <ios>
#include <vector>

#define ll long long

using namespace std;

int main(int argc, char** argv)
{
	cout << fixed;

	ll n;
	vector<vector<ll>> matrix;

	cin >> n;

	matrix.resize(n);

	for (auto i = 0; i < n; ++i)
	{
		auto& row = matrix[i];
		row.reserve(n);
		for (auto j = 0; j < n; ++j)
		{
			ll d;
			cin >> d;
			row.push_back(d);
		}
	}

	bool is_true{ true };

	for (auto i = 0; i < n; ++i)
	{
		for (auto j = i + 1; j < n - 1; ++j)
		{
			for (auto k = j + 1; k < n; ++k)
			{
				if (matrix[i][j] + matrix[i][k] < matrix[j][k]
					|| matrix[j][k] + matrix[i][j] < matrix[i][k]
					|| matrix[i][k] + matrix[j][k] < matrix[i][j])
				{
					is_true = false;
					break;
				}
			}
			if (!is_true)
				break;
		}
		if (!is_true)
			break;
	}

	if (n == 1)
		cout << "No";
	else
	{
		if (is_true)
			cout << "Yes";
		else
			cout << "No";
	}

	return 0;
}

