def min_number(t, test_cases):
    results = []

    for s, k in test_cases:
        n = len(s)
        s_list = list(s)
        
        cur_pos = 0  
        while k > 0 and cur_pos < n:
            min_pos = cur_pos
            for j in range(cur_pos + 1, min(n, cur_pos + k + 1)):
                if s_list[j] < s_list[min_pos]:
                    min_pos = j
            
            if min_pos != cur_pos:
                moves_needed = min_pos - cur_pos

                min_char = s_list[min_pos]
                for j in range(min_pos, cur_pos, -1):
                    s_list[j] = s_list[j - 1]

                s_list[cur_pos] = min_char
                k -= moves_needed
            
            cur_pos += 1

        results.append(''.join(s_list))

    return results

t = int(input())
test_cases = []

for _ in range(t):
    s, k = input().split()
    k = int(k)
    test_cases.append((s, k))

results = min_number(t, test_cases)

for result in results:
    print(result)
