﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int min(long long a, int b)
{
    if (a < b)
    {
        return a;
    }
    else
    {
        return b;
    }
}


int main()
{
    int t; // количество наборов
    cin >> t;
    while (t--)
    {
        string s;
        long long k;
        cin >> s >> k;
        int n = s.size();

        for (int i = 0; i < n && k > 0; ++i)
        {
            char minChar = '9' + 1; // начинаем с символа больше 9
            int minPos = i;

            // Поиск минимальной цифры в пределах диапазона
            for (int j = i; j < min(i + k + 1, n); ++j)
            {
                if (s[j] < minChar)
                {
                    minChar = s[j];
                    minPos = j;
                }
            }

            // Проверьте, необходимо ли что-то менять
            if (minPos != i)
            {
                // Мы должны выполнить (minPos - i) обменов
                long long swapsNeeded = minPos - i;
                k -= swapsNeeded;

                // Сдвигаем минимальную цифру на i-ую позицию
                for (int j = minPos; j > i; --j)
                {
                    swap(s[j], s[j - 1]);
                }
            }
        }
        cout << s << endl; // выводим результат
    }
    return 0;
}
