#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

#define int long long

int f(int n, int k) {
  if (n <= 1) {
    return 0;
  }
  if (k == 0) {
    return n - 1;
  }
  static map<pair<int, int>, int> mem;
  if (mem.count({n, k})) {
    return mem[{n, k}];
  }
  int& res = mem[{n, k}];
  res = n;
  for (int a = 1; a <= n - 1; ++a) {
    res = min(res, max(f(a, k - 1), f(n - a, k)) + 1);
  }
  return res;
}

void run_solve() {
  // int k = 1;
  // for (int n = 1; n <= 100; ++n) {
  //   cout << n << '\t' << k << '\t' << f(n, k) << '\n';
  // }
  int t;
  cin >> t;
  while (t--) {
    int n, k;
    cin >> n >> k;
    // cout << f(n, k) << '\n';
    if (n == 1) {
      cout << 0 << '\n';
    } else if (k > 60) {
      n -= 1;
      int t = 1;
      int ans = 1;
      while (n > t) {
        ++ans;
        n -= t;
        t *= 2;
      }
      cout << ans << '\n';
    } else {
      --n;
      vector<int> t(k + 1, 1);
      int ans = 1;
      while (n > t[k]) {
        ++ans;
        n -= t[k];
        for (int i = k; i > 0; --i) {
          t[i] = t[i] + t[i - 1];
        }
      }
      cout << ans << '\n';
    }
  }
}