#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <iomanip>
#include <set>
using namespace std;
#define int long long
int mod=998244353;
int mul(int a, int b){
return (a*b)%mod;
}
int fastpow(int a,int b)
{
    if(a==0){return 0;}
    if(b==0){return 1;}
    if(b==1){return a;}
    int c=fastpow(a,b/2);
    if(b%2==0)
    {
        return (c*c)%mod;
    }
    return (((c*c)%mod)*a)%mod;
}
int C(int n,int k,vector<int> &fact)
{
    if(n<k) return 0;
    if(n==0 && k==0) return 1;
    return (mul(fact[n],fastpow(( mul((fact[k]),fact[n-k]))%mod,mod-2)))%mod;
}
int sum(int a, int b){
return (a+b)%mod;
}

signed main()
{
    vector<int> fact(400000);
    fact[0]=1;
    for(int i=1;i<400000;i++)
    {
        fact[i]=mul(fact[i-1],i);
    }
    //cout<<C(5,0,fact);
    int a, b, c;
    cin>>a>>b>>c;
    int n=a+b+c;
    int s = n-a;
    int d = abs(c-b);
    int ans1=0;
    int ans2=0;
    int ans3=0;
    int ans4=0;
    if(a>=2){
        for(int m=0;m<a;m++){
            if(m>=d && (m-d)%2==0){
                int t=(m-d)/2;
                int dob=0;
                dob=mul(C(m,t,fact), fastpow(2,a-1-m));
                int T = C((s+m)/2-1, a-2,fact);
                T=mul(T, C(a-1, m, fact));
                dob=mul(dob, T);
                ans1=sum(ans1, dob);
            }
        }
    }
    for(int m=0;m<a+1;m++){
            if(m>=d && (m-d)%2==0){
                int t=(m-d)/2;
                int dob=0;
                dob=mul(C(m,t,fact), fastpow(2,a-m));
                int T = C((s+m)/2-1, a-1,fact);
                T=mul(T, C(a, m, fact));
                dob=mul(dob, T);
                ans2=sum(ans2, dob);
            }
    }
    ans3=ans2;
    for(int m=0;m<a+2;m++){
            if(m>=d && (m-d)%2==0){
                int t=(m-d)/2;
                int dob=0;
                dob=mul(C(m,t,fact), fastpow(2,a+1-m));
                //cout<<dob<<endl;
                int T = C((s+m)/2-1, a,fact);
                T=mul(T, C(a+1, m, fact));
                //cout<<T<<endl;
                dob=mul(dob, T);
                ans4=sum(ans4, dob);
                //cout<<ans4;
            }
    }
    //cout<<ans1<<" "<<ans2<<" "<<ans3<<" "<<ans4<<" ";
    cout<<sum(sum(sum(ans1,ans2),ans3),ans4)%mod;
}
