#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <climits>

using namespace std;

void resolve() {
	string s;
	cin >> s;
	int k;
	cin >> k;
	priority_queue<
		pair<int, int>, 
		vector<pair<int, int>>,
		greater<pair<int, int>>
	> minDigits;
	int r = min(k + 1, (int)s.size());
	for (int i = 0; i < r; i++)
		minDigits.push({ s[i] - '0', i });
	for (int i = 0; i < s.size(); i++) {
		auto minDigit = minDigits.top();
		minDigits.pop();
		cout << minDigit.first;
		if (minDigit.second == i && r < s.size()) {
			minDigits.push({ s[r] - '0', r});
			r++;
		}
	}
	cout << '\n';
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
		resolve();
	return 0;
};