#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <climits>
#include <cmath>

int main() {
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
    #endif

    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    long long t;
    std::cin >> t;

    while (t--) {
        std::string s;
        long long k;

        std::cin >> s;
        std::cin >> k;

        long long n = s.size();
        std::vector<char> result(n);

        for (long long i = 0; i < n; ++i) {
            char min_char = '9' + 1;
            long long min_index = -1;

            for (long long j = i; j < n && j <= i + k; ++j) {
                if (s[j] < min_char) {
                    min_char = s[j];
                    min_index = j;
                }
            }

            if (min_index != -1) {
                long long moves = min_index - i;

                if (moves <= k) {
                    k -= moves;

                    for (long long j = min_index; j > i; --j) {
                        std::swap(s[j], s[j - 1]);
                    }
                }
            }
        }

        std::cout << s << std::endl;
    }

    return 0;
}

/*
4
321 0
9 1 
21241127 10 
692 1
*/

/*
321
9
11122247
629
*/

// -------------------------------

/*
1
21241271 5
*/

/*
11222471
*/

// -------------------------------

/*

*/

/*

*/

// -------------------------------

/*

*/

/*

*/

// -------------------------------