 
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
namespace r = ranges;
namespace v = views;

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 533
#endif

template <typename K, typename V, template <typename> typename Comp = less> using ordered_map = tree<K, V, Comp<K>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T, template <typename> typename Comp = less> using ordered_set = ordered_map<T, null_type, Comp>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<typename T> T random(T l, T r) { return uniform_int_distribution<T>(l, r)(rng); }

constinit int mod = 1'000'000'007;

void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    string s;
    ll k;
    cin >> s >> k;
    ordered_set<int> used;
    vector<__gnu_pbds::priority_queue<int, greater<>>> q(9);
    for (int idx = 0; auto &c: s) q[c - '1'].push(idx++);
    string ans;
    while (k > 0) {
        int cnt_empty = 0;
        for (auto ci: v::iota(0, 9)) {
            if (q[ci].empty()) {
                cnt_empty++;
                continue;
            }
            auto pos = q[ci].top();
            int cnt = used.order_of_key(pos);
            used.insert(pos);
            int cost = pos - cnt;
            if (cost <= k) {
                k -= cost;
                ans += char(ci + '1');
                q[ci].pop();
                break;
            }
        }
        if (cnt_empty == q.size()) break;
    }
    vector<pair<int, char>> can;
    for (auto ci: v::iota(0, 9)) {
        while (!q[ci].empty()) {
            auto pos = q[ci].top();
            can.emplace_back(pos, char(ci + '1'));
            q[ci].pop();
        }
    }
    r::sort(can);
    for (auto i: can) {
        ans += i.second;
    }
    cout << ans << '\n';
}
/*

*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int test = 1;
#if LOCAL
    ifstream cin("../danya.in"); // ofstream cout("danya.out");
    cin >> test;
    if (test == 0) cerr << "CHANGE .IN FILE" << endl;
    for (const auto i: v::iota(1) | v::take(test)) {
        const auto divider = string(30, '=');
        cout << divider << ' ' << i << ' ' << divider << '\n';
        solve(cin, cout);
        cout << '\n';
    }
#else
    // ifstream cin(".in"); ofstream cout(".out");
    cin >> test;
    for (const auto _: v::iota(0, test)) {
        solve(cin, cout);
    }
#endif
}
