//#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
//#pragma GCC target("avx2,avx,sse,sse2,sse3,ssse3,sse4,abm,mmx")
//#pragma GCC march("native")

#include <iostream>
#include <cmath>
#include <vector> 
#include <string>
#include <algorithm>
#include <utility>

#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

template <typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> p) {
    os << "(" << p.first << ", " << p.second << ")";
    return os;
} 

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (T& x : v) os << x << " ";
    return os;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& os, map<T1,T2>& m) {
    for (auto& p : m) os << "{" << p.first << "," << p.second << "} ";
    return os;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);

    int n;
    cin >> n;
    vector<bool> a(26);
    while (n--) {
        string s;
        cin >> s;
        a[s[0] - 'a'] = true;
    }

    for (char c = 'a'; c <= 'z'; c++) {
        if ((c - 'a') % 6 == 0 && c > 'a') cout << endl;
        if (a[c - 'a']) cout << c;
        else cout << ".";

    }
}