#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <deque>

int gcd(int a, int b) {
	if (a < b) {
		std::swap(a, b);
	}

	while (b) {
		a %= b;
		std::swap(a, b);
	}

	return a;
}

int main() {

	int n;
	std::cin >> n;

	
	std::vector<std::string> res;
	std::vector<int> mas(n);
	for (int i = 0; i < n; ++i) {
		int tmp;
		std::cin >> tmp;
		mas[i] = tmp;
	}

	int st;
	int fn;

	std::cin >> st >> fn;
	int delta = fn - st;
	delta /= std::abs(delta);

	int last = 0;
	int last_pos = st;
	for (int i = st - 1 + delta; i != fn - 1 + delta; i += delta) {

		int diff = std::abs(mas[i] - mas[i - delta]);

		if (diff == 1) {
			std::cout << "Impossible";
			return 0;
		}

		if (diff == 0) {
			continue;
		}

		if (last == 0) {
			last = diff;
		}
		else{
			int nod = gcd(last, diff);
			if (nod == 1) {
				
				res.push_back(std::string( "Kaban-" + std::to_string(std::max(2, last) ) + " " +
					std::to_string( last_pos) + " " +std::to_string(i+1-delta) ));
				last_pos = i + 1 - delta;
				last = diff;
			}
			else{
				last = nod;
			}

		}


	}

	res.push_back(std::string("Kaban-" + std::to_string(std::max(2, last)) + " " +
		std::to_string(last_pos) + " " + std::to_string(fn) ));
	
	for (int i = 0; i < res.size(); i++){
		std::cout << res[i] << std::endl;
	}


	return 0;
}
