#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#define dbg(x) cerr << __LINE__ << " " << #x << " " << x << endl
#define ln cerr << __LINE__ << " fine, thanks" << endl
#else
#define dbg(x) void(0)
#define ln void(0)
#endif 

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& e : a) in >> e;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a)
{
    for (auto &e : a)
    {
        out << e << " ";
        if (typeid(T) != typeid(int) && typeid(T) != typeid(long long))
            out << "\n";
    }
    return out;
}

#define forn(i, n) for (int i = 0; (i) != (n); (i)++)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define safe(x, n) (0 <= (x) && (x) < (n))
#define withBit(mask, i) ((mask & (1LL << (i))) > 0)

void solve()
{
    int n;
    cin >> n;
    std::vector<int> a(n);
    cin >> a;
    int s,f;
    cin >> s >> f;
    s--;
    f--;
    bool sw = (f < s);
    if (sw) {
        std::swap(f, s);
    }

    std::vector<vector<int>> ans;
    while(true) {
        int cur = s;
        int g = 0;

        if (s == f) {
            break;
        }

        for(; cur != f; cur++){
            int next = std::abs(a[cur + 1] - a[cur]);
            if (next == 0){
                continue;
            }

            if (std::gcd(g, next) == 1) {
                break;
            }

            g = std::gcd(g, next);
        }

        if (s == cur) {
            std::cout <<"Impossible";
            return;
        }

        if (g == 0) {
            g = a[s];
        }
        ans.push_back({s, cur, g});
        s = cur;
    }

    if (sw) {
        std::reverse(ans.begin(), ans.end());
        for (auto p: ans) {
            std::cout << "kaban-" << p[2] <<" " << p[1] + 1 << " " << p[0] + 1<<'\n'; 
        }
    } else {
        for (auto p: ans) {
            std::cout << "kaban-" << p[2] <<" " << p[0] + 1 << " " << p[1] + 1<<'\n'; 
        }
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    double st = clock();
    #endif 

    int t = 1;
    #ifdef tests
    cin >> t;
    #endif
    while (t--)
    {
        solve();
    }

    #ifdef LOCAL
    cerr << setprecision(5) << "Succeed in " << (clock() - st) / CLOCKS_PER_SEC << " s\n";
    #endif 
}
