#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include "math.h"

using namespace std;

int gcd (int a, int b) {
    while (b) {
        a %= b;
        swap (a, b);
    }
    return a;
}

signed main() {
    
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int s, f;
    cin >> s >> f;
    bool is_reversed = false;
    if (s > f) {
        swap(s, f);
        is_reversed = true;
    }
    s--; f--;
    vector<int> numb;
    vector<int> froms;
    vector<int> tos;
    int lastNod = -1;
    int from = s;
    for (int i = s + 1; i <= f; i++) {
        int d = abs(a[i] - a[i-1]);
        if (d == 1) {
            cout << "Impossible";
            return 0;
        }
        if (d == 0) {
            continue;
        }
        if (lastNod == -1) {
            lastNod = d;
            continue;
        }
        int newNod = gcd(lastNod, d);
        if (newNod == 1) {
            numb.push_back(lastNod);
            froms.push_back(from);
            tos.push_back(i-1);
            from = i-1;
            lastNod = d;
        } else {
            lastNod = newNod;
        }
    }
    if (from != f) {
        if (lastNod == -1) {
            lastNod = 239;
        }
        numb.push_back(lastNod);
        froms.push_back(from);
        tos.push_back(f);
    }
    if (is_reversed) {
        for (int i = numb.size()-1; i >= 0; i--) {
            cout << "Kaban-" << numb[i] << " " << tos[i]+1 << " " << froms[i]+1 << "\n";
        }
    } else {
        for (int i = 0; i < numb.size(); i++) {
            cout << "Kaban-" << numb[i] << " " << froms[i]+1 << " " << tos[i]+1 << "\n";
        }
    }
    return 0;
}
