def find_ordinal_depth(s):
    if s == "{}":
        return 0
    s = s[1:-1]
    depth = 0
    balance = 0
    elements = []
    current = ""

    for char in s:
        if char == '{':
            balance += 1
            current += char
        elif char == '}':
            balance -= 1
            current += char
            if balance == 0:
                elements.append(current)
                current = ""
        elif char == ',' and balance == 0:

            continue
        else:
            current += char


    for elem in elements:
        depth = max(depth, find_ordinal_depth(elem))
    return depth + 1

ordinal_string = input().strip()
print(find_ordinal_depth(ordinal_string))