def is_wooden(matrix):
    n = len(matrix)

    for i in range(n):
        if matrix[i][i] != 0:
            return False

    for i in range(n):
        for j in range(i + 1, n):
            if matrix[i][j] <= 0:
                return False

    for i in range(n):
        for j in range(i + 1, n):
            for k in range(j + 1, n):
                if matrix[i][j] + matrix[j][k] < matrix[i][k]:
                    return False

    return True


n = int(input())

matrix = []
for _ in range(n):
    row = list(map(int, input().split()))
    matrix.append(row)

if is_wooden(matrix):
    print("Yes")
else:
    print("No")