

// &#127850;&#127850;&#127850;

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int MAXN = 2e5 + 23;
const int INF = 1e9 + 23;
const ll BIGINF = 1e17 + 23;
const int MOD = 1e9 + 7;
const int MAX_LOG = 26;

#define SINGLE_TEST
// #define ULTRA_MEGA_COOL_RAND
#define int long long
// #define PRAGM
#define all(x) x.begin(), x.end()
#define pb push_back
#define help                          \
    ios_base::sync_with_stdio(false); \
    cin.tie(nullptr);
#define me cout.tie(nullptr);
#define fileIO(x)                                     \
    freopen(((string)x + ".in").c_str(), "r", stdin); \
    freopen(((string)x + ".out").c_str(), "w", stdout);
#ifdef PRAGM
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math,O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,tune=native")
#endif

int smartGcd(int a, int b)
{
    if (a == -1)
        return b;
    if (b == -1)
        return a;
    return __gcd(a, b);
}

int interact(int x)
{
    cout << x << endl;
    cout.flush();
    int res;
    cin >> res;
    return res;
}

inline void solve()
{
    int n;
    cin >> n;

    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    a[0] = a[1];

    int f, s;
    cin >> f >> s;

    vector<int> diffs(n + 1);
    for (int i = 1; i <= n; ++i)
    {
        diffs[i] = abs(a[i] - a[i - 1]);
    }

    vector<vector<int>> ans;
    if (f <= s)
    {
        int curGcd = 0, start = f;
        for (int i = f + 1; i <= s; ++i)
        {
            if (diffs[i] == 1)
            {
                cout << "Impossible\n";
                return;
            }
            if (smartGcd(curGcd, diffs[i]) == 1)
            {
                vector<int> next = {curGcd, start, i - 1};
                ans.push_back(next);
                curGcd = diffs[i];
                start = i - 1;
            }
            else
            {
                curGcd = smartGcd(curGcd, diffs[i]);
            }
        }
        vector<int> next = {curGcd, start, s};
        ans.emplace_back(next);
    }
    else
    {
        int curGcd = 0, start = f;
        for (int i = f; i >= s + 1; --i)
        {
            if (diffs[i] == 1)
            {
                cout << "Impossible\n";
                return;
            }
            if (smartGcd(curGcd, diffs[i]) == 1)
            {
                vector<int> next = {curGcd, start, i};
                ans.push_back(next);
                curGcd = diffs[i];
                start = i;
            }
            else
            {
                curGcd = smartGcd(curGcd, diffs[i]);
            }
        }
        vector<int> next = {curGcd, start, s};
        ans.emplace_back(next);
    }

    for (const auto &vec : ans)
    {
        cout << "Kaban-" << (vec[0] ? vec[0] : 239239239LL) << ' ' << vec[1] << ' ' << vec[2] << '\n';
    }
}

signed main()
{
    // freopen("b2.txt", "r", stdin);
    help me

#ifdef ULTRA_MEGA_COOL_RAND
        srand(clock());
#endif

    int cases = 1;
#ifndef SINGLE_TEST
    cin >> cases;
#endif
    while (cases--)
        solve();
    return 0;
}
