#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>

using namespace std;
#define int long long
using ll = long long;
using vl = vector<ll>;

istream &operator>>(istream &os, vl &a) {
	for (auto &x: a) cin >> x;
	return os;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	vector<pair<int, int>> p(n);
	for (int i = 0; i < n; i++) cin >> p[i].first >> p[i].second;
	vector<int> on_x;
	for (int i = 0; i < n; i++) {
		if (p[i].second == 0) on_x.push_back(p[i].first);
	}
	if (on_x.size() <= 1) {
		cout << 0 << "\n";
		return 0;
	}
	int l = *min_element(on_x.begin(), on_x.end());
	int r = *max_element(on_x.begin(), on_x.end());
	int z = 0;
	for (int i = 0; i < n; i++) z = max(z, abs(p[i].second));
	int answer = (r - l) * z;
	if (answer & 1LL) cout << answer / 2 << "." << 5 << "\n";
	else cout << answer / 2 << "\n";
}
