#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;
using vl = vector<ll>;

istream &operator>>(istream &os, vl &a) {
    for (auto &x: a) cin >> x;
    return os;
}


map <string, int> toI = {
    {"1110111", 0},
    {"0010010", 1},
    {"1011101", 2},
    {"1011011", 3},
    {"0111010", 4},
    {"1101011", 5},
    {"1101111", 6},
    {"1010010", 7},
    {"1111111", 8},
    {"1111011", 9}
};

map <int, string> fromI = {
    {0, "1110111"},
    {1, "0010010"},
    {2, "1011101"},
    {3, "1011011"},
    {4, "0111010"},
    {5, "1101011"},
    {6, "1101111"},
    {7, "1010010"},
    {8, "1111111"},
    {9, "1111011"}
};


string temp(string a, string tm) {
    string ret = "";
    for (int i = 0; i < a.size(); i++) {
        if (tm[i] == '1')ret += a[i];
        else ret += '0';
    }
    return ret;
}

string temp1, temp2;

int check(int a, int b) {

    vector<int> v;
    for (int i = b; i >= a;i--) {
        string cur1, cur2;
        if (i / 10 == 0)
            cur1 = "0000000";
        else
            cur1 = fromI[i / 10];
        cur2 = fromI[i % 10];
        cur1 = temp(cur1, temp1);
        cur2 = temp(cur2, temp2);
        //cout << i << ' ' << cur1 << ' ' << cur2 << endl;

        int n, n1, n2;
        if ((cur1 != "0000000" && toI.find(cur1) == toI.end()) || toI.find(cur2) == toI.end()) {
            n = -2;
        }
        else {
            n1 = toI[cur1];
            if (cur1 == "0000000")
                n1 = 0;
            n2 = toI[cur2];
            n = n1 * 10 + n2;
        }
        v.push_back(n);
        //cout << i << ' ' << cur1 << ' ' << cur2 << endl;
    }
    int prev = -2;
    int mx = 0;
    int cur = 0;
    for (int g : v) {
        //cout << g << ' ';
        if (g == prev + 1) {
            cur++;
            mx = max(cur, mx);
        }
        else cur = 0;
        prev = g;
    }
    return mx;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    cin >> temp1 >> temp2;

    //cout << check(30, 40);

    int ans = 0;
    for (int l = 0; l <= 99;l++) {
        for (int r = l; r <= 99; r++) {
            ans = max(ans, check(l, r));
        }
    }
    cout << ans << endl;

}
