#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using vl = vector<ll>;

istream &operator>>(istream &os, vl &a) {
    for (auto &x: a) cin >> x;
    return os;
}

int n;
vector<pair<int, int>> p;

void skip(int n) {
    string s;
    for (int i = 0; i < n;i++) cin >> s;
}

int in() {
    string s;
    cin >> s;

    int ret = 0;
    for (int i = 0; i < s.size(); i++) {
        if ('0' <= s[i] && s[i] <= '9') {
            ret *= 10;
            ret += s[i] - '0';
        }
        else break;
    }
    return ret;
}

void parse() {
    skip(7);
    n = in();
    skip(2);
    string s;
    cin >> s;
    while (s != "work") {
        skip(2);
        int a = in();
        skip(2);
        int b = in();
        //cout << a << ' ' << b << endl;
        cin >> s;
        p.push_back({a, b});
    }
    skip(2);
}

map<int, vector<int>> mp;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    parse();

    reverse(p.begin(), p.end());
    map <int, pair<int, int>> cur;

    for (auto x : p) {
        int a = x.first;
        int b = x.second;

        if (cur.find(b) != cur.end()) {
            cur[a] = {b + 1, 1};
        }
        else {
            cur[a] = {cur[b].first, cur[b].second + 1};
        }
    }

    set<int> st;

    for (auto x : cur) {
        st.insert(x.first);
        st.insert(x.second.first);
    }

    st.insert(0);
    st.insert(n);

    vector<pair<int, int>> r(n);
    int cnt = 0;
    map <int, int> mp;
    vector<int> v;


    for (auto i : st) {
        v.push_back(i);
    }

    for (int i = 0; i < v.size(); i++) {
        if (cur.find(v[i]) != cur.end()) {
            auto pp = cur[v[i]];
            r[i] = {mp[pp.first], pp.second + p.size() + 3};
        }
        else {
            r[i] = {i + 1, (v[i + 1] - v[i]) * (p.size() + 3)};
        }
    }
    aaaaa

    int j = 0;
    cout << n;
    for (auto x : r) {
        cout << v[j++] << ' '<< v[x.first] << ' ' << x.second << '\n';
    }

}
