#include <iostream>
#include <vector>
#include <string>
using namespace std;
const vector<int> validSegments = {
        0b1110111, 
        0b0100100,
        0b1011101, 
        0b1101101,
        0b0101110,
        0b1101011,
        0b1111011,
        0b0100101, 
        0b1111111, 
        0b1101111 
};

bool check(int b, int number) {
    return (b & validSegments[number]) == b;
}

int f_m(const vector<int>& bs) {
    int max_k = 0;

    if (bs[0] == 0 && bs[1] == 0) return 0;
    for (int x = 0; x <= 99; ++x) {
        bool val = true;

        for (int i = 0; i <= max_k; ++i) {
            int tens = (x + i) / 10;
            int units = (x + i) % 10;

            if (!check(bs[0], tens) || !check(bs[1], units)) {
                val = false;
                break;
            }
        }

        if (val) {
            int cur = max_k;
            while (true) {
                int tens = (x + cur + 1) / 10;
                int units = (x + cur + 1) % 10;

                if (check(bs[0], tens) && check(bs[1], units)) {
                    cur++;
                } else {
                    break;
                }
            }
            max_k = max(max_k, cur);
        }
    }

    return max_k > 0 ? max_k : 0;
}

int main() {
    string f, s;
    cin >> f >> s;

    int b_f = stoi(f, nullptr, 2);
    int b_s = stoi(s, nullptr, 2);

    vector<int> bs = {b_f, b_s};

    int result = f_m(bs);
    cout << result << '\n';

    return 0;
}