#include <iostream>
#include <string>
using namespace std;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        int n = s.size();

        for (int i = 0; i < n && k > 0; ++i) {
            int pos = i;
            for (int j = i + 1; j < n && j - i <= k; ++j) {
                if (s[j] < s[pos]) {
                    pos = j;
                }
            }
            if (pos != i) {
                char c = s[pos];
                for (int j = pos; j > i; --j) {
                    s[j] = s[j - 1];
                }
                s[i] = c;
                k -= pos - i;
            }
        }
        cout << s << '\n';
    }
    return 0;
}