#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

void solve(long long test_cases) {
    while (test_cases--) {
        string s;
        long long k;
        cin >> s >> k;
        long long n = s.length();

        for (long long i = 0; i < n; ++i) {
            if (k <= 0) {
                break;
            }
            if (s[i] == '1') {
                continue;
            }
            long long max_j = min(i + k, n - 1);
            long long min_digit_index = i;

            for (long long j = i + 1; j <= max_j; ++j) {
                if (s[j] < s[min_digit_index]) {
                    min_digit_index = j;
                }
            }

            long long swaps_needed = min_digit_index - i;
            if (swaps_needed > 0) {
                swap(s[i], s[min_digit_index]);
                k -= swaps_needed;
            }
        }
        cout << s << "\n";
    }
}

int main() {
    long long test_cases;
    cin >> test_cases;
    solve(test_cases);
    return 0;
}
