#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

void solve(long long test_cases) {
    while (test_cases--) {
        string s;
        long long k;
        cin >> s >> k;
        long long n = s.length();

        for (long long i = 0; i < n; ++i) {
            if (k <= 0) {
                break;
            }
            if (s[i] == '1') {
                continue;
            }
            long long max_j = min(i + k, n - 1);
            int min_digit_index = i;

            for (int j = i + 1; j <= max_j; ++j) {
                if (s[j] < s[min_digit_index]) {
                    min_digit_index = j;
                }
            }
            int swaps_needed = min_digit_index - i;
            if (swaps_needed > 0) {
                int digit_to_move = s[min_digit_index];
                for (int j = min_digit_index; j > i; j--) {
                    s[j] = s[j - 1];
                }
                s[i] = digit_to_move;
                k -= swaps_needed;
            }
        }
        cout << s << "\n";
    }
}

int main() {
    long long test_cases;
    cin >> test_cases;
    solve(test_cases);
    return 0;
}
