#include <iostream>
#include <vector>
using namespace std;

void add(vector<int>& v, int i, int j) {
	v[i] |= (1 << j);
}

void solve() {
	int maskFirst = 0;
	int maskSecond = 0;
	{
		string s;
		cin >> s;
		for (int i = 0; i < s.length(); ++i) {
			if (s[i] == '1') {
				maskFirst |= (1 << i);
			}
		}
		cin >> s;
		for (int i = 0; i < s.length(); ++i) {
			if (s[i] == '1') {
				maskSecond |= (1 << i);
			}
		}
	}
	vector<int> mask(10);
	// 0	0 1 4 6 5 2
	// 1	2 5
	// 2	0 2 3 4 6
	// 3	0 2 3 5 6
	// 4	1 3 2 5
	// 5	0 1 3 5 6
	// 6 	0 1 4 6 5 3
	// 7	0 2 5
	// 8	0 1 2 3 4 5 6
	// 9	0 1 2 3 5 6
	add(mask, 0, 0);
	add(mask, 0, 1);
	add(mask, 0, 4);
	add(mask, 0, 6);
	add(mask, 0, 5);
	add(mask, 0, 2);
	add(mask, 1, 2);
	add(mask, 1, 5);
	add(mask, 2, 0);
	add(mask, 2, 2);
	add(mask, 2, 3);
	add(mask, 2, 4);
	add(mask, 2, 6);
	add(mask, 3, 0);
	add(mask, 3, 2);
	add(mask, 3, 3);
	add(mask, 3, 5);
	add(mask, 3, 6);
	add(mask, 4, 1);
	add(mask, 4, 3);
	add(mask, 4, 2);
	add(mask, 4, 5);
	add(mask, 5, 0);
	add(mask, 5, 1);
	add(mask, 5, 3);
	add(mask, 5, 5);
	add(mask, 5, 6);
	add(mask, 6, 0);
	add(mask, 6, 1);
	add(mask, 6, 4);
	add(mask, 6, 6);
	add(mask, 6, 5);
	add(mask, 6, 3);
	add(mask, 7, 0);
	add(mask, 7, 2);
	add(mask, 7, 5);
	for (int i = 0; i <= 6; ++i) {
		add(mask, 8, i);
	}
	for (int i = 0; i <= 6; ++i) {
		if (i == 4) continue;
		add(mask, 9, i);
	}

	vector<int> digit(1 << 7, -1);
	digit[0] = 10;
	for (int i = 0; i < 10; ++i) {
		digit[mask[i]] = i;
	}

	int cnt = 0;
	int maxCnt = 0;
	int prev = 100;
	for (int i = 99; i > 0; --i) {
		int firstDigit = i / 10;
		int secondDigit = i % 10;
		int maskFirstDigit = mask[firstDigit];
		int maskSecondDigit = mask[secondDigit];
		maskFirstDigit &= maskFirst;
		maskSecondDigit &= maskSecond;

		int firstShowingDigit = digit[maskFirstDigit];
		if (firstShowingDigit == 0) {
			continue;
		}
		int secondShowingDigit = digit[maskSecondDigit];
		if (firstShowingDigit == 10 && secondShowingDigit == 0) {
			continue;
		}
		if (firstShowingDigit == -1 || secondShowingDigit == -1) {
			continue;
		}
		firstShowingDigit %= 10;
		int num = firstShowingDigit * 10 + secondShowingDigit;
		if (prev == num - 1) {
			++cnt;
			maxCnt = max(maxCnt, cnt);
		}
		else {
			cnt = 0;
		}
		prev = num;
	}
	cout << maxCnt << '\n';
}

int main() {
	cin.tie(nullptr);
	ios_base::sync_with_stdio(false);
	solve();
	return 0;
}