def triangle_area(A, B, C):
    x1, y1 = A
    x2, y2 = B
    x3, y3 = C
    return abs(x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2)) / 2


def area_with_ox(third):
    return triangle_area(min_dot, max_dot, third)


n = int(input())
dots = []

for i in range(n):
    x, y = map(int, input().split())
    dots.append((x, y))

dots_on_ox = list(filter(lambda dot: dot[1] == 0, dots))

if not dots_on_ox:
    print(0)
else:
    min_dot = min(dots_on_ox)
    max_dot = max(dots_on_ox)
    areas = map(area_with_ox, dots)
    area = max(areas)
    print(area)