n = int(input().strip())  # Считываем данные
# Проверяем, что n находится в допустимом диапазоне
if not (1 <= n <= 100000):
    raise ValueError("n должно быть в пределах от 1 до 100000.")

# Чтение размеров кучек камней
a = list(map(int, input().strip().split()))  # Считываем размеры кучек и сохраняем в список
if len(a) != n:
    raise ValueError("Количество размеров кучек не соответствует количеству указанному в первой строке.")
for ai in a:
    if not (1 <= ai <= 10**9):
        raise ValueError("Размеры кучек должны быть в пределах от 1 до 10^9.")
# Вычисление общей суммы камней в кучках
stones_sum = sum(a)  # Суммируем все камни в кучках
# Определяем победителя на основе четности суммы
if stones_sum % 2 == 1: 
    print("Alice")  
else: 
    print("Dmitry")
