﻿#include <iostream>
#include <vector>

int main() {
    int tasks, roles;
    std::cin >> tasks >> roles; // Ввод количества задач и заинтересованных сторон

    std::vector<std::vector<char>> matrix(tasks, std::vector<char>(roles));

    // Ввод матрицы
    for (int i = 0; i < tasks; i++) {
        for (int j = 0; j < roles; j++) {
            std::cin >> matrix[i][j];
        }
    }

    bool isValid = true; // Флаг корректности

    // Проверка каждой строки на корректность
    for (int i = 0; i < tasks; i++) {
        int countA = 0; // Счетчик для 'A'
        // Проверяем уровень вовлечённости для каждой задачи
        for (int j = 0; j < roles; j++) {
            if (matrix[i][j] == 'A') {
                countA++;
            }
        }
        // Условия для корректности
        if (countA != 1) {
            isValid = false;
            break;
        }
    }

    // Вывод результата
    if (isValid) {
        std::cout << "YES" << std::endl;
    }
    else {
        std::cout << "NO" << std::endl;
    }

    return 0;
}
