# Ввод данных
n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]

max_area = 0

# Перебираем все тройки точек
for i in range(n):
    for j in range(i + 1, n):
        for k in range(j + 1, n):
            # Координаты трёх точек
            x1, y1 = points[i]
            x2, y2 = points[j]
            x3, y3 = points[k]
            
            # Вычисляем площадь
            area = 0.5 * abs(x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2))
            
            # Обновляем максимальную площадь
            max_area = max(max_area, area)

# Вывод результата с точностью до 10^-9
print(f"{max_area:.9f}")
