def square(x1, x2, x3, y1, y2, y3):
    return 0.5 * abs((x2 - x1)*(y3 - y1) - (x3 - x1)*(y2 - y1))


def main():
    n = int(input())
    ox_points = list()
    outside_ox_points = list()
    for _ in range(n):
        point = tuple(map(int, input().split()))
        if point[1] == 0:
            ox_points.append(point)
        else:
            outside_ox_points.append(point)

    max_square = 0
    min_ox_point = min(ox_points, key=lambda x: x[0])
    max_ox_point = max(ox_points, key=lambda x: x[0])
    best_outside_point = max(outside_ox_points, key=lambda x: abs(x[1]))
    print(max(max_square, square(x1=min_ox_point[0], x2=max_ox_point[0], x3=best_outside_point[0], y1=min_ox_point[1], y2=max_ox_point[1], y3=best_outside_point[1])))


if __name__ == "__main__":
    main()