def minimizing_exchanges(s: str, k: int) -> str:
    s = list(s)
    n = len(s)

    for i in range(n):
        if k <= 0:
            break
        max_range = min(i + k + 1, n)
        min_digit = min(s[i: max_range])
        min_digit_pos = s[i: max_range].index(min_digit)
        if min_digit_pos != 0:
            del s[i + min_digit_pos]
            s.insert(i, min_digit)
            k -= min_digit_pos
    
    return ''.join(s)


def main():
    t = int(input())
    for _ in range(t):
        s, k = input().split()
        print(minimizing_exchanges(s, int(k)))


if __name__ == "__main__":
    main()