#define GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
template <class T>
T gcd(T a, T b) {
    while (b) a = a % b, swap(a, b);
    return a;
}

const ll mod = 998244353;

int64_t poww(int64_t val, int64_t d, int64_t modd = mod) {
    int64_t ans = 1, mn = val;
    while (d) {
        if (d & 1) ans = mn * ans % modd;
        mn = mn * mn % modd, d >>= 1;
    }
    return ans;
}

vector<int> sh = {
    1 + 2 + 4 + 16 + 32 + 64,
    4+32,
    1 + 4 + 8 + 16 + 64,
    1 + 2 + 8 + 16 + 64,
    2 + 8 + 32 + 4,
    1 + 2 + 8 + 32 + 64,    
    1 + 2 + 16 + 8 + 32 + 64,
    1 + 4 + 32,
    1 + 2 + 4 + 8 + 16 + 32 + 64,
    1 + 2 + 8 + 4 + 32 + 64
};

void solve() {
    string s_fs; cin >> s_fs;
    string s_sc; cin >> s_sc;
    int fs=0, sc=0;
    // for(auto el: sh) cout << el << ' ';
    // cout << '\n';
    for(int i=0;i<7;i++){
        if(s_fs[i]=='1') fs += pow(2, i);
        if(s_sc[i]=='1') sc += pow(2, i);
    }
    vector<int> true_num(100, -2);
    for(int i=0;i<10;i++){
        for(int j=0;j<10;j++){
            if(i+j==0) continue;
            if(i==0){
                int num = -2;
                int sc_num = sh[j] & sc;
                if(find(sh.begin(), sh.end(),sc_num)==sh.end()) {
                    true_num[j] = num;
                }else{
                    true_num[j] = (find(sh.begin(), sh.end(),sc_num) - sh.begin());
                }
                continue;
            }
            int num = -2;
            int fs_num = sh[i] & fs; 
            int sc_num = sh[j] & sc;
            // cout << i*10+j << ' ' << fs_num << ' ' << sc_num << '\n';
            if(find(sh.begin(), sh.end(), fs_num)==sh.end() || find(sh.begin(), sh.end(),sc_num)==sh.end()) {
                true_num[i*10+j] = num;
            }else{
                true_num[i*10+j] = (find(sh.begin(), sh.end(),fs_num) - sh.begin())*10 + (find(sh.begin(), sh.end(),sc_num) - sh.begin());
            }
        }
    }
    reverse(true_num.begin(), true_num.end());
    true_num.pop_back();
    // for(int i=0;i<99;i++){
    //     cout << 99-i << ' ' << true_num[i] << '\n';
    // }
    int ans = 0;
    for(int i=0;i<99;i++){
        int cur = 0;
        int ind = i+1;
        while(ind<99 && true_num[ind] == true_num[ind-1]+1){
            ind++;
            cur++;
        }
        ans = max(ans, cur);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
