#define GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
template <class T>
T gcd(T a, T b) {
    while (b) a = a % b, swap(a, b);
    return a;
}

const ll mod = 998244353;

int64_t poww(int64_t val, int64_t d, int64_t modd = mod) {
    int64_t ans = 1, mn = val;
    while (d) {
        if (d & 1) ans = mn * ans % modd;
        mn = mn * mn % modd, d >>= 1;
    }
    return ans;
}

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> s(n,vector<ll>(n));
    vector<ll> d;
    for (int i=0;i<n;++i) {
        for (int j=0;j<n;++j) cin >> s[i][j];
    }
    for (int i=0;i<n;++i) {
        for (int j=i+1;j<n;++j) d.push_back(s[i][j]);
    }
    sort(d.begin(), d.end());
    ll sm = 0;
    for (auto e: d) sm += e;
    while (!d.empty()) {
        if (d.back() > sm - d.back()) {
            cout << "No\n";
            return;
        }
        d.pop_back();
    }
    cout << "Yes\n";
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
