#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...)
#endif

using ll = long long;
using db = long double;

vector <ll> DO;
ll k;

ll gcd(ll a, ll b) {
    if (min(a, b) < 1) return max(a, b);
    while (a %= b) swap(a, b);
    return b;
}

ll GC(ll l, ll r) {
    ll s = 0;
    l += k;
    r += k - 1;
    while (l <= r) {
        if (l % 2) s = gcd(s, DO[l++]);
        if (r % 2 < 1) s = gcd(s, DO[r--]);
        l/=2;
        r/=2;
    }
    return s;
}

void test_case() {
    ll n, s, f, i, e = 0, l, r, m;
    cin >> n;
    vector <ll> v(n);
    for (k = 1; k <= n; k*= 2);
    for (i = 0; i < n; i++) {
        cin >> v[i];
    }
    DO.resize(k*2);
    for (i = 1; i < n; i++) {
        DO[i-1+k] = abs(v[i] - v[i-1]);
    }
    for (i = k - 1; i > 0; i--) DO[i] = gcd(DO[i*2], DO[i*2+1]);
    cin >> s >> f;
    s--;
    f--;
    if (s > f) {
        swap(s, f);
        e = 1;
    }
    vector <vector<ll>> ans;
    while (s < f) {
        l = s;
        r = f + 1;
        while (r-l>1) {
            m = (l + r) / 2;
            if (GC(s, m) != 1) l = m;
            else r = m;
        }
        if (l == s) break;
        m = GC(s, l);
        if (m == 0) m = 1e8;
        ans.push_back({m, s, l});
        s = l;
    }
    if (ans.size() < 1 || ans.back()[2] != f) cout << "Impossible";
    else {
        if (e < 1) {
        for (vector <ll> y : ans) {
            cout << "Kaban-" << y[0] << ' ' << y[1] + 1 << ' ' << y[2] + 1 << '\n';
        }
        }
        else {
            reverse(ans.begin(), ans.end());
            for (vector <ll> y : ans) {
            cout << "Kaban-" << y[0] << ' ' << y[2] + 1 << ' ' << y[1] + 1 << '\n';
        }
        }
    }
}

signed main() {
    #ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}