#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...)
#endif

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;

#define eb emplace_back
#define int long long

int parse_to_int(string &s, int i) {
    int x = 0;
    while (i < s.length() && '0' <= s[i] && s[i] <= '9') {
        x = 10 * x + (s[i] - '0');
        i++;
        assert(x >= 0);
    }
    return x;
}

int parse_n(string &s) {
    int i = static_cast<int>(s.find('<')) + 2;
    return parse_to_int(s, i);
}

int parse_x_i(string &s) {
    int i = static_cast<int>(s.find("==")) + 3;
    return parse_to_int(s, i);
}

int parse_y_i(string &s) {
    int i = static_cast<int>(s.find(" = ")) + 3;
    return parse_to_int(s, i);
}


void solve() {
    string tmp;
    getline(cin, tmp);
    int n = parse_n(tmp);
    getline(cin, tmp);
    vector<int> x, y;
    while (tmp.find("work") == std::string::npos) {
        x.eb(parse_x_i(tmp));
        y.eb(parse_y_i(tmp));
        getline(cin, tmp);
    }
    getline(cin, tmp);
    set <ll> st, sx;
    ll ans = 1, i = -1, j;
    for (j = 0; j < (ll)x.size(); j++) sx.insert(x[j]);
    while (st.count(i) == 0) {
        st.insert(i);
        ans+=2;
        i++;
        if (i == n) break;
        if (sx.lower_bound(i) == sx.end()) {
            ans += 3 * (n-i) - 1 + (ll)x.size() * (n - i);
            i = n;
            break;
        }
        else {
            j = *sx.lower_bound(i);
            ans += 3 * (j-i) - 1 + (ll)x.size() * (j-i);
            i = j;
            for (j = 0; j < (ll)x.size(); j++) {
                if (x[j] == i) i = y[j], ans++;
                ans++;
            }
        }
        ans++;
    }
    if (i < n) cout << -1;
    else cout << ans;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
