#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...)
#endif

using ll = long long;
using db = long double;

vector <ll> fac(4e5, 1), ofac(4e5);
ll MOD = 998244353;

ll BP(ll a, ll n) {
    ll y = 1;
    while (n) {
        if (n % 2) y = y * a % MOD;
        n /= 2;
        a = a * a % MOD;
    }
    return y;
}

ll C(ll n, ll k) {
    return fac[n] * ofac[k] % MOD * ofac[n-k] % MOD;
}

void test_case() {
    ll i, a, b, c, k = 4e5, ans = 0;
    cin >> a >> b >> c;
    for (i = 2; i < k; i++) {
        fac[i] = i * fac[i-1] % MOD;
    }  
    ofac[k-1] = BP(fac[k-1], MOD-2);
    for (i = k - 2; i > -1; i--) {
        ofac[i] = ofac[i+1] *  (i+1) % MOD;
    }
    vector <ll> dp(k);
    for (i = 0; i < k; i++) {
        if (a > i && b > i) dp[a-1-i+b-1-i] = (dp[a-1-i+b-1-i] + 2 * C(a-1, i) * C(b-1, i)) % MOD;
        if (a > i && b > i + 1) dp[a-1-i+b-2-i] = (dp[a-1-i+b-2-i] + C(a-1, i) * C(b-1, i+1)) % MOD;
        if (a > i + 1 && b > i) dp[a-1-i+b-2-i] = (dp[a-1-i+b-2-i] + C(a-1, i+1) * C(b-1, i)) % MOD;
    }
    for (i = 0; i < k; i++) {
        if (dp[i] && c <= a + b + 1 && c-i>-1) {
            ans += dp[i] * C(a+b-i+1, c-i) % MOD;
        }
    }
    cout << ans % MOD;
}

signed main() {
    #ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}