#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return bin_pow(a, n - 1) * a;
    ll b = bin_pow(a, n / 2);
    return b * b;
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

struct point {
    ll x, y;
};

point get(point a, point b) {
    return {b.x - a.x, b.y - a.y};
}

ll operator*(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

void solve() {
    int n, m;cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int cnta = 0;
        for (int j = 0; j < m; j++) {
            char c;cin >> c;
            if (c == 'A') cnta++;
        }
        if (cnta != 1) {
            cout << "No";
            return;
        }
    }
    cout << "Yes";
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) solve();
}


// a - 1 b - 2 c - 3