#include <algorithm>
#include <fstream>
#include <iostream>
#include <set>
#include <utility>
#include <vector>
#include <string>
#include <cmath>
#include <numeric>
#include <sstream>

using namespace std;
#define int long long

signed main() {
#ifdef __DEFINETELY_UNDEFINED_MACROVALUE
  freopen("../../in.txt", "r", stdin);
#endif

  int n;
  vector<int> city;
  int s, f;

  cin >> n;
  city.resize(n + 1);
  for (int i = 1; i < n + 1; i++) {
    cin >> city[i];
  }
  cin >> s >> f;

  int dd = (f > s ? 1 : -1);
  int clcm = -1;
  stringstream ans;
  int prev = s;

  for (int c = s; c != f; c += dd) {
    int cur = abs(city[c + dd] - city[c]);
    int tmp_clcm = (clcm == -1 ? cur : gcd(clcm, cur));

    if (tmp_clcm == 1) {
      if (clcm == -1) {
        cout << "Impossible\n";
        return 0;
      } else {
        ans << "Kaban-" << (clcm == 0 ? 239239239 : clcm) << " " << prev << " " << c << "\n";
        clcm = cur;
        prev = c;
      }
    } else {
      clcm = tmp_clcm;
    }
  }
  if (clcm == 1) {
    cout << "Impossible\n";
    return 0;
  }
  ans << "Kaban-" << (clcm == 0 ? 239239239 : clcm) << " " << prev << " " << f << "\n";
  cout << ans.str();
}