#include <bits/stdc++.h>

#define fastIO cin.tie(nullptr); ios_base::sync_with_stdio(false);
#define rep(i, a, b) for (int i = a; i < b; i++)
#define full(vec) vec.begin(), vec.end()
#define eb emplace_back
#define pb push_back
#define fr first
#define sc second

using namespace std;

typedef int64_t ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

typedef vector <ll> vl;
typedef vector <vector <ll>> vvl;

const ld EPS = 1e-9;
const ll P = 307;
const ld PI = acos(-1);

template<class T>
istream &operator>>(istream &input, vector<T>& v) {
    for (auto &i : v) {
        input >> i;
    }
    return input;
}

template<class T>
ostream &operator<<(ostream &output, vector<T>& v) {
    for (auto &i : v) {
        output << i << ' ';
    }
    return output;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

void cok(bool t) { cout << (t ? "Yes" : "No") << '\n'; }

#define bits_s(a) bitset<64>(a).to_string()
string bits(ll m) {
    string s = bits_s(m);
    //reverse(full(s));
    return s;
}

const ll N = 2e5 + 10;
const ll MAXN = 1e16;
const ll MOD = 1e9 + 7;

struct q{
    ll a, b, c;
};

void solve() {
    ll n;
    cin >> n;
    vl a(n);
    cin >> a;
    ll f, s;
    cin >> f >> s;
    bool rev = false;
    if (f > s) {swap(f, s); rev = true;}
    f--, s--;
    bool pr = true;
    for (ll i = f; i < s; i++) {
        if (abs(a[i + 1] - a[i]) == 1) {
            pr = false;
        }
    }
    vector <q> ans;
    if (!pr) {
        cout << "Impossible\n";
        return;
    }
    ll i = f;
    while (i < s) {
        ll j = i;
        while (j < s && abs(a[j + 1] - a[j]) == 0) {
            j++;
        }
        ll t = 1000000000;
        if (j < s) {
            t = abs(a[j + 1] - a[j]);
            while (j < s && abs(a[j + 1] - a[j]) == t || abs(a[j + 1] - a[j]) == 0) {
                j++;
            }
        }
        ans.pb({t, i + 1, j + 1});
        i = j;
    }
    if (rev) {
        for (ll i = ans.size() - 1; i >= 0; i--) {
            cout << "Kaban-" << ans[i].a << ' ' << ans[i].c << ' ' << ans[i].b << '\n';
        }
    } else {
        for (auto i: ans) {
            cout << "Kaban-" << i.a << ' ' << i.b << ' ' << i.c << '\n';
        }
    }
}

signed main() {
    fastIO
    auto start_time = chrono::high_resolution_clock::now();
    ll _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    auto end_time = chrono::high_resolution_clock::now();
    //cerr << "Execution time: " << chrono::duration_cast<chrono::milliseconds>(end_time - start_time).count() << " ms" << endl;
    return 0;
}
