#include <bits/stdc++.h>
using namespace std;
using ll = long long;
 #pragma comment(linker, "/STACK:16777216")
 #pragma GCC optimize("O3,unroll-loops")


void solve() {
    string s;
    ll k;
    cin >> s >> k;
    ll n = s.size();

    for (ll i = 0; i < n && k > 0; ++i) {
        priority_queue<pair<char, int>, vector<pair<char, int>>, greater<pair<char, int>>> minHeap;

        for (ll j = i; j < n && j - i <= k; ++j) {
            minHeap.push({s[j], j});
        }

        auto [minChar, pos] = minHeap.top();

        if (pos != i) {
            s.erase(s.begin() + pos);
            s.insert(s.begin() + i, minChar);
            k -= (pos - i);
        }
    }
    cout << s << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
