#include <iostream>
#include <vector>
using namespace std;

int main() {
    int n;
    cin >> n;
    vector<vector<long>> matrix(n, vector<long>(n));
    bool tree = true;
    int cntM = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
            if ((i == j && matrix[i][j] != 0) || (i != j && matrix[i][j] == 0)) {
                tree = false;
            }
        }
    }

    if (!tree) {
        cout << "No" << endl;
        return 0;
    }

    for (int i = 0; i < n && tree; ++i) {
        for (int j = i + 1; j < n && tree; ++j) {
            for (int k = j + 1; k < n && tree; ++k) {
                long a = matrix[i][j], b = matrix[j][k], c = matrix[i][k];
                if (a + b < c || a + c < b || b + c < a) {
                    tree = false;
                }
            }
        }
    }

    cout << (tree ? "Yes" : "No") << endl;
    return 0;
}
