#include <iomanip>
#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cstdint>
#include <bitset>
#include <numeric>
#include <sstream>
#include <cassert>

using namespace std;

struct Ans {
    long long m, s, f;
};

long long gcd (long long a, long long b) {
    if (a < b) {
        swap(a, b);
    }
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

signed main() {
    ios_base::sync_with_stdio(false);

    long long n;
    cin >> n;
    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
    }
    long long s, f;
    cin >> s >> f;
    --s;
    --f;
    vector<Ans> ans;

    long long start = s;
    long long end   = f;
    long long step  = (s < f) ? 1 : -1;

    long long curS = start;
    long long commonGcd = -1;
    for (long long i = start; i != end;) {
        long long commonGcd = 0;
        for (long long j = i + step; j != end + step; j += step) {
            bool isLast = j == end;
            long long diff = llabs(a[j] - a[j - step]);
            long long curGcd = gcd(diff, commonGcd);
            if (curGcd == 1) {
                if (i == j - step) {
                    cout << "Impossible";
                    return 0;
                }
                ans.push_back({commonGcd, i, j - step});
                i = j - step;
                break;
            } else {
                commonGcd = curGcd;
            }
            if (isLast) {
                ans.push_back({curGcd, i, j});
                i = end;
                break;
            }
        }
    }

    for (auto& [num, from, to]: ans) {
        if (num == 0) {
            num = a[from];
        }
        cout << "Kaban-" << num << " " << from + 1 << " " << to + 1 << endl;
    }
    return 0;
}
