#pragma GCC optimize("O3")
#include <bits/stdc++.h>
       
       
// All the typedefs
typedef long long ll;
#define int ll 
typedef long double ld;
#define double ld
typedef unsigned long long ull;
       
       
using namespace std;
       
       
// All the regular defines
#define all(x) std::begin(x),std::end(x)
#define rall(x) std::rbegin(x),std::rend(x)
#define pii pair<int,int>
#define pdd pair<double, double>
#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define vb vector<bool>
#define vvb vector<vb>
#define vvvb vector<vvb>
#define vpii vector<pii>
#define fi first
#define se second
#define eb emplace_back
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define tri tuple<int,int,int>
#define quad tuple<int,int,int,int>
#define pent tuple<int,int,int,int,int>
       
// All the constants
const int INF = numeric_limits<int>::max()/3;
const int MOD = 998244353;
const int MAX_N = int(1e6+1);
const double PI = acosl(-1.0L);
// const bool BCHECK = false;
// const bool BSOLVE = false;
       
mt19937_64 RNG(ull(chrono::high_resolution_clock::now().time_since_epoch().count()));
       
int rint(int from, int to) {
  uniform_int_distribution<int> d(from, to);
  return d(RNG);
}

void prepare() {
  return;
}

string s;
int k;
void read() {
  cin >> s >> k;
  return;
}

string answ;
void write() {
  cout << answ << '\n';
  return;
}

int f(int x) { 
  return x&-x;
}

void solve() {
  int n = int(s.size());
  vvi ft(10, vi(n+1));
  vvi inds(10, vi(1, 0));
  for (int i = 0; i < n; i++) {
    inds[s[i]-'0'].pb(i+1);
  }

  function<void(int, int)> add = [&](int digit, int index) {
    if (index == 0) {
      return;
    }
    for (; index <= n; index += f(index)) {
      ft[digit][index]++;
    }
  };

  function<int(int, int)> get = [&](int digit, int index) {
    int result = inds[digit][index];
    for (; index > 0; index -= f(index)) {
      result += ft[digit][index];
    }
    return result;
  };

  function<int(int, int)> binsearch = [&](int digit, int upper) {
    int L = 0;  // on that is affected for sure
    int R = int(inds[digit].size());
    while (R - L > 1) {
      int mid = (R+L)/2;
      if (get(digit, mid) > upper) {
        R = mid;
      } else {
        L = mid;
      }
    }
    return L;
  };

  answ.clear();
  vi p(10, 1);
  for (int i = 1; i <= n; i++) {
    for (int d = 0; d < 10; d++) {
      if (int(inds[d].size()) <= p[d]) {
        continue;
      }
      int plsowrk = get(d, p[d]);
      int dist = plsowrk-i;
      // cout << "i, dist:  " << i << ' ' << dist << endl;
      if (k >= dist) {
        k -= dist;
        answ.pb(char('0'+d));
        p[d]++;
        for (int d1 = 0; d1 < 10; d1++) {
          if (d == d1) {
            continue;
          }
          add(d1, binsearch(d1, plsowrk));
        }
        break;
      }
    }
  }

  return;
}
       
signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int tt = 1;
  cin >> tt;
  // prepare();
  while (tt --> 0) {
    read();
    // press();
    solve();
    write();
  }
  // test();
  cout.flush();
  return 0;
}
       
       
/*

nwq1021142
ugocagudipa

0 - 123567 - 119
1 - 36 - 36
2 - 13457 - 93
3 - 13467 - 109
4 - 2346 - 46
5 - 12467 - 107
6 - 124567 - 123
7 - 136 - 37
8 - 1234567 - 127
9 - 123467 - 111

*/