#pragma GCC optimize("O3")
#include <iostream>
#include<vector>
#define int long long
using namespace std;
vector<vector<int>>spisok;
vector<int>used;
void dfs(int u){
  used[u] = true;
  for(int i = 0 ; i < spisok[u].size() ; i++){
    int v = spisok[u][i];
    if(!used[v]){
      dfs(v);
    }
  }
}
signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n;
  cin >> n;
  int a[1000][1000];
  for(int i = 0 ; i < n ; i++){
    for(int j = 0 ; j < n ; j++){
      cin >> a[i][j];
    }
  }
  int cnt = 0;
  vector<vector<int> > g(1000, vector<int>(1000, -1));
  for(int i = 0 ; i < n ; i++){
    for(int j = i + 1 ; j < n ; j++){
      for(int k = j + 1; k < n ; k++){
        if(a[i][j] + a[j][k] + a[k][i] < 2 * max(max(a[i][j], a[j][k]), a[k][i])){
          cout << "No";
          return 0;
        }
        else if(a[i][j] + a[j][k] + a[k][i] == 2 * max(max(a[i][j], a[j][k]), a[k][i])){
          //cout << i << ' ' << j << ' ' << k << endl;
          if(a[i][j] + a[j][k] == a[i][k]){
            g[i][k] = j;
            g[k][i] = j;
          }
          if(a[i][k] + a[k][j] == a[i][j]){
            g[i][j] = k;
            g[j][i] = j;
          }
          if(a[j][i] + a[i][k] == a[j][k]){
            g[j][k] = i;
            g[k][j] = j;
          }
        }
      }
    }
  }
  spisok.resize(n);
  used.resize(n);
  fill(used.begin(), used.end(), 0);
  for(int i = 0 ; i < n ; i++){
    for(int j =  0; j < n ; j++){
      if(g[i][j] == -1 && i != j){
        cnt++;
        //cout << i << ' ' << j << endl;
        spisok[i].push_back(j);
        spisok[j].push_back(i);
      }
    }
  }
  if(cnt != 2 * (n - 1)){
    cout << "No";
    return 0;
  }
  dfs(0);
  for(int i = 0 ; i < n ; i++){
    if(used[i] == 0){
      cout << "No";
      return 0;
    }
  }
  cout << "Yes";
  return 0;
}
       
       
