#include <iostream>
// #include <bits/stdc++.h>
#include <vector>
#include <map>


using namespace std;
using ll = long long;
#define len(s) int(s.size())

string generate_num(vector<int> vec) {
    string s = string(8, '0');
    for (auto &i: vec) {
        s[i - 1] = '1';
    }
    return s;
}

void gen_nums(map<int, string> &num, map<string, int> &str) {
    num[0] = generate_num({1, 2, 3, 5, 6, 7});
    num[1] = generate_num({3, 6});
    num[2] = generate_num({1, 3, 4, 5, 7});
    num[3] = generate_num({1, 3, 4, 6, 7});
    num[4] = generate_num({2, 3, 4, 6});
    num[5] = generate_num({1, 2, 4, 6, 7});
    num[6] = generate_num({1, 2, 4, 5, 6, 7});
    num[7] = generate_num({1, 3, 6});
    num[8] = generate_num({1, 2, 3, 4, 5, 6, 7});
    num[9] = generate_num({1, 2, 3, 4, 6, 7});

    for (auto &i: num) {
        str[i.second] = i.first;
    }
}

string get_real_sign(string &s, string &mask) {
    string res;
    for (int i = 0; i < len(s); i++) {
        if (mask[i] == '1') res += s[i];
        else res += '0';
    }
    return res;
}

int get_number(int t, string &mask1, string &mask2,
               map<int, string> &num, map<string, int> &str) {
    string t1 = num[t / 10];
    string t2 = num[t % 10];
    //cerr << "normal numbers is:\n";
    //cerr << t1 << "\n";
    //cerr << t2 << "\n";

    string r1 = get_real_sign(t1, mask1);
    string r2 = get_real_sign(t2, mask2);

    //cerr << "real numbers is:\n";
    //cerr << r1 << "\n";
    //cerr << r2 << "\n";

    if (str.count(r1) != 0 && str.count(r2) != 0) {
        int s1 = str[r1];
        int s2 = str[r2];
        int value = s1 * 10 + s2;
        return value;
    } else return -1;

}

int max_increasing_len(vector<int> &vec) {
    int mx = 0;
    for (int start = 0; start < len(vec); start++) {
        int ln = 0;
        for (int i = start + 1; i < len(vec); i++) {
            if (vec[i] == vec[i - 1] + 1) {
                //cerr << "place is: " << i << ' ' << vec[i - 1] << ' ' << vec[i] << '\n';
                ln++;
            } else break;
        }
        //cerr << "for start = " << start << " max len is " << ln << "\n";
        mx = max(mx, ln);
    }
    return mx;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    map<int, string> num;
    map<string, int> str;
    gen_nums(num, str);
//    for(auto &i : num) {
//        cout << i.first << " : " << i.second << "\n";
//    }
//    cout << "reverse\n";
//    for(auto &i : str) {
//        cout << i.first << " : " << i.second << "\n";
//    }

    string mask1, mask2;
    cin >> mask1 >> mask2;

    vector<int> real_nums;

    int steps = 99; //will be 99
    for (int t = steps; t >= 1; t--) {
        real_nums.push_back(get_number(t, mask1, mask2, num, str));
    }

    //cerr << "real numbers is:\n";
    for (int i = 0; i < len(real_nums); i++) {
        //cerr << 99 - i << " : " << real_nums[i] << '\n';
    }

    cout << max_increasing_len(real_nums);
    return 0;
}
