#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll sz = 100005;
const int digits = 10;

string solve(string &num, ll k) {

    string result = "";
    vector<ll> shifts(sz, 0);
    vector<ll> cnt(digits, 0);

    for (int i = 0; i < int(num.size()); i++) {
        int digit = num[i] - '0';
        cnt[digit]++;
        for (int j = digit + 1; j < digits; j++) shifts[i] += cnt[j];
    }

    vector<ll> prev_l(sz);
    vector<ll> last_digit_pos(digits, -1);

    for (ll i = int(num.size()) - 1; i >= 0; i--) {
        int digit = num[i] - '0';
        prev_l[i] = last_digit_pos[digit];
        last_digit_pos[digit] = i;
    }

    vector<ll> new_cnt(digits, 0);

    for (int i = 0; i < int(num.size()); i++) {
        bool stop = false;
        for (int j = 0; j < digits && !stop; j++) {

            if (last_digit_pos[j] < 0) continue;
            ll distance = shifts[last_digit_pos[j]] - new_cnt[j];
            if (distance > k) continue;

            for (int t = 0; t < j; t++) {
                new_cnt[t]++;
            }
            
            last_digit_pos[j] = prev_l[last_digit_pos[j]];

            k = k - distance;
            result += char(j + '0');
            stop = true;
        }
    }
    return result;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    ll t;
    cin >> t;

    string num;
    ll k;
    for (ll i = 0; i < t; ++i) {
        cin >> num >> k;
        cout << solve(num, k) << endl;
    }

    return 0;
}
