import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class E {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));

        int n = Integer.parseInt(reader.readLine());
        Point[] points = new Point[n];

        int x_b = 0;
        int y_b = 0;

        int min_x = 10000;
        int max_x = -10000;
        int min_y = 10000;
        int max_y = -10000;

        for (int i = 0; i < n; i++) {
            String line = reader.readLine();

            StringTokenizer tokenizer = new StringTokenizer(line);

            Point point = new Point(Integer.parseInt(tokenizer.nextToken()), Integer.parseInt(tokenizer.nextToken()));

            if (point.getY() == 0) {
                x_b++;
                if (point.getX() < min_x) {
                    min_x = point.getX();
                }
                if (point.getX() > max_x) {
                    max_x = point.getX();
                }
            } else {
                y_b++;
                if (point.getY() < min_y) {
                    min_y = point.getY();
                }
                if (point.getY() > max_y) {
                    max_y = point.getY();
                }
            }
        }
        if (x_b < 2){
            System.out.println(0);
        } else {
            if (y_b < 1){
                System.out.println(0);
            } else {
                System.out.println(0.5 * Math.max(Math.abs(min_y), Math.abs(max_y)) * Math.abs(max_x - min_x));
            }
        }
    }
}

class Point {
    public int x;
    public int y;

    public Point(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }
}
