#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()

#ifndef LOCAL
    #define cerr if (0) cerr
#endif

using namespace std;

template<typename T, typename V> ostream& operator<<(ostream& out, pair<T, V> p)
{
   out << p.fi << ", " << p.se;

   return out;
}

template<typename T> ostream& operator<<(ostream& out, vector<T> v)
{
    out << "[";
    for(auto e : v) out << e << ", ";
    out << "]";

    return out;
}

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int,int>;

void solve();

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    // cin >> t;
    while (t --> 0) {
        solve();
        cout << '\n';
    }

    return 0;
}

void solve()
{
    cout << fixed << setprecision(12);
    int n; cin >> n;
    vector<pii> p(n);
    
    vector<pii> osn;
    for(auto &[x, y] : p){
        cin >> x >> y;
        if(y == 0) osn.pb({x, y});
    }

    if(n < 3 || osn.size() < 2){
        cout << 0 << '\n';
        return;
    }

    sort(all(osn));
    pii a = osn[0], b = osn.back();
    p.erase(find(all(p), a)); p.erase(find(all(p), b));

    pii c = p[0];
    for(int i = 1; i < p.size(); i++){
        if(abs(c.se) < abs(p[i].se)){
            c = p[i];
        }
    }

    cout << 0.5 * abs(a.fi - b.fi) * abs(c.se) << '\n';

}