#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back

#ifndef LOCAL
    #define cerr if (0) cerr
#endif

using namespace std;

template<typename T, typename V> ostream& operator<<(ostream& out, pair<T, V> p)
{
   out << p.fi << ", " << p.se;

   return out;
}

template<typename T> ostream& operator<<(ostream& out, vector<T> v)
{
    out << "[";
    for(auto e : v) out << e << ", ";
    out << "]";

    return out;
}

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int,int>;

void solve();

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    cin >> t;
    while (t --> 0) {
        solve();
        cout << '\n';
    }

    return 0;
}

void solve()
{
    string s;
    cin >> s;
    ll k;
    cin >> k;

    string ss = "";
    vector<ll> cnt(10, 0);
    cnt[s[0] - '0']++;
    int ptr = 1;

    for(; ptr < s.size(); ptr++)
    {
        ll cost = 0;
        for(int i = 9; i > s[ptr] - '0'; i--) cost += cnt[i];

        if(cost <= k)
        {
            cnt[s[ptr] - '0']++;

            k -= cost;
            continue;
        }

        ll kk = k;
        int up = 9;
        while(kk >= cnt[up])
            kk -= cnt[up--];

        for(int i = 1; i < up; i++)
            ss += string(cnt[i], '0' + i);

        ss += string(cnt[up] - kk, '0' + up);
        ss += s[ptr];
        ss += string(kk, '0' + up);
        
        for(int i = up+1; i <= 9; i++)
            ss += string(cnt[i], '0' + i);

        ptr++;

        break;
    }

    if(ss.empty())
    {
        ss = s;
        sort(ss.begin(), ss.end());
    }
    else
        ss += s.substr(min(ptr, (int)s.size()));

    cout << ss;
}