#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back

#ifndef LOCAL
    #define cerr if (0) cerr
#endif

using namespace std;

template<typename T, typename V> ostream& operator<<(ostream& out, pair<T, V> p)
{
   out << p.fi << ", " << p.se;

   return out;
}

template<typename T> ostream& operator<<(ostream& out, vector<T> v)
{
    out << "[";
    for(auto e : v) out << e << ", ";
    out << "]";

    return out;
}

#define int long long

using ld = long double;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int,int>;

void solve();

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    // cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}

void solve()
{
    int n;
    cin >> n;
    vi a(n);
    for (auto &x : a)
        cin >> x;
    
    int s, f;
    cin >> s >> f;
    s--; f--;

    bool kek = s > f;
    if (s > f)
        swap(s, f);

    vector<array<int,3>> ans;
    int l = s;
    int cur = 0;
    for (int i = s + 1; i <= f; i++) {
        int d = abs(a[i] - a[i-1]);
        if (d == 1) {
            cout << "Impossible\n";
            return;
        }

        int prev = cur;
        if (prev == 0)
            prev = 2;
        cur = __gcd(cur, d);
        if (cur == 1) {
            ans.push_back({prev, l, i - 1});
            l = i - 1;
            cur = d;
        }
    }
    if (cur == 0)
        cur = 2;
    ans.push_back({cur, l, f});

    if (kek) {
        reverse(ans.begin(), ans.end());
        for (auto &[m, ll, rr] : ans)
            swap(rr, ll);
    }

    for (auto [m, ll, rr] : ans)
        cout << "Kaban-" << m << ' ' << ll+1 << ' ' << rr+1 << '\n';
}