#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>


using namespace std;

int get(string &s1, string &s2, vector<string> &digits, int num) {
//    cout << "NUM: " << num << '\n';
    int r1 = 0, r2 = 0;
    if (num / 10 != 0) {
        string s = digits[num / 10];
        for (int i = 0; i < 7; ++i) {
            if (s1[i] == '0' && s.find(char(i + 1 + '0')) != string::npos) {
                s.erase(s.find(char(i + 1 + '0')), 1);
            }
        }
        if (find(digits.begin(), digits.end(), s) == digits.end()) {
            return -1;
        }
        r2 = find(digits.begin(), digits.end(), s) - digits.begin();
    }
    string s = digits[num % 10];
    for (int i = 0; i < 7; ++i) {
        if (s2[i] == '0' && s.find(char(i + 1 + '0')) != string::npos) {
            s.erase(s.find(char(i + 1 + '0')), 1);
        }
    }
    if (find(digits.begin(), digits.end(), s) == digits.end()) {
        return -1;
    }
    r1 = find(digits.begin(), digits.end(), s) - digits.begin();
//    cout << "RES: " << r2 * 10 + r1 << '\n';
    return r2 * 10 + r1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    string s1, s2;
    cin >> s1 >> s2;
    vector<string> digits = {"123567", "36", "13457", "13467", "2346", "12467", "124567", "136", "1234567", "123467"};
    for (int k = 98; k >= 0; --k) {
        for (int y = k + 1; y <= 99; ++y) {
            int pr = get(s1, s2, digits, y);
            bool key = true;
            for (int q = 1; q <= k; ++q) {
                if (get(s1, s2, digits, y - q) - pr == 1) {
                    pr = get(s1, s2, digits, y - q);
                } else {
                    key = false;
                    break;
                }
            }
            if (key) {
                cout << k;
                return 0;
            }
        }
    }
    cout << 0;
    return 0;
}
