#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <stack>
#include <map>

using namespace std;

typedef long long ll;

ll mylog(ll n)
{
    ll i = 0;
    for (; (1LL << i) < n; i++);
    return i;
}


ll get(ll n, ll k)
{
    if (k <= 1)
        return n - 1;
    if ((1LL << k) >= n || k >= 60)
    {
        return mylog(n);
    }
    ll i = mylog((n + 1) / 2);
    if (i > 60 || (1LL << i) > n)
        return 1e18 + 1;
    ll right = (n+1)/2;
    return max(get(n - right, k - 1), get(right, k)) + 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    ll t;
    cin >> t;
    while (t--)
    {
        ll n, k;
        cin >> n >> k;
        cout << get(n, k + 1) << endl;
    }
}
