#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <stack>
#include <map>

using namespace std;

typedef long long ll;

int getint(string &s, int &ind)
{
    int res = 0;
    for (int i = ind; i < s.size(); i++)
    {
        if (s[i] <= '9' && s[i] >= '0')
        {
            res *= 10;
            res += s[i] - '0';
            ind++;
        }
        else
            break;
    }
    return res;
}


int main()
{
    ios_base::sync_with_stdio(0);

    string temp;

    //inputing n
    int n;
    for (int i = 0; i < 7; i++)
        cin >> temp;
    cin >> n;
    for (int i = 0; i < 3; i++)
        cin >> temp;

    //
    vector<pair<int, int>> inp;
    getline(cin, temp);
    getline(cin, temp);
    while (temp[0] == 'i')
    {
        int left, right = 0, ind = 9;
        left = getint(temp, ind);
        ind += 6;
        right = getint(temp, ind);

        inp.push_back({ left, right });
        getline(cin, temp);
    }

    map<int, pair<int, int>> res; //what, sum, ind
    res[n] = {n, 1};
    for (int i = (int)inp.size() - 1; i >= 0; i--)
    {
        int left = inp[i].first, right = inp[i].second;
        
        pair<int, int> nxt = { right, 0};
        if(res.find(right) != res.end())
            nxt = res[right];
        res[left] = { nxt.first, nxt.second + 1};
    }

    ll sum = 1, k = 0;
    map<int, int> used;
    if (res.size() > 1)
    {
        k = (res.begin())->first;
    }
    sum += (inp.size() + 3) * k;
    for (int i = k; i < n; i++)
    {
        if (used[res.lower_bound(i)->first] == 1)
        {
            cout << -1;
            return 0;
        }
        used[i] = 1;
        if (res.find(i) != res.end())
        {
            sum += res[i].second;
            sum += inp.size() + 3;
            i = res[i].first;
        } 
        else
        {
            ll j = res.upper_bound(i)->first;
            sum += (j - i) * (inp.size() + 3);
            i = j;
            i--;
        }
    }
    cout << sum + 1 << endl;
}

/*
for (int i = 0; i < 11; i++) {
if (i == 10) i = 1;
work (i);
}

for (int i = 0; i < 100; i++) {
if (i == 30) i = 11;
if (i == 20) i = 1;
if (i == 10) i = 20;
work (i);
}
*/