#include <iostream>
#include <algorithm>
#include <vector>
#include <numeric>
#include <map>

#define ll long long
#define pb push_back
#define pp pop_back
#define mp make_pair

using namespace std;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    string tr;
    ll k;
    ll n;
    for (ll i = 0; i < 7; ++i) cin >> tr;
    cin >> k;
    vector<ll> cond, pr;
    while(cin >> tr) {
        if (tr == "==") {
            ll val;
            cin >> val;
            cond.push_back(val);
        } else if (tr == "=") {
            ll val;
            cin >> val;
            pr.push_back(val);
        }
    }
    pr.push_back(0);
    cond.push_back(0);
    pr.push_back(k);
    cond.push_back(k);
    n = cond.size();
    map<ll, ll> newn;
    map<ll, ll> condpos;
    map<ll, ll> lastn;
    ll curpos = 0;
    for (ll it = 0; it < n; ++it) {
        ll now = cond[it];
        if (lastn.find(now) == lastn.end()) {
            newn[curpos] = now;
            condpos[curpos] = it;
            lastn[now] = curpos;
            curpos++;
        }
    }
    ll m = newn.size();

    map<ll, ll> dpmap;
    vector<ll> dp(n, -1);
    vector<ll> dpcnt(n, -1);
    dp[n - 1] = pr[n - 1] + 1;
    dpcnt[n - 1] = 1;
    dpmap[cond[n - 1]] = n - 1;
    for (ll i = n - 2; i >= 0; --i) {
        ll cn = cond[i];
        ll val = pr[i];
        if (dpmap.find(val) == dpmap.end()) {
            dp[i] = val + 1;
            dpcnt[i] = 1;
            if (i == n - 1 || i == n - 2) dpcnt[i] = 0;
            dpmap[cn] = i;
        } else {
            ll pos = dpmap[val];
            dpcnt[i] = 1 + dpcnt[pos];
            dp[i] = dp[pos];
            dpmap[cn] = i;
        }
    }

    vector<ll> weight(m + 1, -1);
    vector<ll> next(m + 1, -1);
    for (ll i = 0; i < m; ++i) {
        ll dppos = condpos[i];
        weight[i] = (n - 2) + 1 + 2 + dpcnt[dppos];
        ll newv = dp[dppos];
        auto it = lastn.lower_bound(newv);
        ll dist = -1;
        if (newv != k + 1) {
            dist = (*it).first - newv;
            ll newpos = (*it).second;
            next[i] = newpos;
        } else {
            weight[i] += -10000;
            next[i] = -1;
        }
        weight[i] += dist * ((n - 2) + 3);
    }

    vector<bool> used(m + 1, false);
    ll stv = lastn[0];
    ll ans = 0;
    bool hasans = false;
    while(!used[stv]) {
        used[stv] = true;
        if (newn[stv] == k) {
            hasans = true;
            break;
        }
        ans += weight[stv];
        stv = next[stv];
    }
    if (!hasans) {
        cout << -1;
    } else {
        cout << ans + 2;
    }
}
