#include <bits/stdc++.h>

#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

#define pii pair<int, int>
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

int32_t main() {
//   freopen("input.txt", "r", stdin);
//   freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> d(n, vector<int>(n));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> d[i][j];
        }
    }

    bool ok = true;

    vector<pii> c(n);
    for (int i = 0; i < n; i++) {
        c[i] = {d[0][i], i};
    }

    sort(all(c));

    for (int i = 1; i < n; i++) {
        if (!ok) {
            continue;
        }
        int to = c[i].se;
        int parent = 0;
        for (int j = 1; j < i; j++) {
            int from = c[j].se;
            if (d[from][to] == d[0][to] - d[0][from]) {
                parent = from;
            }
        }
        for (int j = 0; j < i; j++) {
            int v = c[j].se;
            ok &= (d[v][to] == d[v][parent] + d[parent][to]);
        }
    }

    cout << (ok ? "Yes" : "No");

    return 0;
}
