#include <bits/stdc++.h>
using namespace std;

template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
       os << vec[i] << ((i != vec.size() -1) ? " " : "" );
   return os;
}

template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}

typedef long long ll;
typedef long double ld;
#define endl "\n"
#define f first
#define s second
const int inf = 1e9 + 1000;
const ll mod = 4398046511104; // 2^42
const ld eps = 1e-9;
const int w = 2147483647;

void solve(){
    string s;
    cin >> s;
    if (s.size() == 2){
        cout << 0 << endl;
        return;
    }
    int count = 0;
    int cur = 0;
    for(auto a : s){
        if( a == '{'){
            cur += 1;
            if (cur == 2)
                count++;
        }
        if(a == '}'){
            cur -=1;
        }
    }
    cout << count << endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifndef LOCAL
    // freopen("INPUT.TXT", "r", stdin);
    // freopen("OUTPUT.TXT", "w", stdout);
    // #else
    // freopen("mincut.in", "r", stdin);
    // freopen("mincut.out", "w", stdout);
    #endif

    int t = 1;
    // cin >> t;
    while(t--)
        solve();

    return 0;
}