#include <bits/stdc++.h>
using namespace std;

template<typename T>
ostream& operator<<(ostream &os, const vector<T> &vec)
{
   for(size_t i = 0; i < vec.size(); i++)
       os << vec[i] << ((i != vec.size() -1) ? " " : "" );
   return os;
}

template<typename T>
istream& operator>>(istream &is, vector<T> &vec)
{
    for (T &it : vec)
        is >> it;
    return is;
}

typedef long long ll;
typedef long double ld;
#define endl "\n"
#define f first
#define s second
const int inf = 1e9 + 1000;
const ll mod = 4398046511104; // 2^42
const ld eps = 1e-9;
const int w = 2147483647;

void solve(){
    int n; cin >> n;
    vector<vector<int>> matrix(n, vector<int>(n, 0));
    for(int i =0; i < n; i++){
        for(int j = 0; j < n; j++){
            cin >> matrix[i][j];
        }
    }
    for(int i = 0; i < n; i++){
        for(int j =i+1; j < n; j++){
            int x = matrix[i][j];
            for(int k = 0; k < j - i; k++){
                int y = matrix[i][i+k];
                int z = matrix[i+k][j];
                if(y + z != x){
                    cout << "No" << endl;
                    return;
                }
            }
        }
    }
    cout << "Yes" <<endl;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifndef LOCAL
    // freopen("INPUT.TXT", "r", stdin);
    // freopen("OUTPUT.TXT", "w", stdout);
    // #else
    // freopen("mincut.in", "r", stdin);
    // freopen("mincut.out", "w", stdout);
    #endif

    int t = 1;
    // cin >> t;
    while(t--)
        solve();

    return 0;
}