﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;

        int n = s.length();
        vector<char> result(s.begin(), s.end());

        for (int i = 0; i < n && k > 0; ++i) {
            char min_char = result[i];
            int min_index = i;

            for (int j = i + 1; j < n && j <= i + k; ++j) {
                if (result[j] < min_char) {
                    min_char = result[j];
                    min_index = j;
                }
            }

            if (min_index != i) {
                int swaps_needed = min_index - i;

                for (int j = min_index; j > i; --j) {
                    swap(result[j], result[j - 1]);
                }

                k -= swaps_needed;
            }
        }

        cout << string(result.begin(), result.end()) << "\n";
    }

    return 0;
}


