#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>

using namespace std;
using ll = long long;
using ull = unsigned long long;
#define inf_int (int)(1e9 + 1)
#define inf_ll 1e18
#define mod (1e9 + 7)

struct point {
    int x, y;
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    point p1{inf_int, inf_int}, p2{-inf_int, -inf_int}, p3{0, 0};
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if (y == 0) {
            if (x < p1.x) {
                p1 = {x, y};
            }
            if (x > p2.x) {
                p2 = {x, y};
            }
        } 
        if (abs(y) > abs(p3.y)) {
            p3 = {x, y};
        }
    }
    // cout << p1.x << " " << p1.y << "\n";
    // cout << p2.x << " " << p2.y << "\n";
    
    if (p1.y != 0 || p2.y != 0) {
        cout << "0\n";
        return 0;
    }
    cout << fixed << showpoint;
    cout << setprecision(16) << 0.5 * (p2.x - p1.x) * abs(p3.y) << "\n";
}