#pragma GCC optimize("O3,Ofast")
#include <bits/stdc++.h>

using namespace std;

template<typename A, typename B> ostream& operator<<(ostream &os, const pair<A, B> &p) { return os << '(' << p.first << ", " << p.second << ')'; }
template<typename T_container, typename T = typename enable_if<!is_same<T_container, string>::value, typename T_container::value_type>::type> ostream& operator<<(ostream &os, const T_container &v) { os << '{'; string sep; for (const T &x : v) os << sep << x, sep = ", "; return os << '}'; }
void dbg_out() { cerr << endl; }
template<typename Head, typename... Tail> void dbg_out(Head H, Tail... T) { cerr << ' ' << H; dbg_out(T...); }
#ifdef LOCAL
#define dbg(...) cerr << "(" << #__VA_ARGS__ << "):", dbg_out(__VA_ARGS__)
#else
#define dbg(...)
#endif

#define ll long long
#define ld long double
#define all(a) (a).begin(), (a).end()

const int MAX_N = 1e5 + 5;
const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ld EPS = 1e-9;



void solve() {
    ll n;
    cin >> n;

    bool has_one = false;
    ll max = 0;
    ll secondmax = 0;
    for (int i = 0; i < n; ++i) {
        ll t;
        cin >> t;

        if (t == 1) {
            has_one = true;
        }
        if (t > max) {
            secondmax = max;
            max = t;
        } else if (t > secondmax && t != max) {
            secondmax = t;
        }
    }
    if (has_one) {
        cout << "Alice" << '\n';
        return;
    }

    if (max != 1) {
        cout << (((max-secondmax) % 2 == 0) ? "Dmitry": "Alice" );
    } else {
        cout << "Alice" << '\n';
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; t++) {
        // cout << "Case #" << t << ": ";
        solve();
    }
}
