// clang-format off
#include <bits/stdc++.h>
#include <cmath>
using namespace std; using ll = long long; using ull = unsigned long long; using ld = long double;
struct hash_pair {template<typename T1, typename T2>size_t operator()(const pair<T1, T2> &p) const noexcept {size_t h1 = (*this)(p.first), h2 = (*this)(p.second); return h1 == h2 ? h1 : h1 ^ h2;} template<typename T> size_t operator()(const T &v) const noexcept {return hash<T>()(v);}};
template<typename T1, typename T2> ostream &operator<<(ostream &o, const pair<T1, T2> &p) {o << '(' << p.first << ';' << p.second << ')'; return o;}
template<typename C, typename Sep> ostream &print_iterable(const C &container, Sep sep, ostream &o = cout);
template<typename C> auto operator<<(ostream &o, const C &container) -> decltype(container.begin(), o) {return print_iterable(container, ' ', o);}
template<typename C, typename Sep> ostream &print_iterable(const C &container, Sep sep, ostream &o) {for (auto &element : container) {o << element << sep;} return o;}
template<typename C> auto operator>>(istream &i, C &container) -> decltype(container.begin(), i) {for (auto &elem : container) {i >> elem;} return i;}
template<typename H, typename... T> void dbg_out(const H &head, const T&... tail) {cerr << head; if constexpr (sizeof...(tail)) {cerr << ' '; dbg_out(tail...);} else cerr << endl;}
#pragma GCC optimize("O3,Ofast")
#ifdef DEBUG
#define dbg(...) do {std::cerr << "(" << #__VA_ARGS__ << ") "; dbg_out(__VA_ARGS__);}while(false);
#else
#define dbg(...) void (0);
#endif
#define forn(i, n) for (ll i = 0; i < ll(n); ++i)
#define all(v) v.begin(), v.end()
constexpr ll MOD = 1e9 + 7;
// clang-format on

void solve() {
    ll n, k;
    cin >> n >> k;
    k = min(k, 1000LL);
    k *= 2;
    ll ans = 0;
    while (n != 1 && k > 0) {
        ++ans;
        n = (n + 1) / 2;
        --k;
    }
    cout << ans + (n - 1) << '\n';
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll all_tests = 1;
    cin >> all_tests;
    forn(test_case, all_tests) {
        dbg("SOLVING #", test_case);
        solve();
    }
}
