#include <vector>
#include <iostream>
#include <random>
#include <time.h>
#include <algorithm>
#include <iomanip>

using namespace std;

#define re return
#define rep(i, n) for (int i = 0; i < n; ++i)
#define rrep(i, n) for (int i = n - 1; i >= 0; --i)
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define fi first
#define se second
#define sz(n) (int)(n.size())
#define sq(n) ((n) * (n))

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void GO() {
#ifdef LOL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    // ios_base::sync_with_stdio(0);
    // cin.tie(0), cout.tie(0);
}

const ll INF = 1e9;
const ll mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int P = 57;
const ld EPS = 1e-8;
const ld PI = acos(-1.0);

mt19937 rnd(time(0));

///var
///


void solve(){
    int n; cin >> n;
    vector<pii> a(n);
    for (auto &i: a) cin >> i.fi >> i.se;
    int i1 = -1, i2 = -1, i3 = -1;
    rep(i, n) {
        if (a[i].se == 0) {
            if (i1 == -1 || a[i].fi < a[i1].fi) i1 = i;
            if (i2 == -1 || a[i2].fi < a[i].fi) i2 = i;
        }
        if (i3 == -1 || abs(a[i].se) > abs(a[i3].se)) i3 = i;
    }
    if (i1 == -1 || i2 == -1 || i3 == -1 || i1 == i2 || i1 == i3 || i2 == i3) {
        cout << 0; re;
    }
    cout << setprecision(20) << (a[i2].fi - a[i1].fi) * abs(a[i3].se) / 2.0;
}

signed main() {
    GO();
    int Q = 1;
    while (Q--) solve();
}