#include <vector>
#include <iostream>
#include <random>
#include <time.h>
#include <algorithm>
#include <iomanip>
#include <map>

using namespace std;

#define re return
#define rep(i, n) for (int i = 0; i < n; ++i)
#define rrep(i, n) for (int i = n - 1; i >= 0; --i)
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define fi first
#define se second
#define sz(n) (int)(n.size())
#define sq(n) ((n) * (n))

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void GO() {
#ifdef LOL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const ll INF = 1e9;
const ll mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int P = 57;
const ld EPS = 1e-8;
const ld PI = acos(-1.0);

mt19937 rnd(time(0));

///var
///

map<int, string> nums= {
    {0, "1110111"},
    {1, "0010010"},
    {2, "1011101"},
    {3, "1011011"},
    {4, "0111011"},
    {5, "1101011"},
    {6, "1101111"},
    {7, "1010010"},
    {8, "1111111"},
    {9, "1111011"}
};

bool check(string num1, string num2, int i){
    string true_num1 = nums[i/10];
    string true_num2 = nums[i%10];

    for (int i = 0; i < 8; i++){
        if (true_num2[i] == '1' && num2[i] == '0'){
            return false;
        }
    } 
    if (i >= 10){
        for (int i = 0; i < 8; i++){
            if (true_num1[i] == '1' && num1[i] == '0'){
                return false;
            }
        }
    }

    return true;
}

void solve(){
    string num1, num2;
    cin >> num1 >> num2;

    int cnt_max = 0;
    int cnt_curr = 0;

    for (int i = 99; i >= 0; i--){
        if (check(num1, num2, i)){
            cnt_curr += 1;
        } else {
            cnt_curr = 0;
        }
        if (cnt_curr > cnt_max){
            cnt_max = cnt_curr;
        }
    }

    cout << max(cnt_max-1, 0);

}

signed main() {
    GO();
    int Q = 1;
    while (Q--) solve();
}