#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<bool> was;
vector<vector<pair<int, int>>> g;
vector<int> dist;
vector<int> c;

void dfs(int v) {
  was[v] = 1;
  for (auto [u,w] : g[v]) {
    if (was[u]) continue;
    c[u] = c[v];
    dfs(u);
  }
}

void dfs2(int v, int p) {
  for (auto [u,w] : g[v]) {
    if (u == p) continue;
    dist[u] = dist[v] + w;
    dfs2(u, v);
  }
}

void solve() {
  int n;
  cin >> n;
  g.resize(n, vector<pair<int, int>>());
  vector<vector<int>> m(n, vector<int>(n));
  c.resize(n);
  was.resize(n, 0);
  vector<pair<int, int>> d;
  for (int i = 0; i < n; ++i) {
    c[i] = i;
    for (int j = 0; j < n; ++j) {
      cin >> m[i][j];
      if(i < j) d.push_back({i, j});
    }
  }
  sort(d.begin(), d.end(), [&](pair<int,int> &a, pair<int, int> &b){
    return m[a.first][a.second] < m[b.first][b.second];
  });
  for (int i = 0; i < d.size(); ++i) {
    if (c[d[i].first] == c[d[i].second]) continue;
    g[d[i].first].push_back({d[i].second, m[d[i].first][d[i].second]});
    g[d[i].second].push_back({d[i].first, m[d[i].first][d[i].second]});
    if (c[d[i].first] < c[d[i].second]) {
      c[d[i].second] = c[d[i].first];
      dfs(d[i].second);
    } else {
      c[d[i].first] = c[d[i].second];
      dfs(d[i].first);
    }
  }
  // for (int i = 0; i < n; ++i) {
  //   cout << i << ": ";
  //   for (auto [u, v] : g[i]) {
  //     cout << "(" << u << " " << v << ") ";
  //   }
  //   cout << "\n";
  // }
  for (int i = 0; i < n; ++i) {
    dist.clear();
    dist.resize(n, 0);
    dfs2(i, i);
    for (int j = 0; j < n; ++j) {
      if (dist[j] != m[i][j]) {
        cout << "NO";
        return;
      }
    }
  }
  cout << "YES";
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  solve();

  return 0;
}