﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <limits.h>

using namespace std;

#define int long long 

const vector<vector<bool>> dig =
{
	{1, 1, 1, 0, 1, 1, 1}, //0
	{0, 0, 1, 0, 1, 0, 0},//1
	{1, 0, 1, 1, 1, 0, 1},//2
	{1, 0, 1, 1, 0, 1, 1},//3
	{0, 1, 1, 1, 0, 1, 0},//4
	{1, 1, 0, 1, 0, 1, 1},//5
	{1, 1, 0, 1, 1, 1, 1},//6
	{1, 0, 1, 0, 0, 1, 0},//7
	{1, 1, 1, 1, 1, 1, 1},//8
	{1, 1, 1, 1, 0, 1, 1}//9
};

int readNum(vector<bool>& a)
{
	for (int i = 0; i < dig.size(); i++)
		if (a == dig[i])
			return i;
	return -1;
}

int read(int x, vector<bool>& a, vector<bool>& b)
{
	if (x < 10)
	{
		vector<bool> c = dig[x];
		for (int i = 0; i < 7; i++)
			c[i] = c[i] && b[i];
		return readNum(c);
	}
	vector<bool> c = dig[x / 10], d = dig[x % 10];
	for (int i = 0; i < 7; i++)
	{
		c[i] = c[i] && a[i];
		d[i] = d[i] && b[i];
	}
	int e = readNum(c), f = readNum(d);
	if (e == -1 || f == -1 || e == 0)
		return -1;
	return e * 10 + f;

}

signed main()
{
	vector<bool> a(7), b(7);
	for (int i = 0; i < 7; i++)
	{
		char x;
		cin >> x;
		a[i] = x - '0';
	}
	for (int i = 0; i < 7; i++)
	{
		char x;
		cin >> x;
		b[i] = x - '0';
	}
	vector<int> f;
	for (int i = 99; i; i--)
		f.push_back(read(i, a, b));
	int ans = 0;
	for (int i = 0; i < f.size(); i++)
	{
		if (f[i] == -1)
			continue;
		int j = i + 1;
		while (true)
		{
			if (j == f.size() || f[j] == -1 || f[j] != f[j-1] + 1)
			{
				ans = max(ans, j - i);
				break;
			}
			j++;
		}
	}
	cout << max(0ll, ans - 1) << '\n';
}