#include <bits/stdc++.h>

using namespace std;

int g[1000][1000];

vector <int> p;
vector <int> sz;
vector <int> used;
long long tec = 0;
int n;
int ans = 1;
vector <vector <int>> tree;

void dfs(int v, int p) {
    used[v] = 1;
    if (tec != g[p][v])
        ans = 0;
    if (!ans)
        return;
    for (int i : tree[v]) {
        if (!used[i]) {
            tec += g[v][i];
            dfs(i, p);
            tec -= g[v][i];
        }
    }
}
int get(int v) {
    return (p[v] == v) ? v : p[v] = get(p[v]);
}

void unite(int u, int v) {
    v = get(v);
    u = get(u);
    if (v == u) {
        return;
    }
    if (sz[v] < sz[u]) swap(u, v);
    p[u] = v;
    sz[v] += sz[u];
}

struct edge {
    int u, v, w;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    p.resize(n);
    for (int i = 0; i < n; ++i) p[i] = i;
    sz.resize(n, 1);
    vector <edge> edges;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
            if (i > j)
                edges.emplace_back(i, j, g[i][j]);
        }
    }
    sort(edges.begin(), edges.end(), [](edge a, edge b) {
        return a.w < b.w;
    });

    tree.resize(n);
    for (auto i : edges) {
        int v = i.v;
        int u = i.u;
        int w = i.w;
        if (get(u) != get(v)) {
            unite(u, v);
            tree[v].push_back(u);
            tree[u].push_back(v);
        }
    }
    for (int i = 0; i < n; ++i) {
        tec = 0;
        used.clear();
        used.resize(n);
        dfs(i, i);
    }
    if (ans) cout << "Yes";
    else cout << "No";
}