#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
// #pragma GCC target("avx2")
#include <fstream>
 
 
#define pll pair < int64_t, int64_t >
#define all(x) x.begin(), x.end()
#define sz(x) int32_t(x.size())
#define pii pair < int, int >
#define vi vector < int > 
#define ld long double
#define pb push_back
#define ull uint64_t
#define ll int64_t 
#define endl '\n'
#define S second
#define F first
#define int ll
 
 
const int inf = 1e9 + 7;
const ll INF = 1e18 + 7;
const int mod = 1e9 + 7;
const ld pi = acosl(-1);
const int MAXN = 1e6;
 
 
using namespace std;
using namespace __gnu_pbds;
 
 
template < typename T >
using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;
 
mt19937_64 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
 
int random(int l, int r) {
    if (l > r) swap(l, r);
    return l + gen() % (r - l + 1);
}
 
int sign(int x) {
    if (x < 0) return -1;
    return 1;
}
 
int binpow(int a, int n, int64_t md = -1) {
    if (md == -1) md = std::numeric_limits<int64_t>::max();
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int b = (binpow(a, n / 2)) % md;
        return (b * b) % md;
    } else {
        return (a * binpow(a, n - 1)) % md;
    }
}
 
ostream& operator << (ostream &os, __int128 x) {
    vector < int > digits;
    if (x == 0) digits.push_back(0);
    while (x) {
        digits.push_back(x % 10);
        x /= 10;
    }
    int sign = 1;
    for (auto &to: digits) {
        if (to < 0) {
            sign = -1;
            to *= -1;
        }
    }
    if (sign == -1) os << '-';
    reverse(digits.begin(), digits.end());
    for (auto to: digits) os << to;
    return os;
}

 
int32_t main() {
 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);       

    int n;
    cin >> n;
    int a[n];

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int start, finish;
    cin >> start >> finish;
    start--;
    finish--;
    int step = sign(finish - start);
    set < int > st;
    int ans = 1000'000'000;

    for (int i = min(start, finish) + 1; i <= max(start, finish); i++) {
        if (abs(a[i - 1] - a[i]) == 1) {
            cout << "Impossible";
            return 0;
        }
    }
    int prev = start;
    for (int i = start; i != finish + step; i += step) {
        if (st.count(a[i])) continue;
        if (st.empty()) {
            st.insert(a[i]);
            continue;
        } else if (sz(st) == 1) {
            ans = abs(*st.begin() - a[i]);
            st.insert(a[i]);
        } else {
            int cur = __gcd(abs(*st.begin() - a[i]), ans);
            if (cur == 1) {
                i -= step;
                cout << "Kaban-" << ans << " " << prev + 1 << " " << i + 1 << endl;
                prev = i;
                st.clear();
                st.insert(a[i]);
                ans = 1000'000'000;
            } else {
                st.insert(a[i]);
                ans = cur;
            }
        }
    }
    if (!st.empty()) {
        cout << "Kaban-" << ans << " " << prev + 1 << " " << finish + 1 << endl;
    }
    return 0;
 
}