#include<bits/stdc++.h>

using namespace std;
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
using ll = long long;

struct segtree {
    vector<int> tree;
    int sz;

    segtree(int n) {
        sz = 1;
        while (sz < n)sz *= 2;
        tree.resize(2 * sz - 1);
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)set(i, v, 2 * x + 1, lx, m);
        else set(i, v, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    void set(int i, int v) {
        set(i, v, 0, 0, sz);
    }

    int sum(int l, int r, int x, int lx, int rx) {
        if (l >= rx or lx >= r)return 0;
        if (lx >= l and rx <= r)return tree[x];
        int m = (lx + rx) / 2;
        int sum1 = sum(l, r, 2 * x + 1, lx, m);
        int sum2 = sum(l, r, 2 * x + 2, m, rx);
        return sum1 + sum2;
    }

    int sum(int l, int r) {
        return sum(l, r, 0, 0, sz);
    }
};

string s;
int k;

void solve() {
    cin >> s >> k;
    vector<vector<int>> a(10);
    int n = (int) s.size();
    vector<bool> b(n);
    for (int i = 0; i < n; i++) {
        a[s[i] - '0'].push_back(i);
    }
    segtree st(n);

//    res = ""
//    while len(s) and k:
//    for i in a:
//    if i in s:
//    h = s.index(i)
//    if h <= k:
//    k -= h
//    res += i
//    s = s[:h] + s[h + 1:]
//    break
//    print(res + s)
    while (st.sum(0, n) != n and k) {
        for (int i = 1; i < 10; i++) {
            if (a[i].size()) {
                if (a[i][0] - st.sum(0, a[i][0]+1) <= k) {
                    k -= a[i][0] - st.sum(0, a[i][0]+1);
                    b[a[i][0]] = true;
                    st.set(a[i][0], 1);
                    a[i].erase(a[i].begin());
                    cout << i;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < n; i++)if (!b[i])cout << s[i];
    cout << '\n';
}

int main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--)solve();
    return 0;
}
