#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define ull unsigned ll
#define int ll
#define ld long double
#define F first
#define S second
#ifndef OlegSanders
#define cerr if (false) cerr
#endif

using namespace std;

set<char> legal_char = {
        '0',
        '1',
        '2',
        '3',
        '4',
        '5',
        '6',
        '7',
        '8',
        '9',
        '-',
};

int next_int(string& s) {
    if (legal_char.count(s.back()) == 0) {
        s.pop_back();
        return 0;
    }
    int step = 1;
    int ans = 0;
    while (!s.empty() && legal_char.count(s.back()) != 0) {
        if (s.back() == '-') {
            ans *= -1;
        } else {
            ans += step * (s.back() - '0');
            step *= 10;
        }
        s.pop_back();
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    set<char> st;
    for (int i = 0; i <n ;i++) {
        string s;
        cin >> s;
        st.insert(s[0]);
    }

    for (char c = 'a'; c <= 'z'; c++) {
        if (st.count(c)) {
            cout << c;
        } else {
            cout << '.';
        }
        if ((c - 'a' + 1) % 6 == 0) cout << endl;
    }
}
