#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define ull unsigned ll
#define int ll
#define ld long double
#define F first
#define S second
#ifndef OlegSanders
#define cerr if (false) cerr
#endif

using namespace std;

int INF = 1e9+7;

struct Digit {
    vector<int> data;

    Digit() {
        data.resize(8);
    }

    Digit(string s) {
        for (auto to:s) {
            data.pb(to - '0');
        }
    }

    Digit(int a) {
        data = {1, 1, 1, 1, 1, 1, 1, 1};
        switch (a) {
            case 0:
                data[3] = 0;
                break;
            case 1:
                data[0] = 0;
                data[1] = 0;
                data[3] = 0;
                data[4] = 0;
                data[6] = 0;
                break;
            case 2:
                data[1] = 0;
                data[5] = 0;
                break;
            case 3:
                data[1] = 0;
                data[4] = 0;
                break;
            case 4:
                data[0] = 0;
                data[4] = 0;
                data[6] = 0;
                break;
            case 5:
                data[2] = 0;
                data[4] = 0;
                break;
            case 6:
                data[2] = 0;
                break;
            case 7:
                data[1] = 0;
                data[3] = 0;
                data[4] = 0;
                data[6] = 0;
                break;
            case 8:
                break;
            case 9:
                data[4] = 0;
                break;
        }
    }

    bool operator==(Digit a){
        return this->data == a.data;
    }


    static int to_int(Digit a) {
        for (int i = 0; i < 10; i++) {
            Digit t{i};
            if (a == t) {
                return i;
            }
        }
    }
};

Digit operator&(Digit a, Digit b) {
    Digit c;
    for (int i = 0; i < 8; i++) {
        c.data[i] = a.data[i] & b.data[i];
    }
    return c;
}

pair<Digit, Digit> get_pair(int k) {
    if (k < 10) {
        return {Digit(), Digit(k)};
    }
    return {Digit(k / 10), Digit(k % 10)};
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
//    for (int i = 0; i < 10; i++) {
//        cout << i << ' ' << Digit::to_int(Digit(i)) << endl;
//    }

    int t;
    cin >> t;
    while (t--) {
        int n,k;
        cin >> n >> k;

        vector<int> sorted;
        vector<int> rest;
        while (n > 0) {
            rest.push_back(n % 10);
            n /= 10;
        }
        reverse(rest.begin(), rest.end());

        while (k > 0 && rest.size() > 0) {
            int ans = rest[0];
            int ind = 0;
            int cost = 0;
            for (int i = 1; i <= min(k, (int)rest.size() - 1);i++) {
                if (ans > rest[i]) {
                    ans = rest[i];
                    ind = i;
                    cost = i;
                }
            }
            sorted.push_back(ans);
            rest.erase(rest.begin() + ind);
            k -= cost;
        }


        for (auto c : sorted) cout << c;
        for (auto c : rest) cout << c;
        cout << "\n";
    }
}
