#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <string>
#include <set>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vii;
typedef vector<pii> vpii;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<pll> vpll;
typedef vector<vl> vll;
template<class T> using maxpq = priority_queue<T>;
template<class T> using minpq = priority_queue<T, vector<T>, greater<T>>;
template<class T> using vec1 = vector<T>;
template<class T> using vec2 = vector<vector<T>>;
template<class T> using vec3 = vector<vector<vector<T>>>;

#define pb push_back
#define dbg(x) cout << #x << " = " << x << "\n";
#define all(x) (x).begin(), (x).end()
#define fst first
#define snd second
#define srt(s) sort(all(s))
#define f(i, m, n) for (ll i = (m); i < (n); i++)
#define rf(i, b, a) for (ll i = (b) ; i >= (a); i--)
// #define create_vec_a_ll(a, n) vector<ll> a(n, 0); for(ll i = 0; i < n; i++) cin >> a[i];
#define test(v) for (auto i : (v)) cout << i << ' '; cout << "\n";

ld r(pair<ld, ld>& a, pair<ld, ld>& b){
    ld x1 = a.fst;
    ld y1 = a.snd;

    ld x2 = b.fst;
    ld y2 = b.snd;
    return (ld)sqrt( (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1) );
}

ld get_s(pair<ld, ld>& d1, pair<ld, ld>& d2, pair<ld, ld>& d3){

    ld a = r(d1, d2);
    ld b = r(d1, d3);
    ld c = r(d2, d3);

    ld p = (a + b + c)/(ld)2;
    ld s = sqrt(p * (p - a) * (p - b) * (p - c));

    //cout << s;

    return s;
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    ll n;
    cin >> n;

    vector<pair<ld, ld>> dots(n);

    for (ll i = 0; i < n; i++){
        cin >> dots[i].first >> dots[i].second;
    }

    ld max_s = 0;

    for (ll i = 0; i < n - 2; i++){
        for (ll j = i + 1; j < n - 1; j++){
            for (ll k = j + 1; k < n; k++){
                int cnt = 0;
                if (dots[i].second == 0){
                    cnt++;
                }
                if (dots[j].second == 0){
                    cnt++;
                }
                if (dots[k].second == 0){
                    cnt++;
                }

                if (cnt == 2){
                    ld res_s = get_s(dots[i], dots[j], dots[k]);

                    if (max_s <= res_s){
                        max_s = res_s;
                    }
                }
            }
        }
    }

    cout << (ld)max_s;

    return 0;
}
