
#include <iostream>
#include <fstream>
#include <utility>
#include <vector>
#include <set>
#include <bitset>
#include <cctype>
#include <cmath>
#include <climits>
#include <algorithm>
#include <sstream>
#include <unordered_map>
#include <map>
#include <queue>
#include <unordered_set>
#include <thread>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//using namespace __gnu_pbds;
using namespace std;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


#define fori(n)for (int i = 0; i < (n); ++i)
#define fo(n)for (int i = 0; i < n; i++)
#define fori1(n)for (long long i = 1; i < n+1; i++)
#define revi1(n)for (int i = n; i >=0; i--)
#define forj(n)for (long long j = 0; j < (n); j++)
#define rep(i, n)for (long long i = 0; i < (n); i++)
#define repj(i, j, n)for (long long i = j; i < (n); i++)
#define forj1(n)for (long long j = 1; j < n+1; j++)
#define revj1(n)for (long long j = n; j >=0; j--)
#define revi(n)for (int i = n-1; i >= 0; i--)
#define ll long long
#define ull unsigned long long
#define MAXN (2147483647)
#define MINN (-2147483648)
#define ffast_io ios::sync_with_stdio(false);\
                 cout.tie(nullptr); cin.tie(nullptr)

vector<vector<ll>> multi(vector<vector<ll>> a, vector<vector<ll>> b) {
    vector<vector<ll>> res(a.size(), vector<ll>(b[0].size(), 0));
    fori(a.size()) {
        forj(b[0].size()) {
            ll temp = 0;
            rep(k, b.size())temp = (temp + (a[i][k] * b[k][j]));
            res[i][j] = temp;
        }
    }
    return res;
}

vector<vector<ll>> pow(const vector<vector<ll>> &mat, int powred) {
    if (powred == 1) return mat;
    if (powred % 2 == 1) return multi(pow(mat, powred - 1), mat);
    vector<vector<ll>> temp = pow(multi(mat, mat), powred / 2);
    return temp;
}

template<typename T>
void debug(T ttt[], std::ostream &out = std::cout) {
    for (auto it = ttt; it != ttt; ++it) out << *it << ' ';
    out << std::endl;
}

void debug(int *ttt[], std::ostream &out = std::cout) {
    for (auto it = ttt; it != ttt; ++it) debug(*it);
    out << std::endl;
}

template<typename T>
void debug(const std::vector<pair<T, T>> &ttt, std::ostream &out = std::cout) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) out << (*it).first << "  " << it->second << ' ';
    out << std::endl;
}

template<typename T>
void debug(const std::vector<T> &ttt, std::ostream &out = std::cout) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) out << *it << ' ';
    out << std::endl;
}

template<typename T>
void debug(const std::vector<vector<T>> &ttt, std::ostream &out = std::cout) {
    for (int it = 0; it != ttt.size(); ++it) debug(ttt[it]);
}

template<typename K, typename V>
void debug(const std::map<K, V> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) std::cout << it->first << ": " << it->second << ' ';
    std::cout << std::endl;
}

template<typename K, typename V>
void debug(const std::unordered_map<K, V> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) std::cout << it->first << ": " << it->second << ' ';
    std::cout << std::endl;
}

template<typename K, typename V>
void debug(const std::unordered_map<K, vector<V>> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) {
        std::cout << it->first << ": ";
        debug(it->second);
    }
    std::cout << std::endl;
}

void debug(std::deque<int> &ttt) {
    for (auto it = ttt.begin(); it != ttt.end(); ++it) {
        std::cout << *it + 1 << " ";
    }
    std::cout << std::endl;
}

template<typename T>
void debug(set<T> ttt, std::ostream &out = std::cout) {
    for (auto t: ttt) out << t << " ";
    out << endl;
}

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,tune=native")

/*
    ___        __              __   ______          __        _____ __             __          __  __
   /   | _____/ /___  ______ _/ /  / ____/___  ____/ /__     / ___// /_____ ______/ /______   / / / /__  ________
  / /| |/ ___/ __/ / / / __ `/ /  / /   / __ \/ __  / _ \    \__ \/ __/ __ `/ ___/ __/ ___/  / /_/ / _ \/ ___/ _ \
 / ___ / /__/ /_/ /_/ / /_/ / /  / /___/ /_/ / /_/ /  __/   ___/ / /_/ /_/ / /  / /_(__  )  / __  /  __/ /  /  __/
/_/  |_\___/\__/\__,_/\__,_/_/   \____/\____/\__,_/\___/   /____/\__/\__,_/_/   \__/____/  /_/ /_/\___/_/   \___/

*/
int gcd(int a, int b) {
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

struct sec {
    int l, r, mod;
public:
    sec(int i, int i1, int i2) : l(i), r(i1), mod(i2) {}
};

signed main() {
    ffast_io;
    vector<int> vec;
    int n, a;
    cin >> n;
    fori(n) {
        cin >> a;
        vec.push_back(a);
    }
    int s, f;
    cin >> s >> f;
    vector<sec> road;
    --s;
    --f;
    bool flag = false;
    if (s > f) {
        flag = true;
    }

    int i = min(s, f);
    int end = max(s, f);
    while (i + 1 <= end) {
        int index = i;
        int mod = abs(vec[index] - vec[index + 1]);

        if (mod == 0) {
            if (vec[index] == 1) {
                mod = 2 * vec[index];
            } else
                mod = vec[index];
        } else if (mod == 1) {
            cout << "Impossible";
            return 0;
        }
//        cout << "a " << vec[index] << " b " << vec[index + 1] << " mod " << mod << "\n";
        cout.flush();

        int temp = mod;
        while (index + 1 <= end) {
            temp = mod;

            mod = gcd(mod, abs(vec[index + 1] - vec[index + 2]));
//            cout << " b " << vec[index + 1] << " c " << vec[index + 2] << " ddd " << mod << "\n";
            if (mod == 1) {
                road.emplace_back(i, index + 1, temp);
                index += 1;
                break;
            } else if (mod == 0) {
                index += 1;
                mod = vec[index + 1];
            } else {
                index += 1;
            }
        }

        if (index + 1 > end) {
            if (i == min(s, f) && mod != 1) {
                road.emplace_back(i, end, temp);
            }
            break;
        }
        i = index;

    }


    if (road.empty()) {
        cout << "Impossible" << "\n";
    } else {
        fori(road.size()) {
            cout << "Kaban-" << road[i].mod << " ";
            if (flag) {
                cout << road[i].r + 1 << " " << road[i].l + 1 << "\n";
            } else {
                cout << road[i].l + 1 << " " << road[i].r + 1 << "\n";
            }
        }
    }

}

