// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define add push_back
#define f first
#define s second
#define pw(x) (1ull << (x))
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
const ll INF = (ll)1e9 + 2024;

const int N = 100;
pair <int, int> correct_masks[N];
int t[pw(7)][pw(7)], real_time[N];

int get_mask(int d) {
    static const int masks[10] = {
        0b1110111, // 0
        0b0100100, // 1
        0b1011101, // 2
        0b1101101, // 3
        0b0101110, // 4
        0b1101011, // 5
        0b1111011, // 6
        0b0100101, // 7
        0b1111111, // 8
        0b1101111, // 9
    };

    return masks[d];
}

int read_mask() {
    string s;
    cin >> s;
    reverse(all(s));
    int mask = 0;
    for (char c : s) {
        mask <<= 1; mask |= (c - '0');
    }
    return mask;
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
    memset(t, -1, sizeof(t));
    for (int i = 1; i < 10; i++) {
        correct_masks[i] = { 0, get_mask(i) };
        t[0][get_mask(i)] = i;
    }
    for (int i = 10; i < 100; i++) {
        correct_masks[i] = { get_mask(i / 10), get_mask(i % 10) };
        t[get_mask(i / 10)][get_mask(i % 10)] = i;
    }
    int left_mask = read_mask();
    int right_mask = read_mask();
    for (int i = 1; i < 100; i++) {
        int cur_left_mask = correct_masks[i].f & left_mask;
        int cur_right_mask = correct_masks[i].s & right_mask;
        real_time[i] = t[cur_left_mask][cur_right_mask];
    }
    int ans = 0;
    for (int i = 99; i > 0; i--) {
        int cur_ans = 0;
        for (int j = i, k = 0; j > 0; j--, k++) {
            if (real_time[j] == -1 || real_time[j] != real_time[i] + k) {
                break;
            }
            cur_ans++;
        }
        ans = max(ans, cur_ans - 1);
    }
    cout << ans;
}
