#include <iostream>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <queue>
#include <random>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>
#include <deque>
 
using namespace std;
 
long long mod = 1e9 + 7;
 
// random_device rd;
// mt19937 gen(rd());
 
// long long binPow(long long a, long long p)
// {
//     if (p == 0 || a == 1) {return 1;}
//     a %= mod;
//     if (p % 2 == 0) {return binPow(a * a % mod, p / 2) % mod;}
//     return (a * binPow(a, p - 1)) % mod;
// }
 
template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p);
 
template<class T>
istream& operator>> (istream& in, vector<T>& vec)
{
    for (T& i: vec) {in >> i;}
    return in;
}
 
template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}
 

pair<string, string> get_ebnutiy_indikator(pair<string, string> cur_indik, string first_indik, string second_indik) {
    string out;
    string out2;
    for (int i = 0; i < first_indik.size(); ++i) {
        if (first_indik[i] == '1') {
            out += cur_indik.first[i];
        } else {
            out += '0';
        }
    }
    for (int i = 0; i < second_indik.size(); ++i) {
        if (second_indik[i] == '1') {
            out2 += cur_indik.second[i];
        } else {
            out2 += '0';
        }
    }
    return make_pair(out, out2);
}

int find_longest_rising_sus(vector<int>& nums) {
    int mxL = 0, curL = 0;
    for (int i = 1; i < nums.size(); ++i) {
        // cout << nums[i] << endl;
        if (nums[i] == nums[i - 1] + 1) {
            curL++;
        } else {
            mxL = max(mxL, curL);
            curL = 0;
        }
    }
    return std::max(mxL, curL);

}

 
void solve()
{
    unordered_map<string, int> mp =
    {
        {"1110111", 0},
        {"0010010", 1},
        {"1011101", 2},
        {"1011011", 3},
        {"0111010", 4},
        {"1101011", 5},
        {"1101111", 6},
        {"1010010", 7},
        {"1111111", 8},
        {"1111011", 9}
    };
    unordered_map<int, string> mp_rev =
    {
        {0, "1110111"},
        {1, "0010010"},
        {2, "1011101"},
        {3, "1011011"},
        {4, "0111010"},
        {5, "1101011"},
        {6, "1101111"},
        {7, "1010010"},
        {8, "1111111"},
        {9, "1111011"}
    };
    string a, b;
    cin >> a >> b;
    int ans = 0;
    vector<int> nums;
    for (int i = 99; i >= 1; --i) {
        auto [digit1, digit2] = get_ebnutiy_indikator(
                make_pair(mp_rev[i / 10], mp_rev[i % 10]),
                a, b
            );

        // string tt = digit1;
        // string ttt = digit2;

        // cout << digit1 << "   " << digit2 << endl;
        if (mp.contains(digit1) && mp.contains(digit2)) {
            nums.push_back((int)mp[digit1] * 10 + mp[digit2]);
        }
        else {
            nums.push_back(-1);
        }
    }
    reverse(nums.begin(), nums.end());
    cout << find_longest_rising_sus(nums) << endl;

}
 

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
 
#ifdef DEBUG
    freopen("/Users/dimkamirniy/Documents/cizhka/algosi/contests/icpi 2024/input.txt", "r", stdin);
    freopen("/Users/dimkamirniy/Documents/cizhka/algosi/contests/icpi 2024/output.txt", "w", stdout);
#endif
 
    int t = 1;
    // cin >> t;
 
    for (;t > 0; --t)
    {
        solve();
    }
}