def ordinal_to_integer(ordinal_str):
    depth = 0
    max_depth = 0
    element_count = 0

    for char in ordinal_str:
        if char == '{':
            depth += 1
            element_count = 0
        elif char == '}':
            max_depth = max(max_depth, depth - 1)
            depth -= 1
        elif char == ',':
            element_count += 1

    return max(max_depth, depth)

ordinal_str = input().strip()
n = ordinal_to_integer(ordinal_str)
print(n)