#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cinttypes>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <codecvt>
#include <forward_list>
#include <initializer_list>
#include <random>
#include <scoped_allocator>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

#if __cplusplus >= 201402L
#include <shared_mutex>
#endif

int main() {
    std::string s;
    std::cin >> s;
    std::string s2;
    std::cin >> s2;
    int c1 = 0, c2 = 0;
    for (int i = 0; i < 7; i++) {
        c1 <<= 1;
        c1 += (s[i] - '0');
    }
    for (int i = 0; i < 7; i++) {
        c2 <<= 1;
        c2 += (s2[i] - '0');
    }
    std::vector<int> ord{0b1111011, 0b1111111, 0b1010010, 0b1101111, 0b1101011, 0b0111010, 0b1011011, 0b1011101, 0b0010010,
                    0b1110111};
    std::reverse(ord.begin(), ord.end());
    std::map<int, int> back;
    for (int i = 0; i < 10; i++) {
        back[ord[i]] = i;
    }
    back[0]=0;
    int last = -1000;
    int k = 0;
    int curk = 0;
    for (int i = 99; i >= 1; i--) {
        int d1 = (ord[i / 10]) & c1;
        int d2 = (ord[i % 10]) & c2;
        if (find(ord.begin(), ord.end(), d1) != ord.end()) {
            if (std::find(ord.begin(), ord.end(), d2) != ord.end()) {
                int n = back[d1] * 10 + back[d2];
                if(i/10 == 0){
                    n = back[d2];
                }
                if (n == last + 1) {
                    curk++;
                    k = std::max(k, curk);
                    last = n;
                } else {
                    curk = 0;
                    last = n;
                }
            } else{
                last =-1000;
                curk = 0;
            }
        } else{
            last = -1000;
            curk = 0;
        }
    }
    std::cout << k << std::endl;
    return 0;
}
