#include <iostream>
#include <vector>

using namespace std;

class point {
public:
  int x, y;
};

bool cmp(point A, point B) { return A.x <= B.x; }

void print(vector<point> vec) {
  for (int i = 0; i < vec.size(); ++i)
    cout << vec[i].x << " " << vec[i].y << endl;
}
void print(point a) { cout << a.x << " " << a.y << endl; }

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);

  int n;
  cin >> n;
  if (n < 3) {
    int k;
    for (int i = 0; i < n; ++i)
      cin >> k;
    cout << 0;
    return 0;
  }
  vector<point> vec(n);
  for (int i = 0; i < vec.size(); ++i) {
    cin >> vec[i].x >> vec[i].y;
  }
  point A = vec[0];
  point B = vec[0];
  point C = vec[0];
  for (int i = 0; i < vec.size(); ++i) {
    if (vec[i].y == 0 && vec[i].x < A.x)
      A = vec[i];
    if (abs(vec[i].y) > abs(B.y))
      B = vec[i];
    if (vec[i].y == 0 && vec[i].x > C.x)
      C = vec[i];
  }

  if (B.y == 0) {
    cout << 0;
    return 0;
  }
  if (C.x == A.x) {
    cout << 0;
    return 0;
  }

  cout << double(abs(C.x - A.x) * abs(B.y) / 2.0) << endl;
  return 0;
}
