import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;


public class Cards {
    static void changePositions(char[] chars, int start, int end) {
        for (int i = start; i > end; i--) {
            chars[i] = chars[i - 1];
        }
    }
    public static void main(String[] args) throws IOException {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        int t = Integer.parseInt(bufferedReader.readLine());
        StringBuilder ans = new StringBuilder();
        for (int i = 0; i < t; i++) {
            String[] line = bufferedReader.readLine().split(" ");
            char[] chars = line[0].toCharArray();
            int n = chars.length;
            long k = Long.parseLong(line[1]);
            for (int j = 0; j < n; j++) {
                if (k <= 0)
                    break;
                int first = j;
                long last = j + k;
                if (n - 1 < last)
                    last = n - 1;
                for (int lb = j + 1; lb < last + 1; lb++) {
                    if (chars[lb] < chars[first])
                        first = lb;
                }
                long moved = first - j;
                if (k >= moved) {
                    char currentMin = chars[first];
                    changePositions(chars, first, j);
                    chars[j] = currentMin;
                    k -= moved;
                }
            }
            String parsed = new String(chars);
            ans.append(parsed).append("\n");
        }
        System.out.print(ans);
    }
}
