#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <climits>
std::string f_min(std::string s, long long k) {
    int n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        char min_char = s[i];
        int min_pos = i;
        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < min_char) {
                min_char = s[j];
                min_pos = j;
            }
        }
        for (int j = min_pos; j > i; --j) {
            std::swap(s[j], s[j-1]);
        }
        k -= (min_pos - i);
    }
    return s;
}
int main() {
    int t;
    std::cin >> t;
    std::vector<std::pair<std::string, long long>> inputs(t);
    for (int i = 0; i < t; ++i) {
        std::cin >> inputs[i].first >> inputs[i].second;
    }
    for (int i = 0; i < t; ++i) {
        std::cout << f_min(inputs[i].first, inputs[i].second) << std::endl;
    }
    return 0;
}