#include <climits>
#include <cstdint>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using point = pair<int64_t, int64_t>;

int main() {
  int64_t n;
  cin >> n;
  vector<point> arr(n);
  for (size_t i = 0; i < arr.size(); ++i) {
    cin >> arr[i].first >> arr[i].second;
  }
  vector<point> ans(3);
  sort(arr.begin(), arr.end());
  int64_t max = LLONG_MIN;
  for (size_t i = 0, j = n - 1; i < arr.size(); ++i, --j) {
    if (arr[j].second == 0 ) {
      ans[0] = arr[j];
    }
    if (arr[i].second == 0) {
      ans[1] = arr[i];
    }
    if (max < abs(arr[i].second)) {
      max = abs(arr[i].second);
      ans[2] = arr[i]; 
    }
  }
  if (ans[0].second == 0 && ans[1].second == 0 && ans[0] != ans[1]) {
    int64_t answer = (ans[1].first - ans[0].first) * abs(ans[2].second);
    if (answer % 2 == 1) {
      cout << fixed << (answer / 2.0) << endl;
    } else {
      cout << answer / 2 << endl;
    }
  } else {
    cout << 0 << endl;
  }
  return 0;
}
