#include <iostream>
#include <vector>

using namespace std;

// Функция для определения победителя
string determine_winner(int n, const vector<int>& piles) {
    int nim_sum = 0;

    // Вычисляем nim-sum
    for (int stones : piles) {
        nim_sum ^= stones;
    }

    // Если nim_sum равен 0, выигрывает Дмитрий, иначе - Алиса
    return (nim_sum == 0) ? "Dmitry" : "Alice";
}

int main() {
    int n;
    cin >> n; // Читаем количество кучек

    vector<int> piles(n);

    // Чтение размеров кучек
    for (int i = 0; i < n; ++i) {
        cin >> piles[i];
    }

    // Вызываем функцию для определения победителя
    string result = determine_winner(n, piles);

    // Выводим результат
    cout << result << endl;

    return 0;
}