from collections import deque


def minimize_number(s, k):
    s = list(s)
    n = len(s)

    i = 0
    while i < n and k > 0:

        min_pos = i
        for j in range(i + 1, min(n, i + k + 1)):
            if s[j] < s[min_pos]:
                min_pos = j


        if min_pos != i:
            s.insert(i, s.pop(min_pos))
            k -= (min_pos - i)

        i += 1

    return ''.join(s)

t = int(input())

results = []
for _ in range(t):
    s, k = input().split()
    k = int(k)

    results.append(minimize_number(s, k))

for result in results:
    print(result)
